#include<iostream>
#include<vector>
#include<cstring>
#include<algorithm>
#include<string>
#include<cmath>
using namespace std;

#define big int

//helpers
vector<string> split(string str, string pattern){

	vector<string> vec;
	string current = "";
	for(int i = 0 ; i < (int)str.size() ; i++){
		if(str.substr(i, pattern.size()) == pattern){
			i+=pattern.size()-1;
			vec.push_back(current);
			current = "";
		}else
			current += str[i];
	}
	if(current.size() > 0)
		vec.push_back(current);
	return vec;
}

big s2i(string s){
	big r = 0;
	for(int i = 0 ; i < (int)s.size() ; i++)
		r = r*10+(s[i]-'0');
	return r;
}

///

vector<pair<big, big> > vec;

void addTerm(string str, int sign){
	vector<string> s = (find(str.begin(), str.end(), 'X') != str.end()) ? split(str, "X") :  vector<string>(1, str);
	big coeff = s.size() > 0 && s[0].size() > 0 ? s2i(s[0]) : 1;
	coeff *= sign;

	big power = s.size() < 2 || s[1].size() == 0 ? (find(str.begin(), str.end(), 'X') != str.end() ? 1 : 0 ) : s2i(s[1].substr(1));
	vec.push_back(make_pair(coeff, power));
}

//split a string representing a polynomial (ex. -2n^3+3n^2+n-4) to an array of coefficients and powers
void getPolynomialTerms(string str){

	//split on plus
	vector<string> ND = (find(str.begin(), str.end(), '+') != str.end()) ? split(str, "+") : vector<string>(1 ,str);

	for(int i = 0 ; i < (int)ND.size() ; i++){
		//split on minus
		vector<string> terms = find(ND[i].begin(), ND[i].end(), '-') != ND[i].end() ? split(ND[i], "-"): vector<string>(1, ND[i]);
		if(terms[0].length() > 0){	//first term is positive
			addTerm(terms[0], 1);
		}
		for(int j = 1 ; j < (int)terms.size() ; j++)
			addTerm(terms[j], -1);
	}
}

int square(int x){
	return x*x;
}
int fastPow(int b,int p) {
	if (p == 0)
		return 1;
	else if (p%2 == 0)
		return square(fastPow(b,p/2));
	else
		return b * fastPow(b,p-1);
}

//get the value of f(x)
int evaluatePolynomial(big x){
	big r = 0;
	for(int i = 0 ; i < (int)vec.size() ; i++){
		big xx = vec[i].first*fastPow(x, vec[i].second);
		r = r+xx;
	}
	return r;
}

int main(){

	freopen("calc.in", "rt", stdin);
	//freopen("calc.out", "wt", stdout);

	int tt; cin >> tt;
	for(int t = 1 ; t <= tt ; t++){
		int X; string str;
		cin >> X >> str;

		vec.clear();
		getPolynomialTerms(str);
//		for(int i = 0 ; i < (int)vec.size() ; i++)
//			cout << vec[i].first << " " << vec[i].second << endl;

		cout << "Case #" << t << ": " << evaluatePolynomial(X) << endl;
	}
}
