import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Vector;


public class hamza {

	class pair{
		public long first, second;
		public pair(long x, long y){
			first = x;
			second = y;
		}
	};

	Vector<pair> vec = new Vector<pair>();

	void addTerm(String str, int sign){
		String[] s;
		if(str.indexOf('X') >= 0)
			s = str.split("X");
		else{
			s = new String[]{str};
		}
		long coeff = s.length > 0 && s[0].length() > 0 ? Long.parseLong(s[0]) : 1;
		coeff *= sign;

		long power = s.length < 2 || s[1].length() == 0 ? (str.indexOf('X') >= 0 ? 1 : 0 ) : Long.parseLong(s[1].substring(1));
		vec.add(new pair(coeff, power));
	}

	//split a String representing a polynomial (ex. -2n^3+3n^2+n-4) to an array of coefficients and powers
	void getPolynomialTerms(String str){

		//split on plus
		String[] ND;
		if(str.indexOf('+') >= 0)
			ND = str.split("\\+");
		else
			ND = new String[]{str};

		for(int i = 0 ; i < (int)ND.length ; i++){
			//split on minus
			String[] terms;
			if(str.indexOf('-') >= 0)
				terms = ND[i].split("-");
			else
				terms = new String[]{ND[i]};
			if(terms[0].length() > 0){	//first term is positive
				addTerm(terms[0], 1);
			}
			for(int j = 1 ; j < terms.length ; j++)
				addTerm(terms[j], -1);
		}
	}

	long square(long x){
		return x*x;
	}
	long fastPow(long b,long p) {
		if (p == 0)
			return 1;
		else if (p%2 == 0)
			return square(fastPow(b,p/2));
		else
			return b * fastPow(b,p-1);
	}

//	get the value of f(x)
	long evaluatePolynomial(long x){
		long r = 0;
		for(int i = 0 ; i < (int)vec.size() ; i++){
			long xx = vec.get(i).first*fastPow(x, vec.get(i).second);
			r = r+xx;
		}
		return r;
	}

	public void solve() throws Exception{
		Scanner sc = new Scanner(new File("calc.in"));
		PrintWriter pw = new PrintWriter(new File("calc.out"));
		int tt = sc.nextInt();
		for(int t = 1 ; t <= tt ; t++){
			int X; String str;
			X = sc.nextInt();
			str = sc.next();

			vec.clear();
			getPolynomialTerms(str);
			pw.println("Case #" + t+ ": " + evaluatePolynomial(X));
		}

		pw.close();
	}

	public static void main(String[] args) throws Exception{
		new hamza().solve();
	}
}
