#include<iostream>
#include<queue>
using namespace std;

const int SIZE = 110;
int R, C, grid[SIZE][SIZE], tr, tc;
bool vis[SIZE][SIZE];
int dir[4][2] = {{-1,0},{1, 0}, {0,-1}, {0, 1}};

bool valid(int r, int c){
	return r >= 0 && r < R && c >= 0 && c < C;
}

bool onBoundry(int r, int c){
	return r == 0 || r == R-1 || c == 0 || c == C-1;
}

int main(){

	freopen("crank.in", "rt", stdin);
	freopen("crank.out", "wt", stdout);

	int tt; cin >> tt;
	for(int t = 1 ; t <= tt ; t++){
		cin >> R >> C >> tr >> tc;

		assert(1 <= R && R <= 10);
		assert(1 <= C && C <= 10);
		assert(1 <= tr && tr <= R);
		assert(1 <= tc && tc <= C);

		tr--; tc--;
		for(int i = 0 ; i < R ; i++)
			for(int j = 0 ; j < C ; j++){
				cin >> grid[i][j];
				assert(1 <= grid[i][j] && grid[i][j] <= 1000);
			}

		memset(vis, 0, sizeof vis);
		int res = 0;
		queue<pair<int, int> > q;
		q.push(make_pair(tr, tc));
		vis[tr][tc] = true;

		while(!q.empty()){
			pair<int, int> p = q.front(); q.pop();
			res += onBoundry(p.first, p.second);
			for(int i = 0 ; i < 4 ; i++){
				pair<int, int> pp = p;
				pp.first += dir[i][0];
				pp.second += dir[i][1];
				if(!valid(pp.first, pp.second) || vis[pp.first][pp.second])
					continue;
				if(grid[pp.first][pp.second] < grid[p.first][p.second])
					continue;
				vis[pp.first][pp.second] = true;
				q.push(pp);
			}
		}

		cout << "Case #" << t << ": " << res << endl;
	}

	return 0;
}
