import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;
import java.util.Vector;

public class se7s
{
	public static int[] xdir = new int[]{ -1, 0, 0, 1};
	public static int[] ydir = new int[]{ 0, -1, 1, 0};

	public int[] dijkastra(Vector<Vector<Integer>> graph,int source)
	{
		boolean[] visited = new boolean[graph.size()];
		Arrays.fill(visited, false);

		int[] distance = new int[graph.size()];
		Arrays.fill(distance, Integer.MAX_VALUE/2);

		Vector<Integer> q = new Vector<Integer>();
		q.add(source);
		distance[source] = 0;

		while( !q.isEmpty() )
		{
			int node = q.firstElement();
			q.removeElementAt(0);

			if( visited[node] )
				continue;

			visited[node] = true;

			for(int i : graph.get(node))
			{
				distance[i] = 1;
				q.add(i);
			}
		}

		return distance;
	}

	public static void main(String[] args) throws Exception
	{
		//Scanner scan = new Scanner(new BufferedInputStream(System.in));
		Scanner scan = new Scanner(new File("crank.in"));
		PrintStream out = new PrintStream("crank.out");
		int test = scan.nextInt();

		for( int tt = 1 ; tt <= test ; tt++ )
		{
			int r = scan.nextInt();
			int c = scan.nextInt();
			int x = scan.nextInt();
			int y = scan.nextInt();

			assert r >= 1 && r <= 10 : "wrong value for r = " + r +", (1 <= r <= 10)";
			assert c >= 1 && c <= 10 : "wrong value for c = " + c +", (1 <= c <= 10)";
			assert x >= 1 && x <= r : "wrong value for x = " + x +", (1 <= x <= " + r + ")";
			assert y >= 1 && y <= c : "wrong value for y = " + y +", (1 <= y <= " + c + ")";

			Vector<Vector<Integer>> g = new Vector<Vector<Integer>>();
			int[][] map = new int[r][c];

			g.setSize(r*c);

			for( int i = 0 ; i < r ; i++ )
				for( int j = 0 ; j < c ; j++ )
				{
					map[i][j] = scan.nextInt();
					assert map[i][j] >= 1 && map[i][j] <= 1000 : "wrong value for building height = " + map[i][j] +", (1 <= building height <= 1000)";
				}

			for( int i = 0 ; i < r ; i++ )
			{
				for( int j = 0 ; j < c ; j++ )
				{
					int from = i*c+j;

					g.set(from, new Vector<Integer>());

					for( int d = 0 ; d < 4 ; d++ )
					{
						int ni = i + xdir[d];
						int nj = j + ydir[d];

						if( ni < 0 || ni >= r || nj < 0 || nj >= c )
							continue;

						int to = ni*c+nj;

						if( map[i][j] <= map[ni][nj] )
							g.get(from).add(to);
					}
				}
			}

			se7s crank = new se7s();

			int source = (x-1)*c+y-1;
			int[] d = crank.dijkastra(g, source);
			int result = 0;

			for( int i = 0 ; i < r ; i++ )
				for( int j = 0 ; j < c ; j++ )
					result += (i == 0 || i == r-1 || j == 0 || j == c-1) && d[i*c+j] < 2 ? 1 : 0;

			out.printf("Case #%d: %d\n", tt, result);
		}
	}
}
