/*
 TASK:
 LANG: C++
 */
#include <algorithm>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <cmath>
#include <iterator>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <list>
#include <bitset>
#include <cstring>
#include <climits>
#include <deque>
#include <utility>
#include <complex>
#include <numeric>
#include <functional>
#include <stack>
#include <iomanip>
#include <ctime>
#include <valarray>
//#include "vc.h"
#ifdef _MSC_VER
#include <hash_set>
#include <hash_map>
using namespace stdext;
#else
#if __GNUC__ > 2
#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;
#else
#include <hash_set>
#include <hash_map>
#endif
#endif

template<class key>
struct hashtemp {

	enum {
		bucket_size = 4, min_buckets = 8
	};
	virtual size_t operator()(const key &p) const=0;

};

using namespace std;
#ifndef M_PI
const long double M_PI=acos((long double)-1);
#endif
#define rep(i,n) for(int  i=0;i<(int)(n);++i)
long double ZERO = 0;
const long double INF = 1 / ZERO, EPSILON = 1e-12;
#define all(c) (c).begin(),(c).end()
#define rep2(i,a,b) for(int i=(a);i<=((int)b);++i)
#define foreach(it,c) for(__typeof((c).begin()) it=(c).begin();it!=(c).end();++it)

#define sz(v) ((int)((v).size()))
#define let(x,y) __typeof(y) x(y)

#define rrep(i,n) for(int  i=((int)n)-1;i>=0;--i)
#define rall(c) (c).rbegin(),(c).rend()
#define rrep2(i,a,b) for(int i=(a);i>=((int)b);--i)
#define rforeach(it,c) for(__typeof((c).rbegin()) it=(c).rbegin();it!=(c).rend();++it)
#define rep2d(i, j, v) rep(i, sz(v)) rep(j, sz(v[i]))
#define foreach2d(i, j, v) foreach(i,v) foreach(j,*i)

void Factorize(long long m, vector<long long>& p, vector<long long>& q) {//m=p1^q1*p2^q2..,np=size of p,q (1-indexed)
	long long a = m;
	long long i = 2;
	while ((unsigned long long) i * i <= (unsigned long long) a) {
		if (a % i == 0) {
			p.push_back(i);
			q.push_back(1);
			a /= i;
			while (a % i == 0) {
				q.back()++;
				a /= i;
			}
		}
		i += i == 2 ? 1 : 2;
	}
	if (a > 1) {
		p.push_back(a);
		q.push_back(1);
	}
}
long long FastPower(long long a, long long n){
	if (n==0) return 1;
	long long x=FastPower(a,n/2);
	if (n%2==0) return x*x;
	return x*x*a;
}
int main() {
	std::ios_base::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("division.in", "rt", stdin);
	freopen("division.out", "wt", stdout);
#endif
	int t,tt=1;
	cin >> t;
	clock_t before=clock();
	while (t--) {
		int n, m;
		cin >> n >> m;
		map<int, int> num, den;
		bool zero=0;
		while (n--) {
			int x;
			cin >> x;
			zero|=x==0;
			vector<long long> p, q;
			Factorize(x, p, q);
			rep(i,sz(p))
				num[p[i]] += q[i];
		}

		while (m--) {
			int x;
			cin >> x;
			vector<long long> p, q;

			Factorize(x, p, q);
			rep(i,sz(p))
				den[p[i]] += q[i];
		}
		foreach(x,num)
		{
			let(y,den.find(x->first));
			if(y!=den.end())
			{
				int z=min(x->second,y->second);
				x->second-=z;
				y->second-=z;
			}
		}
		cout<<"Case #"<<tt++<<": ";
		if(zero)
			cout<<0<<endl;
		else
		{
			int n=1,d=1;
			foreach(x,num)
				n*=FastPower(x->first,x->second);
			foreach(x,den)
				d*=FastPower(x->first,x->second);
		//	if(d==1)
		//		cout<<n<<endl;
		//	else
				cout<<n<<" / "<<d<<endl;
		}
		cerr<<t<<endl;
	}
	clock_t after=clock();
	cerr<<(after-before*1.0)/CLOCKS_PER_SEC<<endl;
	return 0;
}
