import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

class Pair<X,Y>
{
	public X first;
	public Y second;

	public Pair(X x, Y y)
	{
		first = x;
		second = y;
	}
}

public class se7s
{
	public static int[] primesPower = new int[1000001];
	public static ArrayList<ArrayList<Pair<Integer, Integer>>> factors = new ArrayList<ArrayList<Pair<Integer,Integer>>>();

	public static ArrayList<Pair<Integer, Integer>> Factorize(int value)
	{
		ArrayList<Pair<Integer,Integer>> factors = new ArrayList<Pair<Integer,Integer>>();
		int d = 1;

		for( int i = 2 ; i * i <= value ; i += d, d = 2)
		{
			Pair<Integer, Integer> p = new Pair<Integer, Integer>(i, 0);

			while( value % i == 0 )
			{
				p.second++;
				value /= i;
			}

			if( p.second > 0 )
				factors.add(p);
		}

		if( value > 1 )
			factors.add(new Pair<Integer, Integer>(value, 1));

		return factors;
	}

	public static void main(String[] args) throws Exception
	{

		long maxBytes = Runtime.getRuntime().maxMemory();
		System.out.println("Max memory: " + maxBytes / 1024 / 1024 + "M");


//		Scanner scan = new Scanner(new BufferedInputStream(System.in));
		Scanner scan = new Scanner(new File("division.in"));
		PrintStream out = new PrintStream(new File("division.out"));
		int test = scan.nextInt();

		factors.add(new ArrayList<Pair<Integer,Integer>>());
		factors.add(new ArrayList<Pair<Integer,Integer>>());

		for( int i = 2 ; i < 1000001 ; i++ )
			factors.add(Factorize(i));

		for( int tt = 1 ; tt <= test ; tt++ )
		{
			Arrays.fill(primesPower, 0);

			int numertaorCount = scan.nextInt();
			int denominatorCount = scan.nextInt();

			for( int i = 0 ; i < numertaorCount ; i++ )
			{
				int x = scan.nextInt();

				assert x > 0 && x <= 1000000 : "wrong value for a = " + x +", (0 < x <= 1000000)";

				if( x > 1 )
				{
					ArrayList<Pair<Integer, Integer>> f = factors.get(x);

					for( int j = 0 ; j < f.size() ; j++ )
						primesPower[f.get(j).first] += f.get(j).second;
				}
			}

			for( int i = 0 ; i < denominatorCount ; i++ )
			{
				int x = scan.nextInt();

				assert x > 0 && x <= 1000000 : "wrong value for a = " + x +", (0 < x <= 1000000)";

				if( x > 1 )
				{
					ArrayList<Pair<Integer, Integer>> f = factors.get(x);

					for( int j = 0 ; j < f.size() ; j++ )
						primesPower[f.get(j).first] -= f.get(j).second;
				}
			}

			int numerator = 1;
			int denomerator = 1;

			for( int i = 2 ; i < 1000000 ; i++ )
			{
				if( primesPower[i] == 0 )
					continue;

				int prime = i;
				int cnt = Math.abs(primesPower[i]);
				boolean isNumerator = primesPower[i] > 0;

				while( cnt-- > 0 )
				{
					numerator *= isNumerator ? prime : 1;
					denomerator *= isNumerator ? 1 : prime;
				}
			}

			out.printf("Case #%d: %d / %d\n", tt, numerator, denomerator);
		}
	}
}
