#include<iostream>
#include<cstdio>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<sstream>
#include<deque>
#include<queue>
#include<stack>
#include<string>
#include<cstring>
#ifdef _MSC_VER
#include <hash_set>
#include <hash_map>
using namespace stdext;
#else
#if __GNUC__ > 2
#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;
#else
#include <hash_set>
#include <hash_map>
#endif
#endif

using namespace std;

#define eps 1e-12
#define oo (int)1e9
#define foreach(i,c) for(__typeof((c).begin()) i = (c).begin() ; i != (c).end() ; i++)

typedef unsigned long long ull;
typedef long long ll;

int a[100];
int g[100][100];
int n;
int len = 5;

ll v_to_ll(vector<ll> v)
{
	ll m = 0;

	for( int i = 0 ; i < n ; i++ )
	{
		m |= v[i]<<(i*len);
	}

	return m;
}

ll swap_ll(ll m, int i, int j)
{
	ll mi = 15&(m>>(i*len));
	ll mj = 15&(m>>(j*len));

	m &= ~(15<<(len*i));
	m &= ~(15<<(len*j));

	m |= mi<<(j*len);
	m |= mj<<(i*len);

	return m;
}

int solve_brute_force()
{
	ll start = v_to_ll(vector<ll>(a,a+n));
	vector<ll> goalv(a,a+n);
	sort(goalv.begin(), goalv.end());
	ll goal = v_to_ll(goalv);

	queue<pair<ll,int> > q;
	map<ll,int> vis;
	int res = oo;

	q.push(make_pair(start,0));
	vis[start] = 0;

	while( !q.empty() )
	{
		int sz = q.size();

		while(sz--)
		{
			ll m = q.front().first;
			int cost = q.front().second;
			q.pop();

			if( m == goal )
				res = min(res,cost);

			for( int i = 0 ; i < n ; i++ )
			{
				for( int j = i+1 ; j < n ; j++ )
				{
					int nc = cost + abs(i-j);

					ll nm =swap_ll(m,i,j);

					if( vis.count(nm) && vis[nm] <= nc )
						continue;

					vis[nm] = nc;
					q.push(make_pair(nm,nc));
				}
			}
		}
	}

	return res;
}

int solve_warshall()
{
	for( int i = 0 ; i < n ; i++ )
		for( int j = 0 ; j < n ; j++ )
			g[i][j] = abs(i-j);

	for( int k = 0 ; k < n ; k++ )
		for( int i = 0 ; i < n ; i++ )
			for( int j = 0 ; j < n ; j++ )
				g[i][j] = min(g[i][j],g[i][k] + g[k][j]);

	int cost = 0;

	for( int i = 0 ; i < n ; i++ )
		cost += g[i][a[i]-1];

	return (cost+1)/2;
}

int solve_linear()
{
	int cost = 0;
	map<int,int> m;

	for( int i = 0 ; i < n ; i++ )
		m[a[i]] = i;

	int ind = 0;
	foreach(i,m)
		cost += abs(i->second-ind++);

	return (cost+1)/2;
}

int main()
{
#ifndef ONLINE_JUDGE
	freopen("sort.in","rt",stdin);
	freopen("sort.out","w",stdout);
#endif

	int test;

	scanf("%d", &test);

	for( int tt = 1 ; tt <= test ; tt++ )
	{
		scanf("%d", &n);

		for( int i = 0 ; i < n ; i++ )
			scanf("%d", a+i);

		printf("Case #%d: %d\n", tt, solve_linear());
	}
	return 0;
}
