#include <cstdlib>

#include <vector>
#include <map>
#include <cstdio>
#include <algorithm>
using namespace std;

const int TT = 1024*1024;
int T, tree[TT*2];

int n, key[TT];
int queries, beg[TT], end[TT], res[TT];

vector<int> v[TT];

void init() {
    T = 1;
    while (T<(n+1)) T*=2;
    for(int i=0;i<2*T;i++) tree[i] = 0;
}

void insert(int a, int val) {
    a += T;
    tree[a] = val;
    while(a>1) {
        a/=2;
        tree[a] = max(tree[2*a], tree[2*a+1]);
    }
}

int rmq(int l, int r) {
    l+=T;
    r+=T;
    int result = max(tree[l], tree[r]);
    while(l/2 != r/2) {
        if (l%2==0) result = max(result, tree[l+1]);
        if (r%2==1) result = max(result, tree[r-1]);
        l/=2;
        r/=2;
    }
    return result;
}

void scase() {
    scanf("%d%d",&n,&queries);
    if ((n==0) && (queries==0)) exit(0);
    for(int i=1;i<=n;i++) scanf("%d",&key[i]);
    map<int,int> prev;
    for(int i=0;i<queries;i++) {
        scanf("%d%d",&beg[i],&end[i]);
        v[end[i]].push_back(i);
    }
    init();
    for(int i=1;i<=n;i++) {
        insert(i, prev[key[i]]);
        prev[key[i]] = i;
        for(int j=0;j<v[i].size();j++) {
            int x = rmq(beg[v[i][j]],end[v[i][j]]);
            if (x < beg[v[i][j]]) 
                res[v[i][j]] = (-1);
            else
                res[v[i][j]] = key[x];
        }
    }
    for(int i=0;i<=n;i++) v[i].clear();
    for(int i=0;i<queries;i++)
        if (res[i]<0) printf("OK\n"); else printf("%d\n",res[i]);
    printf("\n");
}

int main() {
    for(;;) scase();
    return 0;
}


                


