/*
 * CTU Open Contest 2011
 *
 * Sample solution: analog
 * Author: Jan Stoklasa
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class analog {  

    static BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
    final int N = 51;
    final int X0 = 25;
    final int Y0 = 25;
    final char border[] = "@XXXXXXXXX@XXXXXXXXX@XXXXXXXXX@XXXXXXXXX@XXXXXXXXX@".toCharArray();
    char clock[][] = new char[N][N];

    public static void main(String[] args) throws Exception
    {
	String s;
	analog instance = new analog();

	while((s = input.readLine()) != null && !"END".equalsIgnoreCase(s))
	{
	    StringTokenizer st = new StringTokenizer(s,":");
	    int h = Integer.parseInt(st.nextToken());
	    int m = Integer.parseInt(st.nextToken());	    
	    instance.solve(h,m);
	}
    }
    
    void pixel(int x, int y, char c)
    {
	clock[Y0-y][X0+x] = c;
    }

    void o(int octant, int x, int y, char c)
    {
	switch(octant)
	{
	case 0: pixel(x,y,c); break;
	case 1: pixel(y,x,c); break;
	case 2: pixel(y,-x,c); break;
	case 3: pixel(x,-y,c); break;
	case 4: pixel(-x,-y,c); break;
	case 5: pixel(-y,-x,c); break;
	case 6: pixel(-y,x,c); break;
	case 7: pixel(-x,y,c); break;
	}
    }

    void first_octant_solution(double degrees, int s, char same, char change, int octant)
    {
	if (!(0.0 <= degrees && degrees <= 45.00))
	{
	    System.out.println("First octant solution called with out of range angle: "+degrees);
	    return;
	}
	double angle = degrees*Math.PI/180;
	int ni[] = new int[s+2];
	for (int i=0;i<=s+1;i++)
	{
	    double xi = ((double)i)/Math.tan(Math.PI/2-angle);
	    ni[i] = Math.round((float)xi);
	}
	for (int i=1;i<=s;i++)
	{
	    if (ni[i]*ni[i]+i*i>s*s)
		break;
	    else if (ni[i-1]==ni[i]&&ni[i]==ni[i+1])
		o(octant, ni[i], i, same);
	    else if (ni[i-1]<ni[i]&&ni[i]<ni[i+1])
		o(octant, ni[i], i, change);
	    else
		o(octant, ni[i], i, 'o');
	}
    }

    void line(double degrees, int s)
    {
	final int octants[][] = {
	    {0,1,'|','/'},
	    {90,-1,'-','/'},
	    {-90,1,'-','\\'},
	    {180,-1,'|','\\'},
	    {-180,1,'|','/'},
	    {270,-1,'-','/'},
	    {-270,1,'-','\\'},
	    {360,-1,'|','\\'}};
	int octant = (int)(degrees / 45.0);
	first_octant_solution(octants[octant][0] + octants[octant][1]*degrees, s, (char)octants[octant][2], (char)octants[octant][3], octant);
    }

    void clear()
    {
	for (int i=0;i<clock.length;i++)
	    for (int j=0;j<clock.length;j++)
		clock[i][j] = ' ';
	for (int j=0;j<clock.length;j++)
	{
	    clock[0][j] = clock[j][0] = clock[clock.length-1][j] = clock[j][clock.length-1] = border[j];
	}
	clock[25][25] = '*';
	clock[2][24] = '1'; clock[2][26] = '2';
	clock[25][clock.length-3] = '3';
	clock[25][2] = '9';
	clock[clock.length-3][25] = '6';	  
    }

    void solve(int h, int m)
    {
	clear();
	h = h%12;
	line(30.0*h+m/2.0,15);
	line(m*6.0,21);
	for (int i=0;i<clock.length;i++)
	{
	    System.out.println(clock[i]);
	}
	System.out.println();
    }
}