/*
 * CTU Open Contest 2011
 *
 * Sample solution: Collatz Conjecture
 * Author: Pavel Kos
 */

#include <stdio.h>

#define SIZE 1000000
#define MAX_COUNT 1000

long long values_a[MAX_COUNT];
long long values_b[MAX_COUNT];

long long * prepare(long long * ptr, long long value)
{
  while (1)
  {
    *ptr = value;
    if (value == 1)
      return ptr;
    ++ptr;
    value = (value % 2) ? (3 * value + 1) : (value / 2);
  }
}

int main(void)
{
  int a, b;
  long long * ptr_a, * ptr_b;
  while (1)
  {
    scanf("%d %d", &a, &b);
    if ((a == 0) && (b == 0))
      break;
    ptr_a = prepare(values_a, a);
    ptr_b = prepare(values_b, b);
    while ((ptr_a >= values_a) && (ptr_b >= values_b) && (*ptr_a == *ptr_b))
    {
      --ptr_a;
      --ptr_b;
    }
    ++ptr_a;
    ++ptr_b;
    printf("%d needs %d steps, %d needs %d steps, they meet at %lld\n",
    		a, (ptr_a - values_a), b, (ptr_b - values_b), *ptr_a);
  }
  return 0;
}
