/*
 * CTU Open Contest 2011
 *
 * Sample solution: Collatz Conjecture
 * Author: Martin Kacer
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;

public class collatz {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		collatz instance = new collatz();
		while (instance.run()) {/*repeat*/}
	}
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	Map<Long,Integer> numbers = new HashMap<Long, Integer>(2000);
	int steps1, steps2;
	long common;
	
	void sequence(long n) {
		int step = 0;
		for (;;) {
			Integer res = numbers.put(Long.valueOf(n), Integer.valueOf(step));
			if (res != null) {
				steps1 = res.intValue();
				steps2 = step;
				common = n;
				return;
			}
			if (n == 1) return;
			n = (n % 2 == 0) ? n/2 : n*3 + 1;
			++step;
		}
	}
	
	boolean run() throws Exception {
		int a = nextInt(), b = nextInt();
		if (a == 0) return false;
		numbers.clear();
		sequence(a);
		sequence(b);
		System.out.println(a + " needs " + steps1 + " steps, "
				+ b + " needs " + steps2 + " steps, they meet at " + common);
		return true;
	}
}
