/*
 * CTU Open Contest 2011
 *
 * Sample solution: Gradient
 * Author: Martin Kacer
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class gradient {
	static final int MAXSIZE = 2000;
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		gradient instance = new gradient();
		while (instance.run()) {/*repeat*/}
	}
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	int rows, cols;
	int[][] pic = new int[MAXSIZE+1][MAXSIZE+1];
	int[][] max = new int[MAXSIZE+1][MAXSIZE+1];

	/**
	 * Make a special check for the "small" biggest rectangle (max 3-by-3).
	 * (x,y) gives the bottom-right corner.
	 */
	int checkSmall(int dir, int x, int y) {
		if (x <= 1 || y <= 1) return 1;
		int dx, dy;
		switch (dir) {
			case 1: dx = 0; dy = pic[x][y] - pic[x][y-1]; break;
			case 2: dx = pic[x][y] - pic[x-1][y]; dy = 0; break;
			case 3: dx = pic[x][y] - pic[x-1][y]; dy = dx; break;
			case 4: dx = pic[x][y] - pic[x-1][y]; dy = -dx; break;
			default: throw new IllegalStateException("unknown direction: " + dir);
		}
		for (int i = 0; i < 2; ++i)
			for (int j = 0; j < 2; ++j)
				if (pic[x-i][y-j] != pic[x][y] - dx*i - dy*j)
					return 1;
		if (x <= 2 || y <= 2) return 2;
		for (int i = 0; i < 3; ++i)
			for (int j = 0; j < 3; ++j)
				if (pic[x-i][y-j] != pic[x][y] - dx*i - dy*j)
					return 2;
		return 3;
	}

	boolean run() throws Exception {
		rows = nextInt(); cols = nextInt();
		if (rows == 0) return false;
		for (int i = 1; i <= rows; ++i)
			for (int j = 1; j <= cols; ++j) pic[i][j] = nextInt();
		int best = 0;
		for (int dir = 1; dir <= 4; ++dir)
			for (int i = 1; i <= rows; ++i)
				for (int j = 1; j <= cols; ++j) {
					max[i][j] = checkSmall(dir, i, j);
					if (max[i][j] > best) best = max[i][j];
					int m = Math.min(max[i-1][j], max[i][j-1]);
					if (m < 3) continue;
					int d = pic[i-1][j-1] - pic[i-2][j-2];
					if (pic[i][j] - pic[i-1][j-1] != d) continue;
					max[i][j] = (pic[i-m][j-m] + m*d == pic[i][j]) ? m+1 : m;
					if (max[i][j] > best) best = max[i][j];
				}
		System.out.println(best * best);
		return true;
	}
}
