/*
 * CTU Open Contest 2011
 *
 * Sample solution: Invasion
 * Author: Martin Kacer
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class invasion {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		invasion instance = new invasion();
		while (instance.run()) {/*repeat*/}
	}
	String nextToken() throws Exception {
		while (!st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	int towns, safedist;
	int mindist[];
	int queue[], qb, qe; boolean inqueue[];
	List<Integer> neighbor[];
	int safecount;
	
	void enqueue(int n, int d) {
		if (mindist[n] <= d) return;
		if (mindist[n] == safedist) --safecount;
		mindist[n] = d;
		if (inqueue[n]) return;
		queue[qe] = n; inqueue[n] = true;
		if (++qe >= queue.length) qe = 0;
	}

	boolean run() throws Exception {
		towns = nextInt();
		if (towns == 0) return false;
		int roads = nextInt(); int aliens = nextInt();
		safedist = nextInt();
		neighbor = createArray(towns);
		mindist = new int[towns];
		queue = new int[towns]; inqueue = new boolean[towns];
		qb = qe = 0;
		for (int i = 0; i < towns; ++i) { neighbor[i] = new ArrayList<Integer>(); mindist[i] = safedist; }
		for (int i = 0; i < roads; ++i) {
			int a = nextInt()-1, b = nextInt()-1, d = nextInt();
			neighbor[a].add(Integer.valueOf(b*1000 + d));
			neighbor[b].add(Integer.valueOf(a*1000 + d));
		}
		safecount = towns;
		for (int i = 0; i < aliens; ++i) {
			int a = nextInt()-1;
			enqueue(a, 0);
			while (qb != qe) {
				int n = queue[qb];
				if (++qb >= queue.length) qb = 0;
				inqueue[n] = false;
				for (Integer in : neighbor[n]) {
					enqueue(in.intValue()/1000, mindist[n] + in.intValue()%1000);
				}
			}
			System.out.println(safecount);
		}
		System.out.println();
		return true;
	}

	@SuppressWarnings("unchecked")
	private static <T> ArrayList<T>[] createArray(int len) {
		return new ArrayList[len];
	}
}
