#include <iostream>
#include <cassert>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 50;

int n, m;
int g[maxn][maxn];
int vis[maxn];

int dfs(int x, int no_u, int no_v)
{
    if (x == no_v) return 1;
    vis[x] = 1;
    for (int i = 0; i < n; i++) {
        if (g[x][i] && (x != no_u || i != no_v) && !vis[i]) {
            if (dfs(i, no_u, no_v)) return 1;
        }
    }
    return 0;
}

int main()
{
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

    cin >> n >> m;
    assert(1 <= n && n <= 50);
    
    int i, j;
    for (i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u][v] = i+1;
    }
    
    vector<int> ans;
    for (i = 0; i < n; i++) {
        for (j = 0; j < n; j++) {
            if (g[i][j]) {
                memset(vis, 0, sizeof(vis));
                if (dfs(i, i, j)) ans.push_back(g[i][j]);
            }
        }
    }

    sort(ans.begin(), ans.end());
    
    cout << ans.size() << endl;
    for (i = 0; i < ans.size(); i++)
        cout << ans[i] << " ";

    fclose(stdin); fclose(stdout);
}
