 {$APPTYPE CONSOLE}

uses
  SysUtils, Types;

type
  event = record
    who, where, count: integer;
  end;

  TQueue = class
  public
    constructor Create(init_size: integer);
    procedure push(arg: integer);
    function front: integer;
    procedure pop;
    function empty: boolean;
    function IsInQueue(arg: integer): boolean;
  protected
    r, w, size: integer;
    q: array of integer;
  end;

var
   x_t, r_t, n, m, i, k, f, s, t, j: integer;
   ans: array of TPoint;
   x_ray, room: TQueue;
   time: array [0..1000] of array of event;

procedure AddEvent(when, w, wh, c: integer);
begin
  SetLength(time[when], Length(time[when]) + 1);
  with time[when, high(time[when])] do begin
    who := w;
    where := wh;
    count := c;
  end;
end;  

constructor TQueue.Create(init_size: integer);
begin
  SetLength(q, init_size);
  w := 0;
  r := 1;
  size := init_size;
end;

function TQueue.empty: boolean;
begin
  result := r > w;
end;

function TQueue.front: integer;
begin
  if not empty then
    result := q[r]
  else
    result := 0;
end;

function TQueue.IsInQueue(arg: integer): boolean;
var
  i: integer;
begin
  for i := r to w do
    if q[i] = arg then begin
      result := true;
      exit;
    end;
  result := false;
end;

procedure TQueue.pop;
begin
  if not empty then
    inc(r);
end;

procedure TQueue.push(arg: integer);
begin
  inc(w);
  if w > size then begin
    size := size * 2;
    SetLength(q, size);
  end;
  q[w] := arg;
end;

begin
  reset(input, 'input.txt');
  rewrite(output, 'output.txt');

  read(n, r_t, x_t);
  SetLength(ans, n + 1);
  
  x_ray := TQueue.Create(2 * n);
  room := TQueue.Create(2 * n);

  for i := 1 to n do begin
    read(t, m);
    k := 1;
    if m = 1 then
      read(k);
    AddEvent(t, i, m, k);
  end;

  f := 0;
  s := 0;

  for i := 1 to n do
    ans[i].X := -1;

  for i := 0 to 1000 do begin

    if f > 0 then
      dec(f);
    if s > 0 then
      dec(s);  

    for j := 0 to High(time[i]) do begin
      if time[i, j].where = 1 then begin
        x_ray.push(time[i, j].who);
        if time[i,j].count = 2 then
          room.push(time[i, j].who);
      end
      else
        room.push(time[i, j].who);
      if ans[time[i, j].who].X = -1 then
        ans[time[i, j].who].X := i;
    end;

    if (f = 0) and not x_ray.empty then begin
      f := x_t;
      AddEvent(i + f, x_ray.front, 2, 1);
      if room.IsInQueue(x_ray.front) and (room.front <> x_ray.front) then
        room.push(x_ray.front);
    end;

    if (s = 0) and not room.empty then begin
      t := room.front;
      while (t <> 0) and x_ray.IsInQueue(t) do begin
        room.pop;
        t := room.front;
      end;
      if not room.empty then begin
        s := r_t;
        ans[t].Y := i + s;
      end;
      room.pop;
    end;

    if (f = x_t) and not x_ray.empty then
      x_ray.pop;

  end;

  for i := 1 to n do
    write(ans[i].Y - ans[i].X, ' ');

  FreeAndNil(x_ray);
  FreeAndNil(room);
  close(input);
  close(output);
 end.
