#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <cctype>
#include <sstream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <queue>

using namespace std;

typedef long double real;
typedef long long TT;

#define SQR(x) ((x)*(x))

const int maxn = 12;
const double inf = 1 << 20;

int n, m;
int sx[maxn], sy[maxn];
int ax[maxn], ay[maxn], bx[maxn], by[maxn], dd[maxn];
double d[maxn][1 << maxn][3*maxn];
int fr[maxn][1 << maxn][3*maxn];
int plan_len[maxn];
int plan_t[maxn][maxn];
int plan_d[maxn][maxn];
double ddd[3*maxn][3*maxn];

void tryit(int vehicle, int mask, int point, int vehicle1, int mask1, int point1, double add, double bound)
{
    double val = (vehicle1 == vehicle ? d[vehicle][mask][point] : 0) + add;
    if (val > bound) return;
    if (d[vehicle1][mask1][point1] > val) {
        d[vehicle1][mask1][point1] = val;
        fr[vehicle1][mask1][point1] = point;
    }
}

double dist(int u, int v)
{
    double ux, uy;
    if (u < m) {ux = ax[u]; uy = ay[u];}
    else if (u < m+m) {ux = bx[u-m]; uy = by[u-m];}
    else {ux = sx[u-m-m]; uy = sy[u-m-m];}

    double vx, vy;
    if (v < m) {vx = ax[v]; vy = ay[v];}
    else if (v < m+m) {vx = bx[v-m]; vy = by[v-m];}
    else {vx = sx[v-m-m]; vy = sy[v-m-m];}
    
    return sqrt(SQR(ux-vx) + SQR(uy-vy));
}

int can(double bound)
{
    int vehicle, mask, point;
    
    for (vehicle = 0; vehicle < n; vehicle++)
        for (mask = 0; mask < (1 << m); mask++)
            for (point = 0; point < 2*m + n; point++) {
                d[vehicle][mask][point] = inf;
            }
    d[0][0][2*m] = 0;
    
    for (vehicle = 0; vehicle < n; vehicle++)
        for (mask = 0; mask < (1 << m); mask++)
            for (point = 0; point < 2*m + n; point++) {
                if (d[vehicle][mask][point] == inf) continue;
                
                if (vehicle < n-1) {
                    tryit(vehicle, mask, point, vehicle+1, mask, 2*m + vehicle+1, 0, bound);
                }
                for (int i = 0; i < m; i++) {
                    if (mask & (1 << i)) continue;
                    tryit(vehicle, mask, point, vehicle, mask + (1 << i), i, ddd[point][i+m] + dd[i], bound);
                    tryit(vehicle, mask, point, vehicle, mask + (1 << i), i+m, ddd[point][i] + dd[i], bound);
                }
            }

    int best_point = 0;
    for (point = 1; point < 2*m + n; point++) {
        if (d[n-1][(1 << m)-1][point] < d[n-1][(1 << m)-1][best_point])
            best_point = point;
    }
    
    if (d[n-1][(1 << m)-1][best_point] == inf) return 0;
    
    vehicle = n-1;
    mask = (1 << m)-1;
    point = best_point;
    memset(plan_len, 0, sizeof(plan_len));
    while (point != 2*m) {
        int vehicle1 = point >= 2*m ? vehicle-1 : vehicle;
        int mask1 = point >= 2*m ? mask : mask - (1 << (point%m));
        int point1 = fr[vehicle][mask][point];
        
        if (point < 2*m) {
            plan_len[vehicle]++;
            plan_t[vehicle][plan_len[vehicle]-1] = point%m;
            plan_d[vehicle][plan_len[vehicle]-1] = point < m ? 1 : 0;
        }
        
        vehicle = vehicle1;
        mask = mask1;
        point = point1;
    }
    
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < plan_len[i]/2; j++) {
            swap(plan_t[i][j], plan_t[i][plan_len[i]-1-j]);
            swap(plan_d[i][j], plan_d[i][plan_len[i]-1-j]);
        }
    }
    
    return 1;
}

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);
    
    int i, j;

    cin >> n >> m;
    for (i = 0; i < n; i++) {
        cin >> sx[i] >> sy[i];
    }
    for (i = 0; i < m; i++) {
        cin >> ax[i] >> ay[i] >> bx[i] >> by[i] >> dd[i];
    }
    
    for (i = 0; i < 2*m+n; i++) {
        for (j = 0; j < 2*m+n; j++) {
            ddd[i][j] = dist(i, j);
        }
    }
    
    double L = 0, R = inf;
    for (int sc = 0; sc < 50; sc++) {
        double cur = (L+R) / 2.0;
        if (can(cur)) R = cur; else L = cur;
    }
    
    //cout << fixed << setprecision(5) << L << endl;
    
    for (i = 0; i < n; i++) {
        cout << plan_len[i] << " ";
        for (j = 0; j < plan_len[i]; j++) {
            cout << plan_t[i][j]+1 << " " << plan_d[i][j] << " ";
        }
        cout << endl;
    }
    
    fclose(stdin); fclose(stdout);
    return 0;   
}
