#include <iostream>
#include <string>
#include <cassert>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 100000;

vector<pair<int, int> > a;
vector<int> ans;

int main()
{
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	int n;
	int i, j, k;

	cin >> n;
	assert(n <= 100000);
	ans.resize(n);
	int positive = 0, negative = 0;
	for (i = 0; i < n; i++) {
		cin >> k;
		assert(abs(k) <= 100000);
		a.push_back(make_pair(k, i));
		if (k > 0) positive++;
		if (k < 0) negative++;
	}

	sort(a.begin(), a.end());
	
	int L = 0, R = n-1;
	while (L < R) {
		if (positive == negative) {
			pair<int, int> p1 = a[R];
			pair<int, int> n1 = a[L];
			R -= 1;
			L += 1;
			ans[n1.second] = p1.first;
			ans[p1.second] = -n1.first;
			positive--;
			negative--;
		} else if (positive > negative) {
			pair<int, int> p1 = a[R];
			pair<int, int> p2 = a[R-1];
			pair<int, int> n1 = a[L];
			R -= 2;
			L += 1;
			ans[p1.second] = -n1.first;
			ans[p2.second] = -n1.first;
			ans[n1.second] = p1.first + p2.first;
			positive -= 2;
			negative--;
		} else {
			pair<int, int> n1 = a[L];
			pair<int, int> n2 = a[L+1];
			pair<int, int> p1 = a[R];
			R -= 1;
			L += 2;
			ans[n1.second] = p1.first;
			ans[n2.second] = p1.first;
			ans[p1.second] = -n1.first - n2.first;
			positive--;
			negative -= 2;
		}
	}

	for (i = 0; i < n; i++)
		cout << ans[i] << " ";
	cout << endl;

	fclose(stdin); fclose(stdout);
	return 0;
}
