/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem A. Automated Telephone Exchange                      */
/*                                                              */
/* Original idea         Egor Kulikov                           */
/* Problem statement     Egor Kulikov                           */
/* Testset               Egor Kulikov                           */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Egor Kulikov                           */
/*--------------------------------------------------------------*/
 
import java.util.InputMismatchException;
import java.io.*;

public class ate_ek {
    public static void main(String[] args) {
        InputReader in;
        PrintWriter out;
        try {
            in = new StreamInputReader(new FileInputStream("ate.in"));
            out = new PrintWriter(new PrintStream(new FileOutputStream("ate.out")));
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        run(in, out);
    }

    public static void run(InputReader in, PrintWriter out) {
        Solver solver = new ATE();
        solver.solve(1, in, out);
        Exit.exit(in, out);
    }
}

abstract class InputReader {

    public abstract int read();

    public int readInt() {
        int c = read();
        while (isSpaceChar(c))
            c = read();
        int sgn = 1;
        if (c == '-') {
            sgn = -1;
            c = read();
        }
        int res = 0;
        do {
            if (c < '0' || c > '9')
                throw new InputMismatchException();
            res *= 10;
            res += c - '0';
            c = read();
        } while (!isSpaceChar(c));
        return res * sgn;
    }

    private boolean isSpaceChar(int c) {
        return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
    }

    public void setFinished() {
    }

    public abstract void close();
}

class StreamInputReader extends InputReader {
    private InputStream stream;
    private byte[] buf = new byte[1024];
    private int curChar, numChars;

    public StreamInputReader(InputStream stream) {
        this.stream = stream;
    }

    public int read() {
        if (numChars == -1)
            throw new InputMismatchException();
        if (curChar >= numChars) {
            curChar = 0;
            try {
                numChars = stream.read(buf);
            } catch (IOException e) {
                throw new InputMismatchException();
            }
            if (numChars <= 0)
                return -1;
        }
        return buf[curChar++];
    }

    public void close() {
        try {
            stream.close();
        } catch (IOException ignored) {
        }
    }
}

class Exit {
    private Exit() {
    }

    public static void exit(InputReader in, PrintWriter out) {
        in.setFinished();
        in.close();
        out.close();
    }
}

interface Solver {
    public void solve(int testNumber, InputReader in, PrintWriter out);
}

class ATE implements Solver {
    private static final int MIN_ATE = 100;
    private static final int MAX_ATE = 999;

    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int ate = in.readInt();
        assert ate >= MIN_ATE && ate <= MAX_ATE;
        out.println(Math.max(199 - ate, 0));
    }
}
