/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem B. Black Square                                      */
/*                                                              */
/* Original idea         Maxim Buzdalov                         */
/* Problem statement     Andrew Stankevich                      */
/* Testset               Andrew Stankevich                      */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Akhi                             */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.*;

public class black_aa {

    public static void main(String[] args) {
        new black_aa().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof = false;
    Random rand = new Random(34611256);

    void run() {
        try {
            br = new BufferedReader(new FileReader(FNAME + ".in"));
            out = new PrintWriter(FNAME + ".out");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(566);
        }
    }

    String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(nextToken());
    }

    void myAssert(boolean u, String message) {
        if (!u) {
            throw new Error("Assertion error!!! " + message);
        }
    }

    int nextBoundedInt(int l, int r, String name) {
        int x = nextInt();
        myAssert(l <= x && x <= r, name + " = " + x + " not in [" + l + ".."
                + r + "]");
        return x;
    }

    String FNAME = "black";

    final String UNIQUE = "Unique";
    final String AMBIGUOUS = "Ambiguous";
    final String IMPOSSIBLE = "Impossible";

    final int MAXN = 5000;

    private void solve() throws IOException {
        int m = nextBoundedInt(1, MAXN, "m");
        int n = nextBoundedInt(1, MAXN, "n");
        int s = nextBoundedInt(1, Math.min(m, n), "s");
        int k = nextBoundedInt(1, m, "k");
        char[] c = nextToken().toCharArray();
        myAssert(c.length == n, "wrong line length!");
        for (int i = 0; i < c.length; i++) {
            myAssert(c[i] == '.' || c[i] == '*', "unexpected symbol " + c[i]);
        }
        int cnt = 0;
        int len = 0;
        for (int i = 0; i < c.length; i++) {
            if (c[i] == '*') {
                if (i == 0 || c[i] != c[i - 1]) {
                    cnt++;
                }
                len++;
            }
        }
        if (cnt == 0) {
            int s1 = k - 1;
            int s2 = m - k;
            if (s > s1 && s > s2) {
                out.println(IMPOSSIBLE);
            } else if (s <= s1 && s <= s2 || s < n) {
                out.println(AMBIGUOUS);
            } else {
                out.println(UNIQUE);
            }
            return;
        }
        if (cnt != 1 || len != s) {
            out.println(IMPOSSIBLE);
            return;
        }
        if (m == s || s == 1 || k == 1 || k == m) {
            out.println(UNIQUE);
            return;
        }
        out.println(AMBIGUOUS);
    }

}
