/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem B. Black Square                                      */
/*                                                              */
/* Original idea         Maxim Buzdalov                         */
/* Problem statement     Andrew Stankevich                      */
/* Testset               Andrew Stankevich                      */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Bannykh                          */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

public class black_ab {
    public static void main(String[] arg) {
           new black_ab().run();
    }

    StrictScanner in;
    PrintWriter out;
    boolean eof;


    public void run() {
        try {
            String problemName = this.getClass().getName().split("_")[0];
            in = new StrictScanner(new FileReader(problemName + ".in"));
            out = new PrintWriter(problemName + ".out");
            solve();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        } finally {
            out.close();
        }
    }

    final int MAXN = 5000;
    final int MAXC = 100000;

    final String UNIQUE = "Unique";
    final String AMBIGOUS = "Ambiguous";
    final String IMPOSSIBLE = "Impossible";

    void solve() throws Exception {
        int m = assertBetween(1, in.loadLine().nextInt(), MAXN, "m");
        int n = assertBetween(1, in.skipSpace().nextInt(), MAXN, "n");
        int s = assertBetween(1, in.skipSpace().nextInt(), Math.min(n, m), "s");
        int k = assertBetween(1, in.skipSpace().nextInt(), m, "k");
        String l = in.loadLine().nextToken();
        assert l.length() == n : "Wrong line length";

        boolean started  = false;
        boolean finished = false;
        int len = 0;
        for (char c : l.toCharArray()) {
            if (c == '*') {
                if (finished) {
                    out.println(IMPOSSIBLE);
                    return;
                }
                started = true;
                ++len;
            } else if (started) {
                finished = true;
            }
        }
        if (len == s) {
            if (s == m || s == 1 || k == 1 || k == m) {
                out.println(UNIQUE);
            } else {
                out.println(AMBIGOUS);
            }
        } else if (len == 0) {
            if ((k - 1 == s) ^ (m - k == s) && n == s) {
                out.println(UNIQUE);
                return;
            }
            if (k - 1 < s && m - k < s) {
                out.println(IMPOSSIBLE);
                return;
            }
            out.println(AMBIGOUS);
        } else {
            out.println(IMPOSSIBLE);
        }
    }

    int assertBetween(int l, int m, int r, String name) {
        assert l <= m && m <= r : "Variable " + name + " = " + m + " not in bounds [" + l + ", " + r + "]";
        return m;
    }

    class StrictScanner extends BufferedReader {

        private String cs;
        private int cpos;

        public StrictScanner(Reader a) {
            super(a);
        }

        boolean eoln() {
            return cpos == cs.length();
        }

        StrictScanner loadLine() throws IOException {
            assert cs == null || eoln();
            cs = readLine();
            cpos = 0;
            return this;
        }

        char nextChar() {
            return cs.charAt(cpos++);
        }

        String nextToken() {
            StringBuilder sb = new StringBuilder();
            while (cpos < cs.length() && cs.charAt(cpos) != ' ') {
                sb.append(cs.charAt(cpos));
                ++cpos;
            }
            return sb.toString();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }

        double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        long nextLong() {
            return Long.parseLong(nextToken());
        }

        StrictScanner skipSpace() {
            char c = nextChar();
            assert c == ' ';
            return this;
        }
    }
}
