/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem B. Black Square                                      */
/*                                                              */
/* Original idea         Maxim Buzdalov                         */
/* Problem statement     Andrew Stankevich                      */
/* Testset               Andrew Stankevich                      */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Andrew Stankevich                      */
/*--------------------------------------------------------------*/
 
import java.util.*;
import java.io.*;

class black_as {
    FastScanner in;
    PrintWriter out;

    final static int MAX = 5000;

    public void solve() throws IOException {
        int m = in.nextInt();
        int n = in.nextInt();
        int s = in.nextInt();
        int k = in.nextInt();
        assert 1 <= m && m <= MAX;
        assert 1 <= n && n <= MAX;
        assert 1 <= s && s <= Math.min(m, n);
        assert 1 <= k && k <= m;
        k--;

        String v = in.next();
        assert v.length() == n;
        assert v.matches("[\\.\\*]*");

        int minStar = -1;
        int maxStar = -1;
        for (int i = 0; i < n; i++) {
            if (v.charAt(i) == '*') {
                if (minStar == -1) {
                    minStar = i;
                }
                maxStar = i;
            }
        }
        if (maxStar != -1) {
            if (maxStar - minStar + 1 != s) {
                out.println("Impossible");
                return;
            }
            for (int i = minStar; i <= maxStar; i++) {
                if (v.charAt(i) != '*') {
                    out.println("Impossible");
                    return;
                }
            }
        }

        int can = 0;
        for (int i = 0; i < m - s + 1; i++) {
            for (int j = 0; j < n - s + 1; j++) {
                if (i <= k && k <= i + s - 1) {
                    if (j == minStar) {
                        can++;
                    }
                } else {
                    if (minStar == -1) {
                        can++;
                    }
                }
            }
        }

        if (can == 0) {
            out.println("Impossible");
        } else if (can == 1) {
            out.println("Unique");
        } else {
            out.println("Ambiguous");
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("black.in"));
            out = new PrintWriter(new File("black.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new black_as().run();
    }
}