/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem B. Black Square                                      */
/*                                                              */
/* Original idea         Maxim Buzdalov                         */
/* Problem statement     Andrew Stankevich                      */
/* Testset               Andrew Stankevich                      */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Yury Petrov                            */
/*--------------------------------------------------------------*/
 
#include <stdio.h>
#include <assert.h>

#define maxN 5000

int m, n, s, k;
char a[maxN + 1];

int min( int a, int b ) {
  return a < b ? a : b;
}

int max( int a, int b ) {
  return a > b ? a : b;
}

int main( void ) {
  int i, mi, ma, sum, cnt;
  assert(freopen("black.in", "r", stdin));
  assert(freopen("black.out", "w", stdout));

  assert(scanf("%d%d%d%d%s", &m, &n, &s, &k, a) == 5);
  mi = n;
  ma = -1;
  sum = 0;
  for (i = 0; i < n; i++) {
    if (a[i] == '*') {
      sum++;
      if (i < mi) {
        mi = i;
      }
      if (i > ma) {
        ma = i;
      }
    }
  }
  if (sum == 0) {
    cnt = (max(0, k - s) + max(0, m - k - s + 1)) * max(0, n - s + 1);
  } else if (sum != ma - mi + 1 || sum != s) {
    cnt = 0;
  } else {
    cnt = max(0, min(m - s + 1, k) - max(1, k - s + 1) + 1);
  }
  if (cnt == 0) {
    puts("Impossible");
  } else if (cnt == 1) {
    puts("Unique");
  } else {
    puts("Ambiguous");
  }

  return 0;
}
