/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem C. Cube Coloring                                     */
/*                                                              */
/* Original idea         Georgiy Korneev                        */
/* Problem statement     Maxim Buzdalov                         */
/* Testset               Maxim Buzdalov                         */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Bannykh                          */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.*;

public class cube_ab {
    public static void main(String[] arg) {
           new cube_ab().run();
    }

    StrictScanner in;
    PrintWriter out;
    boolean eof;


    public void run() {
        try {
            String problemName = this.getClass().getName().split("_")[0];
            in = new StrictScanner(new FileReader(problemName + ".in"));
            out = new PrintWriter(problemName + ".out");
            solve();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        } finally {
            out.close();
        }
    }

    final String IMPOSSIBLE = "Impossible";

    final int[][] view = {
            {0, 1, 2, 3, 4},
            {1, 5, 2, 0, 4},
            {2, 1, 0, 3, 5},
            {3, 5, 2, 0, 4},
            {4, 1, 0, 3, 5},
            {5, 1, 2, 3, 4}};


    char[] norm(char[] s) {
        Arrays.sort(s, 1, s.length);
        return s;
    }

    Comparator<char[]> cmp = new Comparator<char[]>() {
        @Override
        public int compare(char[] a, char[] b) {
            for (int i = 0; i < a.length; ++i) {
                int t = a[i] - b[i];
                if (t != 0) return t;
            }
            return 0;
        }
    };

    char[] uc, map;
    char[][] cl;
    char[][] tcl = new char[6][5];

    ArrayList<String> ans;

    int[][] rot = {{0, 2, 3, 4, 1, 5}, {4, 1, 0, 3, 5, 2}, {1, 5, 2, 0, 4, 3}};

    char[] buf = new char[6];
    char[] tb = new char[6];

    void apply(int[] r) {
        for (int i = 0; i < 6; ++i) {
            tb[r[i]] = buf[i];
        }
        char[] t = buf;
        buf = tb;
        tb = t;
    }

    boolean checkMin() {
        System.arraycopy(map, 0, buf, 0, 6);
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                for (int k = 0; k < 4; ++k) {
                    if (cmp.compare(buf, map) < 0) {
                        return false;
                    }
                    apply(rot[2]);
                }
                apply(rot[1]);
            }
            apply(rot[0]);
        }
        return true;
    }

    void bt(int i) {
        if (i == map.length) {
            if (!checkMin()) return;
            for (int j = 0; j < 6; ++j) {
                for (int k = 0; k < view[j].length; ++k) {
                    tcl[j][k] = map[view[j][k]];
                }
                norm(tcl[j]);
            }
            Arrays.sort(tcl, cmp);
            for (int j = 0; j < 6; ++j) {
                if (cmp.compare(tcl[j], cl[j]) != 0) {
                    return;
                }
            }
            ans.add(new String(map));
        } else {
            for (char c : uc) {
                map[i] = c;
                bt(i + 1);
                if (ans.size() == 2) return;
            }
        }
    }

    void solve() throws Exception {
        cl = new char[6][];
        Set<Character> h = new HashSet<Character>();
        for (int i = 0; i < cl.length; ++i) {
            String s = (i == 0 ? in.loadLine() : in.skipSpace()).nextToken();
            assert s.length() == 5;
            cl[i] = norm(s.toCharArray());
            for (char c : cl[i]) {
                h.add(c);
            }
        }
        Arrays.sort(cl, cmp);

        if (h.size() > 6) {
            out.println(IMPOSSIBLE);
            return;
        }

        uc = new char[h.size()];
        int m = 0;
        for (char c : h) {
            uc[m++] = c;
        }

        map = new char[6];
        ans = new ArrayList<String>();
        bt(0);
        if (ans.size() == 0) {
            out.println(IMPOSSIBLE);
        } else {
            for (String s : ans) {
                out.println(s);
            }
        }
    }

    int assertBetween(int l, int m, int r, String name) {
        assert l <= m && m <= r : "Variable " + name + " = " + m + " not in bounds [" + l + ", " + r + "]";
        return m;
    }

    class StrictScanner extends BufferedReader {

        private String cs;
        private int cpos;

        public StrictScanner(Reader a) {
            super(a);
        }

        boolean eoln() {
            return cpos == cs.length();
        }

        StrictScanner loadLine() throws IOException {
            assert cs == null || eoln();
            cs = readLine();
            cpos = 0;
            return this;
        }

        char nextChar() {
            return cs.charAt(cpos++);
        }

        String nextToken() {
            StringBuilder sb = new StringBuilder();
            while (cpos < cs.length() && cs.charAt(cpos) != ' ') {
                sb.append(cs.charAt(cpos));
                ++cpos;
            }
            return sb.toString();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }

        double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        long nextLong() {
            return Long.parseLong(nextToken());
        }

        StrictScanner skipSpace() {
            char c = nextChar();
            assert c == ' ';
            return this;
        }
    }
}
