/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem C. Cube Coloring                                     */
/*                                                              */
/* Original idea         Georgiy Korneev                        */
/* Problem statement     Maxim Buzdalov                         */
/* Testset               Maxim Buzdalov                         */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Maxim Buzdalov                         */
/*--------------------------------------------------------------*/
 
import java.util.*;
import java.io.*;

public class cube_mb {
    private static boolean inc(int[] indices, int max) {
        for (int i = indices.length - 1; i >= 0; --i) {
            if (indices[i] < max) {
                ++indices[i];
                return true;
            }
            indices[i] = 0;
        }
        return false;
    }
    private static final int[][] ngb = {
        {0, 1, 2, 3, 4, 5},
        {1, 0, 4, 5, 2, 3},
        {2, 0, 1, 5, 3, 4},
        {3, 0, 2, 5, 4, 1},
        {4, 0, 3, 5, 1, 2},
        {5, 4, 3, 2, 1, 0}
    };

    private static String smallest(String source) {
        char[] optimumChars = source.toCharArray();
        char[] currentChars = new char[6];
        for (int[] n : ngb) {
            for (int a = 0; a < 4; ++a) {
                currentChars[0] = source.charAt(n[0]);
                currentChars[5] = source.charAt(n[5]);
                for (int i = 0; i < 4; ++i) {
                    currentChars[1 + i] = source.charAt(n[1 + (i + a) % 4]);
                }
                for (int i = 0; i < 6; ++i) {
                    if (currentChars[i] != optimumChars[i]) {
                        if (currentChars[i] < optimumChars[i]) {
                            System.arraycopy(currentChars, 0, optimumChars, 0, 6);
                        }
                        break;
                    }
                }
            }
        }
        return String.valueOf(optimumChars);
    }

    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new FileReader("cube.in"));
        String[] vision = new String[6];
        StringTokenizer st = new StringTokenizer(in.readLine());
        for (int i = 0; i < vision.length; ++i) {
            char[] t = st.nextToken().toCharArray();
            Arrays.sort(t, 1, t.length);
            vision[i] = String.valueOf(t);
        }
        Arrays.sort(vision);
        in.close();

        PrintWriter out = new PrintWriter("cube.out");
        Set<Character> usedChars = new HashSet<Character>();
        for (String s : vision) {
            for (int i = 0; i < s.length(); ++i) {
                usedChars.add(s.charAt(i));
            }
        }
        if (usedChars.size() > 6) {
            out.println("Impossible");
        } else {
            String chars = "";
            for (char c : usedChars) {
                chars += c;
            }
            char[] cubeChars = new char[6];
            int[] cubeIndices = new int[6];
            char[] visChars = new char[5];
            List<String> answers = new ArrayList<String>();
            Set<String> tested = new HashSet<String>();
            String[] myVision = new String[6];
            do {
                for (int t = 0; t < 6; ++t) {
                    cubeChars[t] = chars.charAt(cubeIndices[t]);
                }
                String v = smallest(String.valueOf(cubeChars));
                if (!tested.contains(v)) {
                    tested.add(v);
                    for (int f = 0; f < 6; ++f) {
                        for (int i = 0; i < 5; ++i) {
                            visChars[i] = v.charAt(ngb[f][i]);
                        }
                        Arrays.sort(visChars, 1, visChars.length);
                        myVision[f] = String.valueOf(visChars);
                    }
                    Arrays.sort(myVision);
                    if (Arrays.equals(vision, myVision)) {
                        answers.add(v);
                        if (answers.size() == 2) {
                            break;
                        }
                    }
                }
            } while (inc(cubeIndices, chars.length() - 1));
            if (answers.isEmpty()) {
                out.println("Impossible");
            } else {
                for (int i = 0; i < 2 && i < answers.size(); ++i) {
                    out.println(answers.get(i));
                }
            }
        }
        out.close();
    }
}
