/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem D. Dice                                              */
/*                                                              */
/* Original idea         Georgiy Korneev                        */
/* Problem statement     Dmitry Shtukenberg                     */
/* Testset               Anton Akhi                             */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Akhi                             */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.*;

public class dice_aa {

    public static void main(String[] args) {
        new dice_aa().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof = false;
    Random rand = new Random(34611256);

    void run() {
        try {
            br = new BufferedReader(new FileReader(FNAME + ".in"));
            out = new PrintWriter(FNAME + ".out");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(566);
        }
    }

    String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(nextToken());
    }

    void myAssert(boolean u, String message) {
        if (!u) {
            throw new Error("Assertion error!!! " + message);
        }
    }

    int nextBoundedInt(int l, int r, String name) {
        int x = nextInt();
        myAssert(l <= x && x <= r, name + " = " + x + " not in [" + l + ".."
                + r + "]");
        return x;
    }

    String FNAME = "dice";

    final int MAXN = 1000;
    final int MAXA = 100;


    private void solve() throws IOException {
        int n = nextBoundedInt(1, MAXN, "n");
        Dice[] a = new Dice[n];
        int m = 0;
        for (int i = 0; i < a.length; i++) {
            a[i] = new Dice(nextBoundedInt(1, MAXA, "a_" + (i + 1)),i);
            m += a[i].a.length;
        }
        Arrays.sort(a, new Comparator<Dice>() {

            @Override
            public int compare(Dice o1, Dice o2) {
                return o2.a.length - o1.a.length;
            }
        });
        double s = 0;
        int j = 0;
        int k = 0;
        for (int i = 0; i < m; i++) {
            a[j].a[k++] = i + 1;
            s += (i + 1.0) / a[j].a.length;
            if (k >= a[j].a.length) {
                j++;
                k = 0;
            }
        }
        Arrays.sort(a, new Comparator<Dice>() {

            @Override
            public int compare(Dice o1, Dice o2) {
                return o1.n - o2.n;
            }
        });
        out.println(s);
        for (Dice d : a) {
            for (int i = 0; i < d.a.length; i++) {
                if (i > 0) {
                    out.print(" ");
                }
                out.print(d.a[i]);
            }
            out.println();
        }
    }

    class Dice {
        public Dice(int m, int n) {
            this.n = n;
            a = new int[m];
        }

        int n;
        int[] a;
    }

}
