/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem D. Dice                                              */
/*                                                              */
/* Original idea         Georgiy Korneev                        */
/* Problem statement     Dmitry Shtukenberg                     */
/* Testset               Anton Akhi                             */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Bannykh                          */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.Arrays;

public class dice_ab {
    public static void main(String[] arg) {
           new dice_ab().run();
    }

    StrictScanner in;
    PrintWriter out;
    boolean eof;


    public void run() {
        try {
            String problemName = this.getClass().getName().split("_")[0];
            in = new StrictScanner(new FileReader(problemName + ".in"));
            out = new PrintWriter(problemName + ".out");
            solve();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        } finally {
            out.close();
        }
    }

    final int MAXN = 1000;
    final int MAXA = 100;

    void solve() throws Exception {
        int n = assertBetween(1, in.loadLine().nextInt(), MAXN, "n");
        Dice[] d = new Dice[n];
        int sum = 0;
        for (int i = 0; i < n; ++i) {
            d[i] = new Dice(assertBetween(1, (i == 0 ? in.loadLine() : in.skipSpace()).nextInt(), MAXA, "a_{" + (i + 1) + "}"), i);
        sum += d[i].a;
        }
        Dice[] a = d.clone();
        Arrays.sort(a);
        long ans = 0;
        for (Dice ai : a) {
            ans += 2 * sum - ai.a + 1;
            ai.tm = sum;
            sum -= ai.a;
        }
        out.println(ans / 2 + "." + ans % 2 * 5);
        for (int i = 0; i < d.length; ++i) {
            while (d[i].a --> 0) {
                out.print(d[i].tm-- + " ");
            }
        }
    out.println();
    }

    class Dice implements Comparable<Dice> {
        int a, num, tm;

        public Dice(int a, int num) {
            this.a = a;
            this.num = num;
        }

        @Override
        public int compareTo(Dice o) {
            return a - o.a;
        }
    }

    int assertBetween(int l, int m, int r, String name) {
        assert l <= m && m <= r : "Variable " + name + " = " + m + " not in bounds [" + l + ", " + r + "]";
        return m;
    }

    class StrictScanner extends BufferedReader {

        private String cs;
        private int cpos;

        public StrictScanner(Reader a) {
            super(a);
        }

        boolean eoln() {
            return cpos == cs.length();
        }

        StrictScanner loadLine() throws IOException {
            assert cs == null || eoln();
            cs = readLine();
            cpos = 0;
            return this;
        }

        char nextChar() {
            return cs.charAt(cpos++);
        }

        String nextToken() {
            StringBuilder sb = new StringBuilder();
            while (cpos < cs.length() && cs.charAt(cpos) != ' ') {
                sb.append(cs.charAt(cpos));
                ++cpos;
            }
            return sb.toString();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }

        double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        long nextLong() {
            return Long.parseLong(nextToken());
        }

        StrictScanner skipSpace() {
            char c = nextChar();
            assert c == ' ';
            return this;
        }
    }
}
