/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem F. Flat                                              */
/*                                                              */
/* Original idea         Fedor Tsarev                           */
/* Problem statement     Fedor Tsarev                           */
/* Testset               Fedor Tsarev                           */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Akhi                             */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.*;

public class flat_aa {

    public static void main(String[] args) {
        new flat_aa().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof = false;
    Random rand = new Random(34611256);

    void run() {
        try {
            br = new BufferedReader(new FileReader(FNAME + ".in"));
            out = new PrintWriter(FNAME + ".out");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(566);
        }
    }

    String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(nextToken());
    }

    void myAssert(boolean u, String message) {
        if (!u) {
            throw new Error("Assertion error!!! " + message);
        }
    }

    int nextBoundedInt(int l, int r, String name) {
        int x = nextInt();
        myAssert(l <= x && x <= r, name + " = " + x + " not in [" + l + ".."
                + r + "]");
        return x;
    }

    String FNAME = "flat";

    final int MAXN = 10;
    final int MAXC = 100000;
    final int MAXA = 100;
    final int TYPES = 5;

    private void solve() throws IOException {
        int all = 0;
        int living = 0;
        int balconies = 0;

        int n = nextBoundedInt(1, MAXN, "n");
        int c = nextBoundedInt(1, MAXC, "c");
        for (int i = 0; i < n; i++) {
            int a = nextBoundedInt(1, MAXA, "a_" + (i + 1));
            String t = nextToken();
            all += a;
            if (t.equals("bedroom")) {
                living += a;
            }
            if (t.equals("balcony")) {
                balconies += a;
            }
            myAssert(t.equals("bedroom") ||
                t.equals("bathroom") ||
                t.equals("kitchen") ||
                t.equals("balcony") ||
                t.equals("other"), "Unknown word: " + t);
        }
        nextToken();
        myAssert(eof, "Extra information in input!!!");

        out.println(all);
        out.println(living);
        out.println((2 * all - balconies) * c / 2.0);
    }

}
