/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem G. Galaxy                                            */
/*                                                              */
/* Original idea         Andrew Stankevich                      */
/* Problem statement     Oleg Davydov                           */
/* Testset               Oleg Davydov                           */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Akhi                             */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.*;

public class galaxy_aa {

    public static void main(String[] args) {
        new galaxy_aa().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof = false;
    Random rand = new Random(34611256);

    void run() {
        try {
            br = new BufferedReader(new FileReader(FNAME + ".in"));
            out = new PrintWriter(FNAME + ".out");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(566);
        }
    }

    String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(nextToken());
    }

    void myAssert(boolean u, String message) {
        if (!u) {
            throw new Error("Assertion error!!! " + message);
        }
    }

    int nextBoundedInt(int l, int r, String name) {
        int x = nextInt();
        myAssert(l <= x && x <= r, name + " = " + x + " not in [" + l + ".."
                + r + "]");
        return x;
    }

    String FNAME = "galaxy";

    final int MINN = 3;
    final int MAXN = 100000;
    final int MINK = 3;
    final int MAXM = 100000;

    int k;

    private void solve() throws IOException {
        int n = nextBoundedInt(MINN, MAXN, "n");
        k = nextBoundedInt(MINK, n, "k");
        int m = nextBoundedInt(1, MAXM, "m");
        g = new ArrayList[n];
        for (int i = 0; i < g.length; i++) {
            g[i] = new ArrayList<Integer>();
        }
        for (int i = 0; i < m; i++) {
            int x = nextBoundedInt(1, n, "x_" + (i + 1)) - 1;
            int y = nextBoundedInt(1, n, "y_" + (i + 1)) - 1;
            g[x].add(y);
            g[y].add(x);
        }
        for (int i = 0; i < g.length; i++) {
            myAssert(g[i].size() < k,
                    "Node " + (i + 1) + " has degree " + g[i].size());
        }
        color = new int[n];
        u = new boolean[n];
        Arrays.fill(color, -1);
        for (int i = 0; i < k; i++) {
            color[i] = i;
            u[i] = true;
        }
        for (int i = 0; i < k; i++) {
            for (int j : g[i]) {
                if (!u[j]) {
                    dfs(j);
                }
            }
        }
        for (int i = 0; i < color.length; i++) {
            if (i > 0) {
                out.print(" ");
            }
            out.print(color[i] + 1);
        }
        out.println();
    }

    private void dfs(int x) {
        u[x] = true;
        top = 0;
        for (int i : g[x]) {
            if (u[i]) {
                buf[top++] = color[i];
            }
        }
        Arrays.sort(buf, 0, top);
        for (int i = 0; i < top; i++) {
            if (i == 0) {
                if (buf[i] > 0) {
                    color[x] = buf[i] - 1;
                    break;
                } else if (buf[top - 1] < k - 1) {
                    color[x] = k - 1;
                    break;
                }
            } else if (buf[i] - buf[i - 1] > 1) {
                color[x] = buf[i] - 1;
                break;
            }
        }
        for (int i : g[x]) {
            if (!u[i]) {
                dfs(i);
            }
        }
    }

    ArrayList<Integer>[] g;
    boolean[] u;
    int[] color;
    int[] buf = new int[MAXM];
    int top = 0;

}
