/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem H. High Security                                     */
/*                                                              */
/* Original idea         Sergey Kopeliovich                     */
/* Problem statement     Sergey Poromov                         */
/* Testset               Sergey Poromov                         */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Bannykh                          */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class high_ab {
    public static void main(String[] arg) {
        new high_ab().run();
    }

    StrictScanner in;
    PrintWriter out;
    boolean eof;


    public void run() {
        try {
            in = new StrictScanner(new FileReader("high.in"));
            out = new PrintWriter("high.out");
            solve();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        } finally {
            out.close();
        }
    }

    final int MAXN = 50000;
    final int M = 5;

    int pack(char c) {
        if ('a' <= c && c <= 'z') {
            return c - 'a';
        } else if ('A' <= c && c <= 'Z') {
            return c - 'A' + 26;
        } else if ('0' <= c && c <= '9') {
            return c - '0' + 52;
        } else {
            assert false : "Invalid character";
            return 0;
        }
    }

    void solve() throws Exception {
        int n = assertBetween(1, in.loadLine().nextInt(), MAXN, "n");
        int[][] h = new int[1 << M][n];
        for (int i = 0; i < n; ++i) {
            String s = in.loadLine().nextToken();
            assert s.length() == M : "Password is not " + M + " symbols long: \"" + s + "\"";
            for (int mask = 0; mask < (1 << M); ++mask) {
                int t = 0;
                for (int j = 0; j < M; ++j) {
                    t <<= 6;
                    if ((mask & (1 << j)) == 0) {
                        t += pack(s.charAt(j));
                    }
                }
                h[mask][i] = t;
            }
        }

        int[] df = new int[1 << M];

        for (int mask = 0; mask < (1 << M); ++mask) {
            Arrays.sort(h[mask]);
            int[] f = h[mask];
            long p = -1;
            for (int i = 0; i < f.length; ++i) {
                if (i + 1 == f.length || f[i + 1] != f[i]) {
                    long t = (i - p);
                    df[mask] += t * (t - 1) / 2;
                    p = i;
                }
            }
        }

        long[] ans = new long[M + 1];
        for (int mask = 0; mask < df.length; ++mask) {
            for (int tmask = mask; tmask > 0;) {
                tmask = (tmask - 1) & mask;
                df[mask] -= df[tmask];
            }
            ans[Integer.bitCount(mask)] += df[mask];
        }

        for (int i = 0; i < ans.length; ++i) {
            if (i != 0) {
                out.print(" ");
            }
            out.print(ans[i]);
        }
        out.println();
    }

    int assertBetween(int l, int m, int r, String name) {
        assert l <= m && m <= r : "Variable " + name + " = " + m + " not in bounds [" + l + ", " + r + "]";
        return m;
    }

    class StrictScanner extends BufferedReader {

        private String cs;
        private int cpos;

        public StrictScanner(Reader a) {
            super(a);
        }

        boolean eoln() {
            return cpos == cs.length();
        }

        StrictScanner loadLine() throws IOException {
            assert cs == null || eoln();
            cs = readLine();
            cpos = 0;
            return this;
        }

        char nextChar() {
            return cs.charAt(cpos++);
        }

        String nextToken() {
            StringBuilder sb = new StringBuilder();
            while (cpos < cs.length() && cs.charAt(cpos) != ' ') {
                sb.append(cs.charAt(cpos));
                ++cpos;
            }
            return sb.toString();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }

        double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        long nextLong() {
            return Long.parseLong(nextToken());
        }

        StrictScanner skipSpace() {
            char c = nextChar();
            assert c == ' ';
            return this;
        }
    }
}
