/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem H. High Security                                     */
/*                                                              */
/* Original idea         Sergey Kopeliovich                     */
/* Problem statement     Sergey Poromov                         */
/* Testset               Sergey Poromov                         */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Sergey Poromov                         */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.*;

public class high_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new high_sp()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;
	
	boolean eof;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "high";
	
	final int len = 5;
	final int MAXN = 50000;
	
	int mask;
	
	public void solve() throws IOException {
		int n = nextInt();
		assert (1 <= n && n <= MAXN);
		String[] s = new String[n];
		for (int i = 0; i < n; i++) {
			s[i] = nextToken();
			assert(s[i].length() == len);
			for (int j = 0; j < len; j++) {
				assert(Character.isDigit(s[i].charAt(j)) || Character.isLetter(s[i].charAt(j)));
			}
		}
		long[] cnt = new long[1 << len];
		for (mask = 0; mask < (1 << len); mask++) {
			Comparator<String> cmp = new Comparator<String>() {
				@Override
				public int compare(String o1, String o2) {
					for (int i = 0; i < len; i++) {
						if ((mask & (1 << i)) == 0) continue;
						if (o1.charAt(i) < o2.charAt(i)) return -1;
						if (o1.charAt(i) > o2.charAt(i)) return 1;
					}
					return 0;
				}
			};
			Arrays.sort(s, cmp);
			int i = 0;
			int j = 0;
			while (i < n) {
				while (j < n && cmp.compare(s[i], s[j]) == 0) {
					j++;
				}
				cnt[mask] += 1l * (j - i) * (j - i - 1) / 2;
				i = j;
			}
		}
		long[] ans = new long[len + 1];
		for (int mask = (1 << len) - 1; mask >= 0; mask--) {
			for (int mask2 = 0; mask2 < (1 << len); mask2++) {
				if (mask != mask2 && ((mask2 & mask) == mask)) {
					int t = Integer.bitCount(mask) - Integer.bitCount(mask2);
					if (t % 2 == 1) {
						cnt[mask] += cnt[mask2];
					} else {
						cnt[mask] -= cnt[mask2];
					}
				}
			}
			ans[len - Integer.bitCount(mask)] += cnt[mask];
		}
		for (int i = 0; i <= len; i++) {
			out.print(ans[i] + " ");
		}
	}
}
