/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem H. High Security                                     */
/*                                                              */
/* Original idea         Sergey Kopeliovich                     */
/* Problem statement     Sergey Poromov                         */
/* Testset               Sergey Poromov                         */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Sergey Poromov                         */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.*;
import java.util.Map.Entry;

public class high_sp_hash implements Runnable {

	public static void main(String[] args) {
		new Thread(new high_sp_hash()).start();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;
	
	boolean eof;

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "high";
	
	final int len = 5;
	final int MAXN = 50000;
	
	int mask;
	
	int KEY = 239017;
	
	public void solve() throws IOException {
		int n = nextInt();
		assert (1 <= n && n <= MAXN);
		char[][] s = new char[n][];
		for (int i = 0; i < n; i++) {
			s[i] = nextToken().toCharArray();
			assert(s[i].length == len);
			for (int j = 0; j < len; j++) {
				assert(Character.isDigit(s[i][j]) || Character.isLetter(s[i][j]));
			}
		}
		long[] cnt = new long[1 << len];
		for (mask = 0; mask < (1 << len); mask++) {
			HashMap<Long, Integer> hm = new HashMap<Long, Integer>();
			for (char[] ch : s) {
				long hash = 0;
				for (int i = 0; i < ch.length; i++) {
					if ((mask & (1 << i)) != 0) {
						hash *= KEY;
						hash += ch[i];
					}
				}
				if (!hm.containsKey(hash)) {
					hm.put(hash, 1);
				} else {
					hm.put(hash, hm.get(hash) + 1);
				}
			}
			for (Entry<Long, Integer> e : hm.entrySet()) {
				cnt[mask] += 1l * e.getValue() * (e.getValue() - 1) / 2;
			}
		}
		long[] ans = new long[len + 1];
		for (int mask = (1 << len) - 1; mask >= 0; mask--) {
			for (int mask2 = 0; mask2 < (1 << len); mask2++) {
				if (mask != mask2 && ((mask2 & mask) == mask)) {
					int t = Integer.bitCount(mask) - Integer.bitCount(mask2);
					if (t % 2 == 1) {
						cnt[mask] += cnt[mask2];
					} else {
						cnt[mask] -= cnt[mask2];
					}
				}
			}
			ans[len - Integer.bitCount(mask)] += cnt[mask];
		}
		for (int i = 0; i <= len; i++) {
			out.print(ans[i] + " ");
		}
	}
}
