/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem I. Immediate Delivery                                */
/*                                                              */
/* Original idea         Pavel Mavrin                           */
/* Problem statement     Pavel Mavrin                           */
/* Testset               Pavel Mavrin                           */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Akhi                             */
/*--------------------------------------------------------------*/
 
import java.io.*;
import java.util.*;

public class immediate_aa {

    public static void main(String[] args) {
        new immediate_aa().run();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof = false;
    Random rand = new Random(34611256);

    void run() {
        try {
            br = new BufferedReader(new FileReader(FNAME + ".in"));
            out = new PrintWriter(FNAME + ".out");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(566);
        }
    }

    String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(nextToken());
    }

    void myAssert(boolean u, String message) {
        if (!u) {
            throw new Error("Assertion error!!! " + message);
        }
    }

    int nextBoundedInt(int l, int r, String name) {
        int x = nextInt();
        myAssert(l <= x && x <= r, name + " = " + x + " not in [" + l + ".."
                + r + "]");
        return x;
    }

    String FNAME = "immediate";

    final int MAXN = 20;
    final int MAXT = 1000;

    int[][] a, p, b, w;

    private void solve() throws IOException {
        int n = nextBoundedInt(1, MAXN, "n");
        int m = nextInt();
        a = new int[n][n];
        for (int i = 0; i < a.length; i++) {
            Arrays.fill(a[i], Integer.MAX_VALUE / 4);
        }
        for (int i = 0; i < m; i++) {
            int x = nextBoundedInt(1, n, "x_" + (i + 1)) - 1;
            int y = nextBoundedInt(1, n, "y_" + (i + 1)) - 1;
            int t = nextBoundedInt(1, MAXT, "t_" + (i + 1));
            a[x][y] = Math.min(a[x][y], t);
            a[y][x] = a[x][y];
        }
        p = new int[n][n];
        for (int i = 0; i < p.length; i++) {
            Arrays.fill(p[i], -1);
        }
        for (int k = 0; k < a.length; k++) {
            for (int i = 0; i < a.length; i++) {
                for (int j = 0; j < a.length; j++) {
                    if (a[i][j] > a[i][k] + a[k][j]) {
                        a[i][j] = a[i][k] + a[k][j];
                        p[i][j] = k;
                    }
                }
            }
        }
        b = new int[1 << n][n];
        w = new int[1 << n][n];
        for (int i = 0; i < b.length; i++) {
            Arrays.fill(b[i], Integer.MAX_VALUE / 4);
            Arrays.fill(w[i], -1);
        }
        b[1][0] = 0;
        for (int i = 0; i < b.length; i++) {
            for (int j = 0; j < b[i].length; j++) {
                if ((i & (1 << j)) == 0 || b[i][j] >= Integer.MAX_VALUE / 4) {
                    continue;
                }
                for (int k = 0; k < n; k++) {
                    if ((i & (1 << k)) != 0
                            || b[i | (1 << k)][k] < b[i][j] + a[j][k]) {
                        continue;
                    }
                    b[i | (1 << k)][k] = b[i][j] + a[j][k];
                    w[i | (1 << k)][k] = j;
                }
            }
        }
        int mini = 0;
        int minj = 0;
        int mink = 0;
        int min = Integer.MAX_VALUE / 2;
        for (int i = 0; i < b.length; i++) {
            for (int j = 0; j < b[i].length; j++) {
                if ((i & (1 << j)) == 0) {
                    continue;
                }
                int prof = (i ^ ((1 << n) - 1)) | 1;
                for (int k = 0; k < b[prof].length; k++) {
                    if ((prof & (1 << k)) == 0) {
                        continue;
                    }
                    int val = Math.max(b[i][j], b[prof][k]);
                    if (min > val) {
                        min = val;
                        mini = i;
                        minj = j;
                        mink = k;
                    }
                }
            }
        }
        out.println(min);
        ArrayList<Integer> path1 = restorePath(mini, minj);
        ArrayList<Integer> path2 = restorePath((((1 << n) - 1) ^ mini) | 1,
                mink);
        out.print(path1.size() - 1);
        for (int i : path1) {
            out.print(" " + i);
        }
        out.println();
        out.print(path2.size() - 1);
        for (int i : path2) {
            out.print(" " + i);
        }
        out.println();
    }

    private ArrayList<Integer> restorePath(int prof, int x) {
        ArrayList<Integer> ans = new ArrayList<Integer>();
        while (prof != 1) {
            ans.addAll(getPath(w[prof][x], x));
            int nx = w[prof][x];
            prof ^= (1 << x);
            x = nx;
        }
        ans.add(1);
        Collections.reverse(ans);
        return ans;
    }

    private ArrayList<Integer> getPath(int i, int j) {
        if (i == j) {
            return new ArrayList<Integer>();
        }
        ArrayList<Integer> ans = new ArrayList<Integer>();
        int k = p[i][j];
        if (k < 0) {
            ans.add(j + 1);
            return ans;
        }
        ans.addAll(getPath(k, j));
        ans.addAll(getPath(i, k));
        return ans;
    }

}
