/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem K. Kids Like Cakes                                   */
/*                                                              */
/* Original idea         Georgiy Korneev                        */
/* Problem statement     Yury Petrov                            */
/* Testset               Yury Petrov                            */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Anton Bannykh                          */
/*--------------------------------------------------------------*/
 
import java.io.*;

public class kids_ab {
    public static void main(String[] arg) {
           new kids_ab().run();
    }

    StrictScanner in;
    PrintWriter out;
    boolean eof;


    public void run() {
        try {
            String problemName = this.getClass().getName().split("_")[0];
            in = new StrictScanner(new FileReader(problemName + ".in"));
            out = new PrintWriter(problemName + ".out");
            solve();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        } finally {
            out.close();
        }
    }

    final int MAXN = 5000;
    final int MAX = 100000000;

    void solve() throws Exception {
        int n = assertBetween(4, in.loadLine().nextInt(), MAXN, "n");
        long[] x = new long[n];
        long[] y = new long[n];
        for (int i = 0; i < n; ++i) {
            x[i] = assertBetween(-MAX, in.loadLine().nextInt(), MAX, "x_{" + (i + 1) + "}");
            y[i] = assertBetween(-MAX, in.skipSpace().nextInt(), MAX, "y_{" + (i + 1) + "}");
        }

        long ans = Long.MIN_VALUE;

        int max_i, max_j, max_k;
        int min_i;
        max_i = max_j = max_k = min_i = -1;

        for (int i = 0; i < n; ++i) {
            long min_sq = Long.MAX_VALUE / 4;
            long max_sq = Long.MIN_VALUE / 4;
            int j, k, pk, next, prev, prev2;
            k = (i + 3) % n;
            j = pk = (i + 2) % n;
            next = prev = (i + 1) % n;
            prev2 = i;

            int ms = i;

            for (; j != i; prev2 = prev, prev = j, j = (j + 1) % n) {
                long ta = Math.abs((x[prev] - x[j]) * (y[prev2] - y[j]) - (y[prev] - y[j]) * (x[prev2] - x[j]));
                if (min_sq > ta) {
                    min_sq = ta;
                    ms = prev2;
                }
                max_sq = Math.abs((x[j] - x[i]) * (y[pk] - y[i]) - (y[j] - y[i]) * (x[pk] - x[i]));
                while (k != i && max_sq < (ta = Math.abs((x[j] - x[i]) * (y[k] - y[i]) - (y[j] - y[i]) * (x[k] - x[i])))) {
                    max_sq = ta;
                    pk = k;
                    k = (k + 1) % n;
                }

                if (max_sq - min_sq > ans) {
                    ans = max_sq - min_sq ;
                    max_i = i;
                    max_j = j;
                    max_k = pk;
                    min_i = ms;
                }
            }
        }
        out.printf("%d.%d\n", ans / 2, (ans % 2) * 5);
        out.println((max_i + 1) + " " + (max_j + 1) + " " + (max_k + 1));
        out.println((min_i + 1) + " " + ((min_i + 1) % n + 1) + " " + ((min_i + 2) % n + 1));
    }

    int assertBetween(int l, int m, int r, String name) {
        assert l <= m && m <= r : "Variable " + name + " = " + m + " not in bounds [" + l + ", " + r + "]";
        return m;
    }

    class StrictScanner extends BufferedReader {

        private String cs;
        private int cpos;

        public StrictScanner(Reader a) {
            super(a);
        }

        boolean eoln() {
            return cpos == cs.length();
        }

        StrictScanner loadLine() throws IOException {
            assert cs == null || eoln();
            cs = readLine();
            cpos = 0;
            return this;
        }

        char nextChar() {
            return cs.charAt(cpos++);
        }

        String nextToken() {
            StringBuilder sb = new StringBuilder();
            while (cpos < cs.length() && cs.charAt(cpos) != ' ') {
                sb.append(cs.charAt(cpos));
                ++cpos;
            }
            return sb.toString();
        }

        int nextInt() {
            return Integer.parseInt(nextToken());
        }

        double nextDouble() {
            return Double.parseDouble(nextToken());
        }

        long nextLong() {
            return Long.parseLong(nextToken());
        }

        StrictScanner skipSpace() {
            char c = nextChar();
            assert c == ' ';
            return this;
        }
    }
}
