import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;


public class B {
	private static String problem = "black";
	
	BufferedReader in;
	PrintWriter out;
	
	private StringTokenizer st = null;
	
	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			st = new StringTokenizer(line);
		}
		
		return st.nextToken();		
	}
	
	public String next() throws IOException {
		return nextToken();
	}
	
	public int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader(problem + ".in"));
		out = new PrintWriter(problem + ".out");
		solve();
		in.close();
		out.close();
	}
	
	public void solve() throws Exception {
		int m = nextInt();
		int n = nextInt();
		int s = nextInt();
		int k = nextInt();
		int begin = n, end = 0;
		boolean impossible = false;
		String str = next();
		if (m < s || n < s) {
			out.println("Impossible");
			return;
		}
		for (int i = 0; i < n; ++i) {
			char c = str.charAt(i);
			if (c == '.') {
				if (begin < i && end == 0) {
					end = i;
				}
				continue;
			} else {
				if (end > 0) {
					impossible = true;
					break;
				}
				if (begin == n) {
					begin = i;
				}
			}
		}
		if (begin == n) {
			if (k - 1 < s && m - k == s || k - 1 == s && m - k < s) {
				if (n == s) {
					out.println("Unique");
				} else {
					out.println("Ambiguous");
				}
				return;
			}
			if (k - 1 < s && m - k < s) {
				out.println("Impossible");
				return;
			}
			out.println("Ambiguous");
			return;
		}
		if (end == 0) {
			end = n;
		}
		if (impossible || (end - begin != s)) {
			out.println("Impossible");
			return;
		}
		int firstRow = Math.max(1, k - s + 1);
		int lastRow = Math.min(m, k + s - 1);
		if (lastRow - firstRow + 1 == s) {
			out.println("Unique");
		} else {
			out.println("Ambiguous");
		}
	}
	
	public static void main(String[] args) throws Exception {
		new B().run();
	}
}
