import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashSet;
import java.util.Locale;
import java.util.StringTokenizer;


public class C {
	private static String problem = "cube";
	
	private C() {}
	
	BufferedReader in;
	PrintWriter out;
	
	private String line = null;
	private StringTokenizer st = null;
	
	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			st = new StringTokenizer(line);
		}
		
		return st.nextToken();		
	}
	
	public int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader(problem + ".in"));
		out = new PrintWriter(problem + ".out");
		solve();
		in.close();
		out.close();
	}
	
	ArrayList<String> ans = new ArrayList<String>();
	String[] v = new String[6];
	
	public boolean nextPermutation(int[] a) {
		int i;
		for (i = a.length - 2; i >= 0; --i) {
			if (a[i] < a[i + 1]) {
				break;
			}		
			
		}	
		if (i == -1) {
			return false;			
		}
		int mj = -1;
		int m = -1;
		for (int j = i + 1; j < a.length; ++j) {
			if ((a[j] < m || mj == -1) && a[j] > a[i]) {
				mj = j;
				m = a[j];
			}
		}
		
		a[mj] = a[i];
		a[i] = m;
		Arrays.sort(a, i + 1, a.length);
		
		return true;
	}
	
	public boolean nextPermutation(char[] a) {
		int i;
		for (i = a.length - 2; i >= 0; --i) {
			if (a[i] < a[i + 1]) {
				break;
			}			
		}	
		if (i == -1) {
			return false;			
		}
		int mj = -1;
		char m = 0;
		for (int j = i + 1; j < a.length; ++j) {
			if ((a[j] < m || mj == -1) && a[j] > a[i]) {
				mj = j;
				m = a[j];
			}
		}
		
		a[mj] = a[i];
		a[i] = m;
		Arrays.sort(a, i + 1, a.length);
		
		return true;
	}
	
	public Collection<String> generateAll(String s) {
		ArrayList<String> res = new ArrayList<String>();
		int[][] a = {{0, 1, 2, 3, 4, 5}, {1, 0, 4, 5, 2, 3}, {2, 1, 5, 3, 0, 4}};
		for (int i = 0; i < 3; ++i) {
			char[] q = new char[s.length()];
			for (int j = 0; j < 4; ++j) {
				q[0] = s.charAt(a[i][0]);
				q[5] = s.charAt(a[i][5]);
				for (int k = 0; k < 4; ++k) {
					q[k + 1] = s.charAt(a[i][1 + (j + k) % 4]);
				}
				res.add(new String(q));
				for (int k = 0; k < 3; ++k) {
					char t = q[k];
					q[k] = q[5 - k];
					q[5 - k] = t;
				}
				res.add(new String(q));
			}
		}
		return res;
	}
	
	public void solve() throws Exception {
		char[] a = new char[6];
		for (int i = 0; i < 6; ++i) {
			v[i] = nextToken();
			a[i] = v[i].charAt(0);
		}			
		
		int[] b = {5, 3, 4, 1, 2, 0};
				
		Arrays.sort(a);
		
		
		
		ArrayList<String> ans = new ArrayList<String>();
		HashSet<String> added = new HashSet<String>();
		
		do {
			int[] c = new int[6];
			for (int i = 0; i < 6; ++i) {
				c[i] = i;
			}
			boolean found = false;
			do {				
				boolean ok = true;
				for (int i = 0; i < 6; ++i) {
					if (a[c[i]] != v[i].charAt(0)) {
						ok = false;
						break;
					}
					char[] z1 = new char[4];
					for (int j = 0; j < 4; ++j) {
						z1[j] = v[i].charAt(j + 1);
					}
					char[] z2 = new char[4];
					for (int j = 0, k = 0; j < 6; ++j) {
						if (j == c[i] || j == b[c[i]]) {
							continue;
						}
						z2[k] = a[j];
						++k;
					}
					Arrays.sort(z1);
					Arrays.sort(z2);
					if (!Arrays.equals(z1, z2)) {
						ok = false;
						break;
					}
				}
				if (ok) {
					found = true;
					break;
				}
				
			} while (nextPermutation(c));
			
			if (found) {
				String ss = new String(a);
				if (!added.contains(ss)) {
					ans.add(ss);
					added.addAll(generateAll(ss));
//					System.err.println(ss);
//					System.err.println(generateAll(ss));
//					System.err.println("---");
				}
			}
			
			if (ans.size() == 2) {
				break;
			}
//			break;
		} while (nextPermutation(a));

		if (ans.size() == 0) {
			out.println("Impossible");			
		} else {
			for (String s: ans) {
				out.println(s);
			}
		}
	}
	
	public static void main(String[] args) throws Exception {
		new C().run();
	}
	

}
