import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;


public class D {
	private static String problem = "dice";
	
	BufferedReader in;
	PrintWriter out;
	
	private String line = null;
	private StringTokenizer st = null;
	
	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			st = new StringTokenizer(line);
		}
		
		return st.nextToken();		
	}
	
	public int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader(problem + ".in"));
		out = new PrintWriter(problem + ".out");
		solve();
		in.close();
		out.close();
	}
	
	class E implements Comparable<E> {
		int no, k;
		
		@Override
		public int compareTo(E o) {
			return k - o.k;
		}
	}
	
	public void solve() throws Exception {
		int n = nextInt();
		E[] es = new E[n];
		int sum = 0;
		for (int i = 0; i < n; i++) {
			es[i] = new E();
			es[i].k = nextInt();
			sum += es[i].k;
			es[i].no = i;
		}
		
		Arrays.sort(es);
		String[] ans = new String[n];
		double sa = 0;
		for (E e : es) {
			double x = (2 * sum - e.k + 1) / (double) 2;
//			System.err.println(x);
			sa += x;
			
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < e.k; i++) {
				sb.append((sum - i) + " ");
			}
			ans[e.no] = sb.toString(); 
			sum -= e.k;
		}
		
		out.printf("%.5f\n", sa);
		for (int i = 0; i < n; i++) {
			out.println(ans[i]);
		}
	}
	
	public static void main(String[] args) throws Exception {
		new D().run();
	}
	

}
