import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.StringTokenizer;

import javax.swing.text.MaskFormatter;


public class H {
	private static String problem = "high";
	
	BufferedReader in;
	PrintWriter out;
	
	private String line = null;
	private StringTokenizer st = null;
	
	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			st = new StringTokenizer(line);
		}
		
		return st.nextToken();		
	}
	
	public int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader(problem + ".in"));
		out = new PrintWriter(problem + ".out");
		solve();
		in.close();
		out.close();
	}
	
	public static class MaskComparator implements Comparator<String> {
		private int mask;
		public MaskComparator(int mask) {
			this.mask = mask;			
		}
		@Override
		public int compare(String o1, String o2) {			
			for (int i = 0, z = 1; i < 5; ++i, z *= 2) {
				if ((mask & z) == 0) {
					continue;
				}
				int res = o1.charAt(i) - o2.charAt(i);
				if (res != 0) {
					return res;
				}
			}			
			return 0;
		}
		
		
	}
	
	public void solve() throws Exception {
		int n = nextInt();
		String[] a = new String[n];
		for (int i = 0; i < n; ++i) {
			a[i] = nextToken();
		}
		
		long[] eq = new long[7];
		int M = 1 << 5;
		long[] b = new long[M];
		
		for (int mask = 0; mask < M; ++mask) {
			MaskComparator mc = new MaskComparator(mask);
			Arrays.sort(a, mc);
			int begin = 0;
			for (int i = 1; i < n; ++i) {
				if (mc.compare(a[i-1], a[i]) != 0) {
					long t = i - begin;
					b[mask] += t * (t - 1) / 2; 
					begin = i;
				}				
			}
			long t = n - begin;
			b[mask] += t * (t - 1) / 2;
			
		}		 
		
		long[] c = new long[M];
		long[] eqe = new long[6];
		for (int mask = M - 1; mask >= 0; --mask) {
			c[mask] = b[mask];
			for (int mask1 = 0; mask1 < M; ++mask1) {
				if (mask1 == mask) {
					continue;
				}
				if ((mask1 & mask) != mask) {
					continue;					
				}
				c[mask] -= c[mask1];				
			}
			eqe[Integer.bitCount(mask)] += c[mask];
		}
		
		for (int i = 0; i < 6; ++i) {
			out.print(eqe[5 - i] + " ");
		}
		out.println();
	}
	
	public static void main(String[] args) throws Exception {
		new H().run();
	}
	

}
