import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;


public class I {
	private static String problem = "immediate";
	
	BufferedReader in;
	PrintWriter out;
	
	private String line = null;
	private StringTokenizer st = null;
	
	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			st = new StringTokenizer(line);
		}
		
		return st.nextToken();		
	}
	
	public int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader(problem + ".in"));
		out = new PrintWriter(problem + ".out");
		solve();
		in.close();
		out.close();
	}
	
	int get(int m, int i) {
		return (m >> i) & 1;
	}
	int set(int m, int i, int v) {
		int lv = get(m, i);
		if (lv == v) {
			return m;
		}
		return m ^ (1 << i);
	}

	int n;
	int[][] ts;
	int[] d;
	int[] sd;
	
	void goPrint(int m) {
		for (int i = 0; i < n; i++) {
			int nfv = set(m, i, 1);
			if (sd[nfv] == sd[m]) {
				m = nfv;
			}
		}
//		out.println(Integer.toBinaryString(m));
		
		int cv = -1;
		for (int i = 0; i < n; i++) {
			int nm = (m << 5) | i;
			if (d[nm] == sd[m]) {
				cv = i;
			}
		}
		if (cv == -1) {
			throw new RuntimeException("cv == -1"); 
		}

		List<Integer> ans = new ArrayList<Integer>();
		while (m != 1) {
			ans.add(cv);
			int c = (m << 5) | cv;
			for (int pv = 0; pv < n; pv++) {
				if (ts[pv][cv] != -1) {
					int pm = m;
					if (d[(pm << 5) | pv] == d[c] - ts[pv][cv]) {
						cv = pv;
						m = pm;
						break;
					} else {
						pm = set(m, cv, 0);
						if (d[(pm << 5) | pv] == d[c] - ts[pv][cv]) {
							cv = pv;
							m = pm;
							break;
						}
					}
				}
			}
		}
		ans.add(cv);
		
		out.print((ans.size() - 1) + " ");
		for (int i = ans.size() - 1; i >= 0; i--) {
			out.print((ans.get(i) + 1) + " ");
		}
		out.println();
	}
	
	public void solve() throws Exception {
		n = nextInt();
		int mm = nextInt();
		
		ts = new int[n][n];
		for (int i = 0; i < n; i++) {
			Arrays.fill(ts[i], -1);
		}
		for (int i = 0; i < mm; i++) {
			int a = nextInt() - 1;
			int b = nextInt() - 1;
			int t = nextInt();
			ts[a][b] = t;
			ts[b][a] = t;
		}
		
		int M = 1 << n;
		int INF = Integer.MAX_VALUE / 2;
		d = new int[M << 5];
		Arrays.fill(d, INF);

		int vM = (1 << 5) - 1;
		d[1 << 5] = 0; 
		TreeSet<Integer> s = new TreeSet<Integer>(new Comparator<Integer>() {
			public int compare(Integer o1, Integer o2) {
				if (d[o1] != d[o2]) {
					return d[o1] - d[o2];
				}
				return o1 - o2;
			}
		});
		s.add(1 << 5);
		
		while (s.size() > 0) {
			int vv = s.first();
			s.remove(vv);
			int m = vv >> 5;
			int v = vv & vM;
			for (int i = 0; i < n; i++) {
				if (ts[v][i] != -1) {
					int nd = d[vv] + ts[v][i];
					int nm = set(m, i, 1);
					int nv = (nm << 5) | i;
					if (d[nv] > nd) {
						d[nv] = nd;
						s.remove(nv);
						s.add(nv);
					}
				}
			}
		}
		
		sd = new int[M];
		Arrays.fill(sd, INF);
		for (int i = 0; i < M; i++) {
			int t = i << 5;
			for (int j = 0; j < n; j++) {
				sd[i] = Math.min(sd[i], d[t + j]);
			}
		}
		for (int i = M - 1; i >= 0; i--) {
			for (int j = 0; j < n; j++) {
				if (get(i, j) == 1) {
					int nm = set(i, j, 0);
					sd[nm] = Math.min(sd[nm], sd[i]);
				}
			}
//			out.println(Integer.toBinaryString(i) + " " + sd[i]);
		}
		
		int minM = 0;
		int v = INF;
		for (int i = 0; i < M; i++) {
			int nm = (M - 1) ^ i;
			int cv = Math.max(sd[i], sd[nm]);
			if (v > cv) {
				v = cv;
				minM = i;
			}
		}
		out.println(v);
		
		goPrint(minM);
		goPrint((M - 1) ^ minM);
	}
	
	public static void main(String[] args) throws Exception {
		new I().run();
	}
	

}
