import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TreeMap;


public class J {
	private static String problem = "john";
	
	private J() {}
	
	BufferedReader in;
	PrintWriter out;
	
	private StringTokenizer st = null;
	
	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			st = new StringTokenizer(line);
		}
		
		return st.nextToken();		
	}
	
	public int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader(problem + ".in"));
		out = new PrintWriter(problem + ".out");
		solve();
		in.close();
		out.close();
	}
	
	class Pair {
		public int f, s;
		public Pair(int f, int s) {
			this.f = f;
			this.s = s;
		}
	}
	
	final int N = 1 << 17;
	int[] tr = new int[N * 2];
	
	void inc(int n, int l, int r, int c) {
		++tr[n];
		if (l + 1 == r) {
			return;
		}
		int m = (l + r) / 2;
		if (c < m) {
			inc(n * 2 + 1, l, m, c);
		} else {
			inc(n * 2 + 2, m, r, c);
		}
	}
	
	int sum(int n, int L, int R, int l, int r) {
		if (L == l && R == r) {
			return tr[n];
		}
		int m = (L + R) / 2;
		if (r <= m) {
			return sum(n * 2 + 1, L, m, l, r);
		}
		if (l >= m) {
			return sum(n * 2 + 2, m, R, l, r);
		}
		return sum(n * 2 + 1, L, m, l, m) + sum(n * 2 + 2, m, R, m, r);
	}
	
	public void solve() throws Exception {
		int n = nextInt();
		Pair[] pr = new Pair[n];
		for (int i = 0; i < n; ++i) {
			int f = nextInt();
			int s = nextInt();
			pr[i] = new Pair(f, s);
		}
		Arrays.sort(pr, new Comparator<Pair>() {
			@Override
			public int compare(Pair o1, Pair o2) {
				if (o1.f != o2.f) {
					return o1.f - o2.f;
				}
				return o1.s - o2.s;
			}
		});
		Map<Integer, Integer> tm = new TreeMap<Integer, Integer>();
		for (Pair p : pr) {
			tm.put(p.s, 0);
		}
		int q = 0;
		for (Map.Entry<Integer, Integer> me : tm.entrySet()) {
			me.setValue(++q);
		}
		long ans = 0;
		for (Pair p : pr) {
			p.s = tm.get(p.s);
			inc(0, 0, N, p.s);
			ans += sum(0, 0, N, p.s + 1, N);
		}
		out.println(ans);
	}
	
	public static void main(String[] args) throws Exception {
		new J().run();
	}
	

}
