import java.io.*;
import java.util.*;
import java.math.*;

public class C {
	View[] views = new View[6];

	void solve() throws IOException {
		boolean[] u = new boolean[26];
		for (int i = 0; i < views.length; i++) {
			char[] v = next().toCharArray();
			Arrays.sort(v, 1, 5);
			for (int j = 0; j < v.length; j++) {
				u[v[j] - 'A'] = true;
			}
			views[i] = new View(v);
		}
		Arrays.sort(views);
		int cnt = 0;
		char[] letters = new char[6];
		for (int i = 0; i < u.length; i++) {
			if (u[i]) {
				if (cnt < 6) {
					letters[cnt] = (char) ('A' + i);
				}
				cnt++;
			}
		}
		if (cnt > 6) {
			out.println("Impossible");
			return;
		}
		rotates();
		int[] a = new int[6];
		HashSet<ArrayContainer> hs = new HashSet<C.ArrayContainer>();
		ArrayList<int[]> ans = new ArrayList<int[]>();
		ArrayContainer aca = new ArrayContainer(a);
		fr: for (int i0 = 0; i0 < cnt; i0++) {
			a[0] = letters[i0];
			for (int i1 = 0; i1 < cnt; i1++) {
				a[1] = letters[i1];
				for (int i2 = 0; i2 < cnt; i2++) {
					a[2] = letters[i2];
					for (int i3 = 0; i3 < cnt; i3++) {
						a[3] = letters[i3];
						for (int i4 = 0; i4 < cnt; i4++) {
							a[4] = letters[i4];
							for (int i5 = 0; i5 < cnt; i5++) {
								a[5] = letters[i5];
//								System.err.println(Arrays.toString(a) + " "
//										+ check(a));
								if (check(a)
										&& !hs.contains(aca)) {
									ans.add(a.clone());
									if (ans.size() >= 2) {
										break fr;
									}
									for (ArrayContainer ac : rotates) {
										hs.add(new ArrayContainer(
												apply(a, ac.a)));
									}
								}
							}
						}
					}
				}
			}
		}
		if (ans.isEmpty()) {
			out.println("Impossible");
		} else {
			System.err.println(ans);
			for (int[] aa : ans) {
				for (int i = 0; i < aa.length; i++) {
					out.print((char) aa[i]);
				}
				out.println();
			}
		}
	}

	class View implements Comparable<View> {
		char[] c;

		public View(char[] c) {
			super();
			this.c = c;
		}

		@Override
		public int compareTo(View o) {
			for (int i = 0; i < c.length; i++) {
				if (c[i] < o.c[i]) {
					return -1;
				}
				if (c[i] > o.c[i]) {
					return 1;
				}
			}
			return 0;
		}

		@Override
		public String toString() {
			return new String(c);
		}

	}

	View[] mv = new View[6];
	{
		for (int i = 0; i < mv.length; i++) {
			mv[i] = new View(new char[5]);
		}
	}

	private boolean check(int[] a) {
		for (int i = 0; i < a.length; i++) {
			mv[i].c[0] = (char) a[i];
			int t = 1;
			for (int j = 0; j < a.length; j++) {
				if (j == i || j == FORB[i]) {
					continue;
				}
				mv[i].c[t++] = (char) a[j];
			}
			Arrays.sort(mv[i].c, 1, 5);
		}
		Arrays.sort(mv);
//		System.err.println(Arrays.toString(mv) + " " + Arrays.toString(views));
		for (int i = 0; i < mv.length; i++) {
			if (!Arrays.equals(mv[i].c, views[i].c)) {
				return false;
			}
		}
		return true;
	}

	int[] FORB = { 5, 3, 4, 1, 2, 0 };
	int[][] R = { { 0, 2, 3, 4, 1, 5 }, { 1, 2, 5, 0, 4, 3 } };

	static class ArrayContainer {
		int[] a;

		public ArrayContainer(int[] a) {
			super();
			this.a = a;
		}

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + Arrays.hashCode(a);
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			ArrayContainer other = (ArrayContainer) obj;
			if (!Arrays.equals(a, other.a))
				return false;
			return true;
		}

	}

	HashSet<ArrayContainer> rotates;
	Random rand = new Random(1);

	void rotates() {
		rotates = new HashSet<C.ArrayContainer>();
		int[] r = new int[6];
		for (int i = 0; i < 6; i++) {
			r[i] = i;
		}
		while (rotates.size() < 24) {
			r = apply(r, R[rand.nextInt(2)]);
			rotates.add(new ArrayContainer(r));
		}

	}

	private int[] apply(int[] r2, int[] perm) {
		int[] res = new int[6];
		for (int i = 0; i < res.length; i++) {
			res[i] = r2[perm[i]];
		}
		return res;
	}

	static final String FILENAME = "cube";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new C().run();
	}
}
