import java.io.*;
import java.util.*;
import java.math.*;

public class D {
	
	static class Num implements Comparable<Num>{
		int val, id;

		public Num(int val, int id) {
			super();
			this.val = val;
			this.id = id;
		}
		
		@Override
		public int compareTo(Num o) {
			return val - o.val;
		}
	}
	
	void solve() throws IOException {
		int n = nextInt();
		Num[] a = new Num[n];
		int sum = 0;
		for (int i = 0; i < n; i++) {
			a[i] = new Num(nextInt(), i);
			sum += a[i].val;
		}
		Arrays.sort(a);
		ArrayList<Integer>[] ans = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			ans[i] = new ArrayList<Integer>();
		}
		int it = sum;
		for (Num i : a) {
			for (int j = 0; j < i.val; j++) {
				ans[i.id].add(it--);
			}
		}
		double sumAns = 0;
		for (ArrayList<Integer> al : ans) {
			double s = 0;
			for (int i : al) {
				s += i;
			}
			sumAns += s / al.size(); 
		}
		
		out.println(sumAns);
		for (int i = 0; i < n; i++) {
			Collections.sort(ans[i]);
			for (int j : ans[i]) {
				out.print(j + " ");
			}
			out.println();
		}
	}

	static final String FILENAME = "dice";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new D().run();
	}
}
