import java.io.*;
import java.util.*;
import java.math.*;

public class G {
	
	ArrayList<Integer>[] g;
	
	int[] color;
	boolean[] used;
	
	int k;
	
	void dfs(int v) {
		used[v] = true;
		if (color[v] == -1) {
			boolean[] usedColors = new boolean[k];
			for (int to : g[v])
				if (color[to] != -1)
					usedColors[color[to]] = true;
			for (int i = 0; i < k; i++)
				if (!usedColors[i] && usedColors[(i + 1) % k]) {
					color[v] = i;
					break;
				}
		}
		
		for (int to : g[v])
			if (!used[to])
				dfs(to);
	}
	
	void solve() throws IOException {
		int n = nextInt();
		k = nextInt();
		int m = nextInt();
		
		g = new ArrayList[n];
		for (int i = 0; i < n; i++)
			g[i] = new ArrayList<Integer>();
		
		for (int i = 0; i < m; i++) {
			int v1 = nextInt() - 1;
			int v2 = nextInt() - 1;
			if (v1 < k && v2 < k && Math.abs(v1 - v2) != 1 && Math.abs(v1 - v2) != k - 1)
				throw new AssertionError();
			g[v1].add(v2);
			g[v2].add(v1);
		}
		
		color = new int[n];
		Arrays.fill(color, -1);
		for (int i = 0; i < k; i++)
			color[i] = i;
		used = new boolean[n];
		
		dfs(0);
		
		for (int i : color)
			out.print(i + 1 + " ");
	}

	static final String FILENAME = "galaxy";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new G().run();
	}
}
