import java.io.*;
import java.util.*;
import java.math.*;

public class H {
	String[] a;
	char[][] s;

	static class State {
		int L, R, pos, rem;

		public State(int l, int r, int pos, int rem) {
			super();
			L = l;
			R = r;
			this.pos = pos;
			this.rem = rem;
		}

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + L;
			result = prime * result + R;
			result = prime * result + pos;
			result = prime * result + rem;
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			State other = (State) obj;
			if (L != other.L)
				return false;
			if (R != other.R)
				return false;
			if (pos != other.pos)
				return false;
			if (rem != other.rem)
				return false;
			return true;
		}

	}

	HashMap<State, Long> hm = new HashMap<H.State, Long>();

	long calc(int L, int R, int pos, int rem) {
		State ss = new State(L, R, pos, rem);
		if (hm.containsKey(ss)) {
			return hm.get(ss);
		}
		if (rem < 0) {
			return 0;
		}
		if (pos == 5) {
			return (R - L) * (R - L - 1L) / 2;
		}
		long res = 0;
		int prev = L;
		for (int i = L; i < R; i++) {
			if (i > L && s[i][pos] != s[prev][pos]) {
				res += calc(prev, i, pos + 1, rem);
				res -= calc(prev, i, pos + 1, rem - 1);
				prev = i;
			}
		}
		res += calc(prev, R, pos + 1, rem);
		res -= calc(prev, R, pos + 1, rem - 1);
		res += calc(L, R, pos + 1, rem - 1);
		hm.put(ss, res);
		return res;
	}

	void solve() throws IOException {
		int n = nextInt();
		a = new String[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = next();
		}
		Arrays.sort(a);
		s = new char[n][];
		for (int i = 0; i < a.length; i++) {
			s[i] = a[i].toCharArray();
		}
		long[] res = new long[6];
		for (int i = 0; i < res.length; i++) {
			res[i] = calc(0, n, 0, i);
		}
		for (int i = res.length - 1; i > 0; i--) {
			res[i] -= res[i - 1];
		}
		for (int i = 0; i < res.length; i++) {
			out.print(res[i] + " ");
		}
		// System.err.println(Arrays.toString(res));
	}

	static final String FILENAME = "high";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new H().run();
	}
}
