import java.io.*;
import java.util.*;
import java.math.*;

public class J {
	
	long inversions(int[] a) {
		if (a.length < 2) {
			return 0;
		}
		int n = a.length;
		int n1 = a.length / 2;
		int n2 = n - a.length / 2;
		int[] L = new int[n1];
		int[] R = new int[n2];
		for (int i = 0; i < n1; i++) {
			L[i] = a[i];
		}
		for (int i = 0; i < n2; i++) {
			R[i] = a[n1 + i];
		}
		long ans = inversions(L) + inversions(R);
//		System.err.println(Arrays.toString(L) + " " + Arrays.toString(R));
		int p = 0;
		for (int i = 0; i < n1; i++) {
			while (p < n2 && R[p] < L[i]) {
				p++;
			}
			ans = ans + p;
		}
		int p1 = 0;
		int p2 = 0;
		p = 0;
		while ((p1 < n1 || p2 < n2)) {
			if (p1 != n1 && (p2 == n2 || L[p1] < R[p2])) {
				a[p++] = L[p1++];
			} else {
				a[p++] = R[p2++];
			}
		}
		return ans;
	}
	
	static class Pair implements Comparable<Pair> {
		int a, b;

		public Pair(int a, int b) {
			super();
			this.a = a;
			this.b = b;
		}
		
		@Override
		public int compareTo(Pair o) {
			if (a != o.a) {
				return a - o.a;
			} 
			return b - o.b;
		}
	}
	
	void solve() throws IOException {
		int n = nextInt();
		Pair[] a = new Pair[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Pair(nextInt(), nextInt());
		}
		Arrays.sort(a);
		int[] first = new int[n];
		int[] second = new int[n];
		for (int i = 0; i < n; i++) {
			first[i] = a[i].a;
			second[i] = a[i].b;
		}
//		System.err.println(inversions(new int[] { 3 ,2,1, 3, 4, 5}));
		long ans = inversions(first) + inversions(second);
		out.println(ans);
	}

	static final String FILENAME = "john";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new J().run();
	}
}
