import java.io.*;
import java.util.*;
import java.math.*;

public class K {

	static class Point {
		long x, y;
		int id;

		public Point(long x, long y, int id) {
			super();
			this.x = x;
			this.y = y;
			this.id = id;
		}

		@Override
		public String toString() {
			return "(" + x + ", " + y + ")";
		}
	}

	long s(Point a, Point b, Point c) {
		long abx = b.x - a.x;
		long aby = b.y - a.y;
		long acx = c.x - a.x;
		long acy = c.y - a.y;
		return Math.abs(abx * acy - aby * acx);
	}

	// Global answer
	Point aMin, bMin, cMin;
	Point aMax, bMax, cMax;

	// Local answer
	Point aMinLocal, bMinLocal, cMinLocal;
	Point aMaxLocal, bMaxLocal, cMaxLocal;

	// getMax output
	Point a, b, c;
	long ans = -1;

	long getMax(Point[] p, int n) {
		// p = Arrays.copyOf(p, n);
		// System.err.println(Arrays.toString(Arrays.copyOf(p, n)));
		int L = 0;
		int R = n - 1;
		long ans = -1;
		a = p[0];
		b = p[n - 1];
		while (R - L > 2) {
			int c1 = (2 * L + R) / 3;
			int c2 = (L + 2 * R) / 3;
			long v1 = s(p[0], p[n - 1], p[c1]);
			long v2 = s(p[0], p[n - 1], p[c2]);
			if (v1 > v2) {
				R = c2;
				c = p[c1];
				ans = v1;
			} else {
				L = c1;
				c = p[c2];
				ans = v2;
			}
		}
		for (int i = L + 1; i < R; i++) {
			long v = s(p[0], p[n - 1], p[i]);
			if (v > ans) {
				c = p[i];
				ans = v;
			}
		}
		return ans;
	}

	long min;

	void updateMin(Point a, Point b, Point c) {
		long s2 = s(a, b, c);
		if (s2 < min) {
			min = s2;
			aMinLocal = a;
			bMinLocal = b;
			cMinLocal = c;
		}
	}

	void check(Point[] p) {
		int n = p.length;
		min = s(p[0], p[n - 1], p[n - 2]);
		aMinLocal = p[0];
		bMinLocal = p[n - 1];
		cMinLocal = p[n - 2];
		for (int i = n - 2; i > 0; i--) {
			updateMin(p[i], p[i + 1], p[(i + 2) % n]);
			updateMin(p[i], p[i + 1], p[0]);
			updateMin(p[i], p[n - 1], p[0]);
			// System.err.println("minimum in "
			// + Arrays.toString(copyOf(p, i - 1, n)) + " " + p[0] + " = "
			// + min);
			long s3 = getMax(p, i + 1);
			// System.err.println("maximum in "
			// + Arrays.toString(Arrays.copyOf(p, i + 1)) + " = " + s3);
			if (s3 - min > ans) {
				aMax = a;
				bMax = b;
				cMax = c;
				aMin = aMinLocal;
				bMin = bMinLocal;
				cMin = cMinLocal;
				ans = s3 - min;
			}
		}
	}

	private Point[] copyOf(Point[] p, int i, int n) {
		Point[] res = new Point[n - i];
		for (int j = 0; j < res.length; j++) {
			res[j] = p[i + j];
		}
		return res;
	}

	void solve() throws IOException {

		int n = nextInt();
		Point[] p = new Point[n];
		for (int i = 0; i < n; i++) {
			p[i] = new Point(nextLong(), nextLong(), i + 1);
		}

		// System.err.println(getMax(p, n));
		//
		// if (true) {
		// return;
		// }

		Point[] p2 = new Point[n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				p2[j] = p[(i + j) % n];
			}
			check(p2);
		}
		out.printf("%.1f\n", ans / 2.0);
		System.err.println(ans);
		out.println(aMax.id + " " + bMax.id + " " + cMax.id);
		out.println(aMin.id + " " + bMin.id + " " + cMin.id);
	}

	static final String FILENAME = "kids";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new K().run();
	}
}
