import java.io.*;
import java.util.*;
import java.math.*;

public class K {

	static class Point {
		long x, y;
		int id;

		public Point(long x, long y, int id) {
			super();
			this.x = x;
			this.y = y;
			this.id = id;
		}

		@Override
		public String toString() {
			return "(" + x + ", " + y + ")";
		}
	}

	long s(Point a, Point b, Point c) {
		long abx = b.x - a.x;
		long aby = b.y - a.y;
		long acx = c.x - a.x;
		long acy = c.y - a.y;
		return Math.abs(abx * acy - aby * acx);
	}

	Point a, b, c, aTmp, bTmp, cTmp;
	long ans = -1;

	long biggestTriangle0(Point[] p) {
		int p2 = 0;
		int n = p.length;
		long max = -1;
		aTmp = p[0];
		for (int i = 2; i < n; i++) {
			long s = s(p[0], p[1], p[i]);
			if (s > max) {
				max = s;
				p2 = i;
				bTmp = p[1];
				cTmp = p[i];
			}
		}
		for (int i = 2; i < n - 1; i++) {
			while (p2 < n - 1
					&& s(p[0], p[i], p[p2]) < s(p[0], p[i], p[p2 + 1])) {
				p2++;
			}
			long s = s(p[0], p[i], p[p2]);
			if (s > max) {
				max = s;
				bTmp = p[i];
				cTmp = p[p2];
			}
		}
		return max;
	}

	long biggestTriangle(Point[] p) {
		int n = p.length;
		Point[] p2 = new Point[n];
		long max = -1;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				p2[j] = p[(i + j) % n];
			}
			long tmp = biggestTriangle0(p2);
			if (tmp > max) {
				max = tmp;
				a = aTmp;
				b = bTmp;
				c = cTmp;
			}
		}
		
//		for (int i = 0; i < p.length; i++) {
//			for (int j = i + 1; j < p.length; j++) {
//				for (int k = j + 1; k < p.length; k++) {
//					long tmp = s(p[i], p[j], p[k]);
//					if (tmp > max) {
//						max = tmp;
//						a = p[i];
//						b = p[j];
//						c = p[k];
//					}					
//				}
//			}
//		}
		
		return max;
	}

	void solve() throws IOException {

		int n = nextInt();
		Point[] p = new Point[n];
		for (int i = 0; i < n; i++) {
			p[i] = new Point(nextLong(), nextLong(), i);
		}

		trySolve(p, null, null, null);
		System.err.println(a + " " + b + " " + c);
		int aid = a.id;
		int bid = b.id;
		int cid = c.id;
		trySolve(except(p, aid), p[(aid + n - 1) % n], p[aid], p[(aid + 1) % n]);
		trySolve(except(p, bid), p[(bid + n - 1) % n], p[bid], p[(bid + 1) % n]);
		trySolve(except(p, cid), p[(cid + n - 1) % n], p[cid], p[(cid + 1) % n]);
//		out.printf("%.1f\n", res / 2.0);
		out.println(res / 2 + (res % 2 == 0 ? "" : ".5"));
		out.println((maxa.id + 1) + " " + (maxb.id + 1) + " " + (maxc.id + 1));
		out.println((mina.id + 1) + " " + (minb.id + 1) + " " + (minc.id + 1));
	}

	long res = Long.MIN_VALUE;
	Point maxa, maxb, maxc, mina, minb, minc;

	private Point[] except(Point[] p, int id) {
		Point[] res = new Point[p.length - 1];
		for (int i = 0; i < id; i++) {
			res[i] = p[i];
		}
		for (int i = id + 1; i < p.length; i++) {
			res[i - 1] = p[i];
		}
		return res;
	}

	private void trySolve(Point[] p, Point aa, Point bb, Point cc) {
		long max = biggestTriangle(p);
		long min = Long.MAX_VALUE / 10;

		Point aMin = aa;
		Point bMin = bb;
		Point cMin = cc;
		if (aa != null) {
			min = s(aa, bb, cc);
		}

		for (int i = 0; i < p.length; i++) {
			if (i == a.id || i == b.id || i == c.id) {
				continue;
			}
			long s = s(p[i], p[(i + 1) % p.length], p[(i + p.length - 1)
					% p.length]);
			if (s < min) {
				min = s;
				aMin = p[i];
				bMin = p[(i + 1) % p.length];
				cMin = p[(i - 1 + p.length) % p.length];
			}
		}
		if (max - min > res) {
			res = max - min;
			maxa = a;
			maxb = b;
			maxc = c;
			mina = aMin;
			minb = bMin;
			minc = cMin;
		}
	}

	static final String FILENAME = "kids";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new K().run();
	}
}
