import java.io.*;
import java.util.*;

public class BlackSquare {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	void solve() throws Exception {
		int m = nextInt();
		int n = nextInt();
		int s = nextInt();
		int k = nextInt();
		String g = next();
		int cnt = 0;
		int left = -1;
		int right = -1;
		for (int i = 0; i < n; i++) {
			
			if (g.charAt(i) == '*') {
				cnt++;
				if (left == -1)
					left = i;
				right = i;
			}
		}
		if (cnt != s || (right - left + 1) != s) {
			out.println("Impossible");
			return;
		}
		if (s == 1 || m == s || k == 1 || k == m) {
			out.println("Unique");
			return;
		}
		out.println("Ambiguous");
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("black.in"));
			out = new PrintWriter("black.out");

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new BlackSquare().run();

	}

}
