import java.io.*;
import java.util.*;

public class CubeColoring {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	String[] s;

	int[][] a = { { 1, 2, 3, 4 }, { 5, 2, 0, 4 }, { 3, 0, 1, 5 },
			{ 4, 0, 2, 5 }, { 3, 5, 1, 0 }, { 4, 3, 2, 1 } };
	char[] c;
	boolean[] used;
	int n;
	char[] q;
	String tmp;
	int[] perm;
	boolean[] used1;
	
	void gen1(int i) {
		if (i == 6) {
			check();
			return;
		}
		for (int j = 0; j < 6; j++) {
			if (!used1[j]) {
				used1[j] = true;
				perm[i] = j;
				
				gen1(i + 1);
				
				perm[i] = -1;
				used1[j] = false;
			}
		}
	}
	
	void check() {
		for (int i = 0; i < 6; i++) {
			int[] a1 = new int[256];
			int[] a2 = new int[256];
			if (q[i] != s[perm[i]].charAt(0)) {
				return;
			}
			for (int j = 0; j < 4; j++) {
				a1[q[a[i][j]] - 'A']++;
				a2[s[perm[i]].charAt(j + 1) - 'A']++;
			}
			for (int j = 0; j < 26; j++) {
				if (a1[j] != a2[j]) {
					return;
				}
			}
		}
		ans.add(String.valueOf(q));
	}

	void gen(int i) {
		if (i == 6) {
			gen1(0);
			return;
		}
		if (i >= n) {
			for (int j = 0; j < n; j++) {
				q[i] = c[j];
				gen(i + 1);
				q[i] = 0;
			}
		} else {

			for (int j = 0; j < n; j++) {
				if (!used[j]) {
					q[i] = c[j];
					used[j] = true;

					gen(i + 1);

					used[j] = false;
					q[i] = 0;
				}
			}
		}
	}

	TreeSet<String> ans;
	
	int sum(int[] a) {
		int ans = 0;
		for (int i : a)
			ans += i;
		return ans;
	}
	
	boolean can(String x, String y) {
		char[] q = new char[6];
		for (int i = 0; i < 6; i++) {
			q[0] = y.charAt(i);
			for (int j = 0; j < 4; j++) {
				for (int k = 0; k < 4; k++) {
					q[k + 1] = y.charAt(a[i][(j + k) % 4]);
				}
			}
			q[5] = y.charAt(15 - i - sum(a[i]));
			String tmp = String.valueOf(q);
			if (tmp.equals(x)) {
				return true;
			}
		}
		return false;
	}

	void solve() throws Exception {
		s = new String[6];
		for (int i = 0; i < 6; i++)
			s[i] = next();
		TreeSet<Character> ts = new TreeSet<Character>();
		for (int i = 0; i < 6; i++) {
			for (int j = 0; j < 5; j++) {
				ts.add(s[i].charAt(j));
			}
		}

		if (ts.size() > 6) {
			out.println("Impossible");
			return;
		}

		c = new char[ts.size()];
		int tmp = 0;
		for (char g : ts)
			c[tmp++] = g;
		n = c.length;
		q = new char[6];
		perm = new int[6];
		used = new boolean[n];
		used1 = new boolean[6];
		ans = new TreeSet<String>();
		gen(0);
//		for (String s : ans) {
//			out.println(s);
//		}
		String[] cand = new String[ans.size()];
		tmp = 0;
		for (String s : ans)
			cand[tmp++] = s;
		if (tmp == 0) {
			out.println("Impossible");
			return;
		}
		int p = 0;
		for (int i = 0; i < tmp; i++) {
			boolean fl = true;
			for (int j = 0; j < i; j++) {
				if (can(cand[i], cand[j])) {
					fl = false;
					break;
				}
			}
			if (fl) {
				out.println(cand[i]);
				p++;
			}
			if (p == 2) {
				break;
			}
		}
		
		
		
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("cube.in"));
			out = new PrintWriter("cube.out");

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new CubeColoring().run();

	}

}
