import java.io.*;
import java.util.*;

public class Dice {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	class Pair implements Comparable<Pair> {
		int x, i;
		public Pair(int x, int i) {
			this.x = x;
			this.i = i;
		}
		
		@Override
		public int compareTo(Pair o) {
			if (this.x == o.x)
				return this.i - o.i;
			return this.x - o.i;
		}
	}
	
	void solve() throws Exception {
		int n = nextInt();
		Pair[] a = new Pair[n];
		double ans = 0;
		int sum = 0;
		for (int i = 0; i < n; i++) {
			a[i] = new Pair(nextInt(), i);
			sum += a[i].x;
		}
		Arrays.sort(a);
		ArrayList<Integer>[] b = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			b[i] = new ArrayList<Integer>();
		}
		for (int i = 0; i < n; i++) {
			int s = 0;
			for (int j = 0; j < a[i].x; j++) {
				s += sum;
				b[a[i].i].add(sum--);
			}
			ans += ((double) s) / ((double) b[a[i].i].size());
		}
		out.println(ans);
		for (int i = 0; i < n; i++) {
			Collections.sort(b[i]);
			for (int j : b[i]) {
				out.print(j + " ");
			}
			out.println();
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("dice.in"));
			out = new PrintWriter("dice.out");

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new Dice().run();

	}

}
