import java.io.*;
import java.util.*;

public class Galaxy {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	ArrayList<Integer>[] graph;
	boolean[][] g;
	
	void set(int v, int c) {
		for (int h : graph[v]) {
			g[h][c] = true;
		}
	}
	
	void solve() throws Exception {
		int n = nextInt();
		graph = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			graph[i] = new ArrayList<Integer>();
		}
		int k = nextInt();
		int m = nextInt();
		
		for (int i = 0; i < m; i++) {
			int x = nextInt() - 1;
			int y = nextInt() - 1;
			graph[x].add(y);
			graph[y].add(x);
		}
		g = new boolean[n][k];
		int[] ans = new int[n];
		Arrays.fill(ans, -1);
		for (int i = 0; i < k; i++) {
			ans[i] = i;
			set(i, i);
		}
		
		for (int i = k; i < n; i++) {
			for (int j = 0; j < k; j++) {
				if (g[i][(j + k - 1) % k] == true && g[i][j] == false) {
					ans[i] = j;
					set(i, j);
					break;
				}
			}
		}
		
		for (int i = 0; i < n; i++) {
			out.print((ans[i] + 1) + " ");
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("galaxy.in"));
			out = new PrintWriter("galaxy.out");

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new Galaxy().run();

	}

}
