import java.io.*;
import java.util.*;

public class HighSecurity {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}
	
	long get(int mask, String[] s) {
		int n = s.length;
		String[] a = new String[n];
		for (int i = 0; i < n; i++) {
			a[i] = "";
			for (int j = 0; j < 5; j++) {
				if ((mask & (1 << j)) != 0) {
					a[i] += s[i].charAt(j);
				}
			}
		}
		long ans = 0;
		for (int i = 0; i < n; ) {
			int j = i;
			while (j < n && a[j].equals(a[i])) {
				j++;
			}
			long c = j - i;
			ans += c * (c - 1) / 2;
			i = j;
		}
		return ans;
	}

	void solve() throws Exception {
		int n = nextInt();
		String[] s = new String[n];
		for (int i = 0; i < n; i++) {
			s[i] = next();
		}
		long[] ans = new long[6];
		long[] count = new long[32];
		for (int i = 1; i < 32; i++) {
			count[i] = get(i, s);
		}
		
		long nn = n;
		count[0] = (nn * (nn - 1)) / 2L;
		long[] newcount = count.clone();
		for (int i = 31; i >= 0; i--) {
			for (int j = 31; j >= i; j--) {
				int k = j - i;
				int l = j ^ i;
				if (k == l && k != 0) {
					int cnt = Integer.bitCount(k);
					if (cnt % 2 == 0)
						newcount[i] += count[j];
					else
						newcount[i] -= count[j];
				}
			}
		}
		for (int i = 0; i < 32; i++) {
			ans[Integer.bitCount(i)] += newcount[i];
		}
		for (int i = 5; i >= 0; i--) {
			out.print(ans[i] + " ");
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("high.in"));
			out = new PrintWriter("high.out");

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new HighSecurity().run();

	}

}
