import java.io.*;
import java.util.*;

public class CubeColoring {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	int matr[][];
	int prev[][];
	int len[][];
	int last[][];
	int stp2[];

	void outway(int st, int en) {
		if (prev[st][en] == st) {
			out.print(" " + (en+1));
			return;
		}
		outway(st, prev[st][en]);
		outway(prev[st][en], en);

	}

	void buildway(int mask, int v, int cost) {
		if (mask == 1) {
			out.print(cost + " " + 1);
			return;
		}
		int tek = last[v][mask];
		buildway(mask - stp2[v], last[v][mask], cost + len[tek][v]);
		outway(tek, v);
	}

	void solve() throws Exception {
		int n = nextInt();
		int m = nextInt();
		matr = new int[n][n];
		prev = new int[n][n];
		len = new int[n][n];
		for (int i = 0; i < n; i++)
			Arrays.fill(matr[i], Integer.MAX_VALUE / 3);
		for (int i = 0; i < m; i++) {
			int st = nextInt() - 1;
			int en = nextInt() - 1;
			int cost = nextInt();
			if (matr[st][en] > cost) {
				matr[st][en] = cost;
				prev[st][en] = st;
				len[st][en] = 1;
				len[en][st] = 1;
				prev[en][st] = en;
				matr[en][st] = cost;
			}
		}
		for (int i = 0; i < n; i++)
			matr[i][i] = 0;
		for (int k = 0; k < n; k++)
			for (int i = 0; i < n; i++)
				for (int j = 0; j < n; j++) {
					if (matr[i][k] + matr[k][j] < matr[i][j]) {
						prev[i][j] = k;
						len[i][j] = len[i][k] + len[k][j];
						matr[i][j] = matr[i][k] + matr[k][j];
					}
				}
		stp2 = new int[n+1];
		stp2[0] = 1;
		for (int i = 1; i <= n; i++)
			stp2[i] = 2 * stp2[i - 1];
		int a[][] = new int[n][stp2[n]];
		int res[] = new int[stp2[n]];
		int num[] = new int[stp2[n]];
		last = new int[n][stp2[n]];
		for (int i = 0; i < n; i++)
			Arrays.fill(a[i], Integer.MAX_VALUE / 3);
		Arrays.fill(res, Integer.MAX_VALUE / 3);
		a[0][1] = 0;
		res[1] = 0;
		for (int mask = 1; mask < stp2[n]; mask++)
			for (int i = 0; i < n; i++) {
				if (a[i][mask] == Integer.MAX_VALUE / 3)
					continue;
				if (res[mask] > a[i][mask]) {
					res[mask] = a[i][mask];
					num[mask] = i;
				}
				for (int j = 0; j < n; j++)
					if (((mask & stp2[j]) == 0)
							&& (a[j][mask | stp2[j]] > a[i][mask] + matr[i][j])) {
						a[j][mask | stp2[j]] = a[i][mask] + matr[i][j];
						last[j][mask | stp2[j]] = i;
					}
			}
		int opt = 1;
		for (int mask = 1; mask < stp2[n]; mask++) {
			if (Math.max(res[opt], res[stp2[n] - opt]) > Math.max(res[mask],
					res[stp2[n] - mask]))
				opt = mask;
		}
		out.println(Math.max(res[opt], res[stp2[n] - opt]));
		buildway(opt,num[opt], 0);
		out.println();
		opt = stp2[n] - opt;
		buildway(opt,num[opt], 0);
		out.println();
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("immediate.in"));
			out = new PrintWriter("immediate.out");

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new CubeColoring().run();

	}

}
