#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <cstdio>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)
#define eprintf(...) {fprintf(stderr, __VA_ARGS__); fflush(stderr);}
#define pb push_back
#define mp make_pair
#define sz(c) (int)(c).size()
#define all(c) (c).begin(),(c).end()
typedef long long LL;

#define TASK "immediate"
const int maxn = 18;
const int maxk = 1<<maxn;
const int maxm = maxn*maxk;
const int inf  = (int)1e9;

int n,m;

vector<int> g[maxn];
vector<int> c[maxn];

int dist[maxm];
int p[maxm];
priority_queue< pair<int,int> > pq;
int res[maxk];
int ind[maxk];

inline int code(int mask,int v){
	return mask*18+v;
}
	
inline void relax(int v,int cost,int fr){
	if(dist[v]>cost){
		//set<pair<int,int> >::iterator it = pq.find(mp(dist[v],v));
		//if(it!=pq.end()){
		//	pq.erase(it);
		//}
		p[v] = fr;
		dist[v] = cost;
		pq.push(mp(-dist[v],v));
	}	
}


void dijkstra(){
	forn(i,maxm) dist[i] = inf,p[i]=-1;
	dist[code(1,0)] = 0;
	pq.push(mp(0,code(1,0)));
	while(!pq.empty()){
	 	int w  = -pq.top().first;
	 	int sc = pq.top().second;
		pq.pop();
		//pq.erase(pq.begin());
		if(dist[sc]<w) continue;
		int v = sc%maxn;
		int mask = sc/maxn;
		forn(i,sz(g[v])){
			int u = g[v][i];
			int nmask = mask | (1<<u);
			int cost = c[v][i];
			relax(nmask*18+u,dist[sc]+cost,sc);
		} 
	}
}

void go(int v){
	vector<int> res;
	while(p[v]!=-1){
		res.pb(v%18);
		v = p[v];
	}
	res.pb(0);
	reverse(all(res));
	res.resize(unique(all(res))-res.begin());
	printf("%d ",sz(res)-1);
	forn(i,sz(res)) printf("%d%c",res[i]+1," \n"[i+1==sz(res)]);
}

int main() {
	int t0 = clock();
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	scanf("%d%d",&n,&m);
	eprintf("!!!\n");
	forn(i,m){
		int u,v,_c; scanf("%d%d%d",&u,&v,&_c),u--,v--;
		g[u].pb(v); g[v].pb(u);
		c[u].pb(_c); c[v].pb(_c);
	}
//	eprintf("!!!\n");
	dijkstra();
	eprintf("!!!\n");
	for(int mask = (1<<n)-1 ; mask >= 0 ; mask-- ){
		ind[mask] = -1;
		res[mask] = inf;
		forn(v,n){
			int cc = mask*18 + v;
			if(dist[cc]<res[mask]){
				res[mask] = dist[cc];
				ind[mask] = cc;
			}
		}
		forn(v,n){
			if(res[mask|(1<<v)]<res[mask]){
				res[mask] = res[mask|(1<<v)];
				ind[mask] = ind[mask|(1<<v)];
			}
		} 
	}
	int ra,rb;
	ra = 0;
	rb = (1<<n)-1;
	forn(i,1<<n){
		int j = i^((1<<n)-1);
		if(max(res[i],res[j])<max(res[ra],res[rb])){
			ra = i;
			rb = j;
		}
	}
	printf("%d\n",max(res[ra],res[rb]));
	go(ind[ra]);
	go(ind[rb]);
	eprintf("%d ms\n",int(1000.*(clock()-t0)/CLOCKS_PER_SEC));
	return 0;
}
