#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <cstdio>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)
#define eprintf(...) {fprintf(stderr, __VA_ARGS__); fflush(stderr);}
typedef long long LL;

#define TASK "kids"


const int maxn = 1<<10;

const double eps = 1e-9;
inline LL det(LL a,LL b,LL c,LL d){
	return a*d-b*c;
}


struct vec{
	LL x,y;
	vec(LL _x,LL _y){
		x = _x , y = _y;
	}
	vec(){
		x = y = 0;
	}
	void read(){
		int _x,_y;
		scanf("%d%d",&_x,&_y);
		x = _x , y = _y;
	}
	void print(){
		eprintf("(%I64d,%I64d)\n",x,y);
	}
	
};

struct plane{
	LL a,b,c;
	LL d;
	plane(LL _a,LL _b,LL _c){
		a = _a , b = _b , c = _c;
		d = a*a + b*b + c*c;
	}
	
	plane(vec p,vec q){
		a =  det(p.y,1,q.y,1);
		b = -det(p.x,1,q.x,1);
		c =  det(p.x,p.y,q.x,q.y);
	}
	
	inline void print(){
		printf("%+I64dx%+I64dy%+I64d=0");
	}
	inline double dist(vec p){
		double q = 1.*p.x*a + 1.*p.y*b + c;
		q = q*q;
		return q/d;
	}
};

inline LL vmult(vec a,vec b,vec o){
	return det(a.x-o.x,a.y-o.y,b.x-o.x,b.y-o.y);
}
inline LL area(vec a,vec b,vec o){
	LL res = vmult(a,b,o);
	if(res<0) return -res; else return res;
}

vec p[maxn];
struct triple{
	int a,b,c;
	triple(){}
	triple(int _a,int _b,int _c){
		a = _a , b = _b , c = _c;
	}
};

int go_max[maxn][maxn];
int go_min[maxn][maxn];
LL gmin[maxn][maxn];
LL gmax[maxn][maxn];
triple rmin[maxn][maxn];
triple rmax[maxn][maxn];

int main() {
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n; scanf("%d",&n);
	forn(i,n) p[i].read(),p[i+n]=p[i];
	memset(go_max,-1,sizeof go_max);
	//eprintf("max--->\n");
	forn(i,n){
		int k = i;
		for(int j = i+2 ; j < i + n ; j++ ){
			plane l = plane(p[i],p[j]);
			while(l.dist(p[k+1])>l.dist(p[k])) k++;
			go_max[i][j] = k;
			assert(area(p[i],p[j],p[k])>0);
			//eprintf("%d %d %d\n",i%n+1,j%n+1,k%n+1);
		}
	}
	//eprintf("min--->\n");
	forn(i,n){
		int k = i;
		for(int j = i + 2 ; j < i + n ; j++ ){
			plane l  = plane(p[i],p[j]);
			if(l.dist(p[i+1])<l.dist(p[j-1])) k = i+1 ; else k = j-1;
			go_min[i][j] = k;
			//eprintf("%d %d %d\n",i%n+1,j%n+1,k%n+1);
			assert(area(p[i],p[j],p[k])>0);
		}
	}
	//eprintf("!!!\n");
	for(int len = 2 ; len <= n-2 ; len++ ){
		for(int i = 0 ; i < n ; i++ ){
			rmin[i][i+len] = triple(i,i+len,go_min[i][i+len]);
			rmax[i][i+len] = triple(i,i+len,go_max[i][i+len]);
			
			gmin[i][i+len] = area(p[i],p[i+len],p[go_min[i][i+len]]);
			gmax[i][i+len] = area(p[i],p[i+len],p[go_max[i][i+len]]);
			
			if(len>2){
				if(gmin[i+1][i+len] < gmin[i][i+len]){
					rmin[i][i+len] = rmin[i+1][i+len];
					gmin[i][i+len] = gmin[i+1][i+len];
				}
				if(gmin[i][i+len-1] < gmin[i][i+len]){
					rmin[i][i+len] = rmin[i][i+len-1];
					gmin[i][i+len] = gmin[i][i+len-1];
				}
				if(gmax[i+1][i+len] > gmax[i][i+len]){
					rmax[i][i+len] = rmax[i+1][i+len];
					gmax[i][i+len] = gmax[i+1][i+len];
				
				}
				if(gmax[i][i+len-1] > gmax[i][i+len]){
					rmax[i][i+len] = rmax[i][i+len-1];
					gmax[i][i+len] = gmax[i][i+len-1];
				}
			}
		}
	}
	LL res = -(1LL<<62);
	//eprintf("%I64d\n",res);
	triple r[2];
	for(int i = 0 ; i < n ; i++ ){
		for(int j = i + 2 ; j < n ; j++ ){
			if(res<gmax[i][j]-gmin[j][i+n]){
				res=gmax[i][j]-gmin[j][i+n];
				r[0] = rmax[i][j];
				r[1] = rmin[j][i+n];
			}
			if(res<gmax[j][i+n]-gmin[i][j]){
				res=gmax[j][i+n]-gmin[i][j];
				r[0] = rmax[j][i+n];
				r[1] = rmin[i][j];
			
			}
			//res = max(res,gmax[i][j]-gmin[j][i+n]);
			//res = max(res,gmax[j][i+n]-gmin[i][j]);
		}
	}
	//eprintf("%I64d\n",res);
	printf("%.20lf\n",res*0.5);
	printf("%d %d %d\n",r[0].a%n+1,r[0].b%n+1,r[0].c%n+1);
	printf("%d %d %d\n",r[1].a%n+1,r[1].b%n+1,r[1].c%n+1);
	return 0;
}
