import java.io.*;
import java.util.*;

class cube {
	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while ((in == null) || (!in.hasMoreTokens()))
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public String gen(String s, int k) {
		int k1 = 5;
		if ((k == 1) || (k == 2))
			k1 = k + 2;
		if ((k == 3) || (k == 4))
			k1 = k - 2;
		if (k == 5)
			k1 = 0;
		String ans = "";
		for (int i = 0; i < 6; i++) {
			if (i == k)
				continue;
			if (i == k1)
				continue;
			ans = ans + s.charAt(i);
		}
		return ans;
	}

	public boolean check(String A, String B) {
		char[] a = A.toCharArray();
		char[] b = B.toCharArray();
		Arrays.sort(a);
		Arrays.sort(b);
		for (int i = 0; i < a.length; i++)
			if (a[i] != b[i])
				return false;
		return true;
	}

	public int[] nextPerm(int[] a) {
		int[] res = new int[6];
		int t = -1;
		for (int i = 5; i > 0; i--) {
			if (a[i] > a[i - 1]) {
				t = i - 1;
				break;
			}
		}
		if (t == -1) {
			Arrays.sort(a);
			return a;
		}
		for (int i = 0; i <= t; i++) {
			res[i] = a[i];
		}
		for (int i = t + 1; i < 6; i++) {
			res[i] = a[6 - (i - t)];
		}
		for (int i = t + 1; i < 6; i++) {
			if (res[i] > res[t]) {
				int tmp = res[t];
				res[t] = res[i];
				res[i] = tmp;
				break;
			}
		}
		return res;
	}

	public String[] nextPer(int[] a, String[] b) {
		Arrays.sort(b);
		a = nextPerm(a);
		String[] res = new String[6];
		for (int i = 0; i < 6; i++)
			res[i] = b[a[i]];
		return res;
	}

	public String nextPer2(int[] a, String b) {
		String res = "";
		a = nextPerm(a);
		for (int i = 0; i < 6; i++)
			res += b.charAt(a[i]);
		return res;
	}
	
	public boolean checkDiff(String a, String b) {
		if ((a.charAt(0) != b.charAt(0)))
			return false;
		if ((a.charAt(5) != b.charAt(5)))
			return false;
		String z = "";
		for (int i = 1; i < 5; i++)
			z = z + a.charAt(i);
		for (int i = 1; i < 4; i++)
			z = z + a.charAt(i);
		for (int di = 0; di < 4; di++) {
			boolean fl = true;
			for (int i = 1; i < 5; i++) {
				if (b.charAt(i) != z.charAt(i + di - 1))
				fl = false;
			}
			if (fl)
				return false;
		}
		return true;
	}

	public void solve() throws IOException {
		String[] a = new String[6];
		int[] c = new int[256];
		for (int i = 0; i < 6; i++) {
			a[i] = nextToken();
			for (int j = 0; j < a[i].length(); j++)
				c[a[i].charAt(j)]++;
		}
		String m = "";
		for (int i = 0; i < 256; i++) {
			if (c[i] % 5 != 0) {
				out.println("Impossible");
				return;
			}
			c[i] = c[i] / 5;
			for (int j = 0; j < c[i]; j++)
				m = m + (char) i;
		}
		int[] per = new int[6];
		for (int i = 0; i < 6; i++)
			per[i] = i;
		String s = m;
		ArrayList<String> ans = new ArrayList<String>();
		for (int i = 0; i < 720; i++) {
			int[] per2 = new int[6];
			for (int j = 0; j < 6; j++)
				per2[j] = j;
			for (int j = 0; j < 720; j++) {
				boolean flag = true;
				for (int k = 0; k < 6; k++) {
					if (a[k].charAt(0) != s.charAt(k)) {
						flag = false;
						break;
					}
					if (!check(a[k].substring(1), gen(s, k))) {
						flag = false;
						break;
					}
				}
				a = nextPer(per2, a);
				if (flag) {
					ans.add(s);
					break;
				}
				per2 = nextPerm(per2);

			}
			s = nextPer2(per, s);
			per = nextPerm(per);
		}
		/*for (int i = 0; i < ans.size(); i++)
			out.println(ans.get(i));
*/
		if (ans.size() == 0) {
			out.println("Impossible");
			return;
		}

		out.println(ans.get(0));
		/*for (int i = 1; i < ans.size(); i++) {
			if (checkDiff(ans.get(0), ans.get(i))) {
				out.println(ans.get(i));
				break;
			}*/
		String z = "";
		z += ans.get(0).charAt(0);
		for (int i = 4; i > 0; i--)
			z+= ans.get(0).charAt(i);
		z += ans.get(0).charAt(5);
		if (checkDiff(ans.get(0), z))
			out.println(z);

	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("cube.in"));
			out = new PrintWriter("cube.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new cube().run();
	}
}