import java.io.*;
import java.util.*;

class dice {
	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while ((in == null) || (!in.hasMoreTokens()))
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	class Dice implements Comparable<Dice> {
		int k, num;
		ArrayList<Integer> ans;

		public double getEx() {
			Collections.sort(ans);
			double res = 0;
			for (int i = 0; i < ans.size(); i++) {
				res += ans.get(i);
			}
			return (res / ans.size());
		}

		@Override
		public int compareTo(Dice t) {
			return k - t.k;
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int sum = 0;
		Dice[] a = new Dice[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Dice();
			a[i].k = nextInt();
			a[i].num = i;
			a[i].ans = new ArrayList<Integer>();
			sum += a[i].k;
		}

		Arrays.sort(a);

		double max = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < a[i].k; j++) {
				a[i].ans.add(sum);
				sum--;
			}
			max += a[i].getEx();
		}

		Dice[] ans = new Dice[n];
		for (int i = 0; i < n; i++)
			ans[a[i].num] = a[i];

		out.println(max);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < ans[i].ans.size(); j++) {
				out.print(ans[i].ans.get(j));
				if (j < ans[i].ans.size() - 1)
					out.print(' ');
				else
					out.println();
			}
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("dice.in"));
			out = new PrintWriter("dice.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new dice().run();
	}
}