import java.io.*;
import java.util.*;

class high {
	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while ((in == null) || (!in.hasMoreTokens()))
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public String get(String s, int mask) {
		String ans = "";
		for (int i = 0; i < 5; i++) {
			if (mask % 2 > 0)
				ans = ans + s.charAt(i);
			mask /= 2;
		}
		return ans;
	}
	
	public int getC(int t) {
		int ans = 0;
		for (int i = 0; i < 5; i++) {
			ans += t % 2;
			t /= 2;
		}
		return ans;
	}
	
	public int getHash(String s) {
		long res = 0;
		int n = s.length();
		for (int i = 0; i < n; i++) {
			res *= 63;
			char c = s.charAt(i);
			int cc = c - '0';
			if ((c >= 'A') && (c <= 'Z'))
				cc = c - 'A' + 10;
			if ((c >= 'a') && (c <= 'z'))
				cc = c - 'a' + 36;
			res += cc;
		}
		return (int)(res % 20000007);
	}
	
	public void solve() throws IOException {
		int n = nextInt();
		String[] a = new String[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextToken();
		}
		
		
		long[] c = new long[32];
		long[] count = new long[20000007];
		for (int mask = 0; mask < 32; ++mask) {
			for (int i = 0; i < n; ++i) {
				String s = get(a[i], mask);
			int hash = getHash(s);
				count[hash]++;
			}
			for (int i = 0; i < n; ++i) {
				String s = get(a[i], mask);
				int hash = getHash(s);
				c[mask] += count[hash] * (count[hash] - 1) / 2;
				count[hash] = 0;
			}
		}
		
		long[] d = new long[32];
		long[] ans = new long[6];
		for (int i = 0; i < 32; i++) {
			for (int j = 0; j < 32; j++) {
				if ((j | i) != j) 
					continue;
				if ((getC(j) - getC(i)) % 2 == 0)
					d[i] += c[j];
				else
					d[i] -= c[j];
			}
			ans[5 - getC(i)] += d[i];
		}
		
		for (int i = 0; i < 6; i++) {
			out.print(ans[i]);
			if (i < 5)
				out.print(' ');
			else
				out.println();
		}
		
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("high.in"));
			out = new PrintWriter("high.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new high().run();
	}
}