import java.io.*;
import java.util.*;

class john {
	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while ((in == null) || (!in.hasMoreTokens()))
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	class Card implements Comparable<Card>{
		int a, b;
		
		Card(int A, int B) {
			a = A;
			b = B;
		}
		
		public void swap() {
			int c = a;
			a = b;
			b = c;
		}
		
		@Override
		public int compareTo(Card t) {
			if (a == t.a)
				return b - t.b;
			else
				return a - t.a;
		}
	}
	
	class FenwickTree {
		long[] a;
		int n;
		
		public long get(int k) {
			long ans = 0;
			while (k > 0) {
				ans += a[k];
				k = (k & (k - 1));
			}
			return ans;
		}
		
		public void add(int k) {
			while (k <= n) {
				a[k]++;
				k = k + (k - (k & (k - 1)));
			}
		}
		
		FenwickTree(int N) {
			n = N;
			a = new long[n + 1];
		}
	}
	
	public void solve() throws IOException {
		int n = nextInt();
		
		int[] x = new int[n];
		int[] y = new int[n];
		int[] xx = new int[n];
		int[] yy = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = nextInt();
			y[i] = nextInt();
			xx[i] = x[i];
			yy[i] = y[i];
		}
		
		Arrays.sort(xx);
		Arrays.sort(yy);
		TreeMap<Integer, Integer> xM = new TreeMap<Integer, Integer>();
		TreeMap<Integer, Integer> yM = new TreeMap<Integer, Integer>();
		int xt = 1;
		int yt = 1;
		
		for (int i = 0; i < n; i++) {
			if (!xM.containsKey(xx[i])) {
				xM.put(xx[i], xt);
				xt++;
			}
			if (!yM.containsKey(yy[i])) {
				yM.put(yy[i], yt);
				yt++;
			}
		}
		
		Card[] a = new Card[n];
		for (int i = 0; i < n; i++)
			a[i] = new Card(xM.get(x[i]), yM.get(y[i]));
		Arrays.sort(a);
		
		FenwickTree count = new FenwickTree(n);
		long ans = 0;
		for (int i = 0; i < n; i++) {
			ans += i - count.get(a[i].b);
			count.add(a[i].b);
		}
		
		for (int i = 0; i < n; i++)
			a[i].swap();
		
		Arrays.sort(a);
		
		count = new FenwickTree(n);
		long ans2 = 0;
		for (int i = 0; i < n; i++) {
			ans2 += i - count.get(a[i].b);
			count.add(a[i].b);
		}
		
		
		out.println(Math.min(ans, ans2));
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("john.in"));
			out = new PrintWriter("john.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new john().run();
	}
}