import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;


public class B implements Runnable {

	private void solve() throws IOException {
		int h = nextInt();
		int w = nextInt();
		int s = nextInt();
		int k = nextInt();		
		String impossible = "Impossible";
		String ambigious = "Ambiguous";
		String unique = "Unique";
		
		char[] inp = next().toCharArray();
		int l = 0;
		int state = 0;
		for (int i = 0; i < inp.length; ++i) {
			l += inp[i] == '*' ? 1 : 0;
			if (inp[i] == '*' && state == 0) {
				++state;
			} else if (inp[i] == '.' && state == 1) {
				++state;
			} else if (inp[i] == '*' && state == 2) {
				//System.err.println(1 + " " + new String(inp));
				out.println(impossible);
				return;
			}
		}
		
		if (!(l == 0 || l == s)) {			
			out.println(impossible);
			return;
		}
		if (l == 0) {
			if (k < s + 1 && s > h - k) {
				out.println(impossible);
			} else if (((k == s + 1) ^ (s == h - k)) && w == s) {
				out.println(unique);
			} else {
				out.println(ambigious);
			}
		} else {
			int mx = Math.max(1, k - s + 1);
			int mn = Math.min(h, k + s - 1);
			if (mx + s - 1 == mn) {
				out.println(unique);				
			} else {
				out.println(ambigious);
			}
		}
		
				
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		(new Thread(new B())).start();
	}

	private String filename = "black";
	private BufferedReader br;
	private PrintWriter out;
	private StringTokenizer st;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br  = new BufferedReader(new FileReader(filename + ".in"));
			out = new PrintWriter(filename + ".out");
			st = new StringTokenizer("");
			while (hasNext()) {
				solve();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String temp = br.readLine();
			if (temp == null) {
				return null;
			}
			st = new StringTokenizer(temp);
		}
		return st.nextToken();
	}
	
	boolean hasNext() throws IOException {
		while (!st.hasMoreTokens()) {
			String temp = br.readLine();
			if (temp == null) {
				return false;
			}
			st = new StringTokenizer(temp);
		}
		return true;
	}
	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
}
