import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;


public class G implements Runnable {

	ArrayList<Integer>[] edge;
	int[] color;
	boolean[] was;
	int k;
	
	boolean[] colored;
	
	void dfs(int v) {
		was[v] = true;
		if (color[v] == -1) {
		Arrays.fill(colored, false);
			for (Integer u : edge[v]) {
				if (color[u] != -1) {
					colored[color[u]] |= true;
				}			
			}
			for (Integer u : edge[v]) {
				if (color[u] != -1 && !colored[(color[u] + 1) % k]) {
					color[v] = (color[u] + 1) % k;
					break;
				}
			}
		}
		for (Integer u : edge[v]) {
			if (!was[u]) {
				dfs(u);
			}
		}
	}
	
	private void solve() throws IOException {
		int n = nextInt();
		k = nextInt();
		int m = nextInt();
		color = new int[n];
		colored = new boolean[k];
		was = new boolean[n];
		Arrays.fill(color, -1);
		edge = new ArrayList[n];
		for (int i = 0; i < n; ++i) {
			edge[i] = new ArrayList<Integer>();
		}
		int x = 0;
		int y = 0;
		for (int i = 0; i < m; ++i) {
			x = nextInt() - 1;
			y = nextInt() - 1;
			edge[x].add(y);
			edge[y].add(x);
		}
		for (int i = 0; i < k; ++i) {
			color[i] = i;
		}
		dfs(0);
		for (int i = 0; i < n; ++i) {
			out.print((color[i] + 1) + " ");
		}
		out.println();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		(new Thread(new G())).start();
	}

	private String filename = "galaxy";
	private BufferedReader br;
	private PrintWriter out;
	private StringTokenizer st;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br  = new BufferedReader(new FileReader(filename + ".in"));
			out = new PrintWriter(filename + ".out");
			st = new StringTokenizer("");
			while (hasNext()) {
				solve();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String temp = br.readLine();
			if (temp == null) {
				return null;
			}
			st = new StringTokenizer(temp);
		}
		return st.nextToken();
	}
	boolean hasNext() throws IOException {
		while (!st.hasMoreTokens()) {
			String temp = br.readLine();
			if (temp == null) {
				return false;
			}
			st = new StringTokenizer(temp);
		}
		return true;
	}
	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
}
