#include <cstdio>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>

#include <ext/hash_map>

#define sz(c) ((int)(c).size())
#define ALL(c) (c).begin(), (c).end()
#define REP(i, n) for (int i = 0; i < (n); ++i)
#define FOR(i, s, n) for (int i = (s); i < (n); ++i)

using namespace std;
typedef long long ll;

using namespace __gnu_cxx;

int cnk( int n, int k )
{
  int ans = 1;
  for (int i = 1, j = n - k + 1; i <= k; ++i, ++j)
    ans = ans * j / i;
  return ans;
}

inline ll toLL( string const& s )
{
  ll h = 0;
  REP(i, sz(s))
    h = h * 256 + s[i];
  return h;
}

struct Hasher
{
  size_t operator () ( ll h ) const
  {
    return (size_t)(h * 239017);
  }
};

typedef hash_map<ll, int, Hasher> HashMap;

bool testCase()
{
  int n;
  if (scanf("%d", &n) != 1)
    return false;

  vector<string> str(n);
  REP(i, n)
  {
    static char buf[10];
    scanf("%5s", buf);
    str[i] = buf;
    assert(sz(str[i]) == 5);

//    cerr << str[i] << endl;
  }

  vector<int> ones((1 << 5), 0);
  REP(m, (1 << 5))
  {
    REP(j, 5)
      ones[m] += ((m >> j) & 1);
  }

  HashMap cnt;
  vector<int> c(6);
  string s;
  REP(i, n)
    REP(m, (1 << 5))
    {
      s = str[i];
      REP(j, 5)
        if ((m >> j) & 1)
          s[j] = '*';
      int& val = cnt[toLL(s)];
      c[ones[m]] += val;
      ++val;
    }

//  REP(i, 6)
//    fprintf(stderr, "%I64d%c", c[i], (i + 1 == 6 ? '\n' : ' '));

  vector<ll> a(6, 0);
  for (int i = 0; i < 6; ++i)
  {
    a[i] = c[i];
    FOR(j, 0, i)   //n, k
      a[i] -= a[j] * cnk(5 - j, i - j);
  }
  
  REP(i, 6)
    printf("%I64d%c", a[i], (i + 1 == 6 ? '\n' : ' '));
  return true;
}

int main()
{
  freopen("high.in",  "rt", stdin);
  freopen("high.out", "wt", stdout);
/*
  REP(n, 6)
  {
    REP(k, n + 1)
      printf("%d ", cnk(n, k));
    printf("\n");
  }
  return 0;
*/
  while (testCase())
    ;
  return 0;
}