import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Locale;
import java.util.StringTokenizer;


public class I implements Runnable {

	int[][] fbp;
	int[][] fbd;
	private int[][] edge;
	
	void ford(int n) {
		fbp = new int[n][n];
		fbd = new int[n][n];
		for (int[] i : fbd) {
			Arrays.fill(i, (int)1e9);
		}			
		for (int i = 0; i < n; ++i) {
			fbd[i][i] = 0;
		}			
		for (int i = 0; i < n; ++i) {
			for (int at = 0; at < n; ++at) {
				for (int j = 0; j < n; ++j) {
					for (int k = 0; k < n; ++k) {
						if (fbd[i][k] > fbd[i][j] + edge[j][k]) {
							fbd[i][k] = fbd[i][j] + edge[j][k];
							fbp[i][k] = j;
						}
					}
				}
			}
		}			
	}
	
	void push_ans(int to, int from, ArrayList<Integer> ans) {
		while (to != from) {
			to = fbp[from][to];
			ans.add(to);
		}
	}
	
	
	private void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		edge = new int[n][n];
		
		for (int[] i : edge) {
			Arrays.fill(i, (int)1e9);
		}
		for (int i = 0; i < n; ++i) {
			edge[i][i] = 0;
		}
		int x, y, t;
		for (int i = 0; i < m; ++i) {
			x = nextInt() - 1;
			y = nextInt() - 1;
			t = nextInt();
			edge[y][x] = edge[x][y] = Math.min(edge[x][y], t);
		}
		ford(n);
//		for (int[] i : fbd) {
//			System.err.println(Arrays.toString(i));
//		}
//		System.err.println();
//		for (int[] i : fbp) {
//			System.err.println(Arrays.toString(i));
//		}
//		System.err.println();
		int sz = 1 << n;
		int[][] d = new int[n][sz];
		int[][] prev = new int[n][sz];
		for (int[] i : prev) {
			Arrays.fill(i, -1);
		}
		for (int[] i : d) {
			Arrays.fill(i, (int)1e9);
		}
		d[0][1] = 0;
		int to = 0;
		int[] fr;
		int[] tr;
		for (int from = 0; from < sz; ++from) {
			for (int i = 0; i < n; ++i) {
				if (((from >> i) & 1) == 0) {
					to = from | (1 << i);
					tr = d[i];
					for (int j = 0; j < n; ++j) {
						fr = d[j];
						if (((from >> j) & 1) == 1 &&					 
							tr[to] > fr[from] + fbd[i][j]) {
							tr[to] = fr[from] + fbd[i][j];					
							prev[i][to] = j;
						}
					}
				}
			}
		}
//		for (int i = 0; i < n; ++i) {
//			System.err.println(Arrays.toString(d[i]));
//		}
//		System.err.println();
		int pos = 0;
		int lastx = 0;
		int lasty = 0;
		int xp, yp;
		int min = (int)1e9;
		for (int msk = 1; msk < sz; ++msk) {
			x = d[0][msk];
			y = d[0][sz - msk];
			xp = 0;
			yp = 0;
			for (int i = 0; i < n; ++i) {
				if (x > d[i][msk]) {
					x = d[i][msk];
					xp = i;
				}
				if (y > d[i][sz - msk]) {
					y = d[i][sz - msk];
					yp = i;
				}				
			}
			if (Math.max(x, y) < min) {
				min = Math.max(x, y);
				pos = msk;
				lastx = xp;
				lasty = yp;
			}
		}
		out.println(min);
		ArrayList<Integer> ansx = new ArrayList<Integer>();
		ArrayList<Integer> ansy = new ArrayList<Integer>();
		ansx.add(lastx);
		ansy.add(lasty);
		int tmp = 0;
		for (int msk = pos; lastx != 0; ) {
			push_ans(lastx, prev[lastx][msk], ansx);
			tmp = msk;
			msk ^= 1 << lastx;
			lastx = prev[lastx][tmp];			
		}
		for (int msk = sz - pos; lasty != 0; ) {
			push_ans(lasty, prev[lasty][msk], ansy);
			tmp = msk;
			msk ^= 1 << lasty;
			lasty = prev[lasty][tmp];			
		}
		Collections.reverse(ansx);
		Collections.reverse(ansy);
		out.print((ansx.size() - 1) + " ");
		for (Integer i : ansx) {
			out.print((i + 1) + " ");	
		}
		out.println();
		out.print((ansy.size() - 1) + " ");
		for (Integer i : ansy) {
			out.print((i + 1) + " ");	
		}
		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		(new Thread(new I())).start();
	}

	private String filename = "immediate";
	private BufferedReader br;
	private PrintWriter out;
	private StringTokenizer st;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br  = new BufferedReader(new FileReader(filename + ".in"));
			out = new PrintWriter(filename + ".out");
			st = new StringTokenizer("");
			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String next() throws IOException {
		while (!st.hasMoreTokens()) {
			String temp = br.readLine();
			if (temp == null) {
				return null;
			}
			st = new StringTokenizer(temp);
		}
		return st.nextToken();
	}
	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
}
