#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

string fname = "john";
string fin = fname + ".in";
string fout = fname + ".out";

vector<pair<int, int> > a; 
vector<pair<int, int> > b; 

void mergesort(vector<pair<int, int> >& a, int l, int r, int& count)
{
	if (r - l <= 1)
		return;
	int mid = (l + r) / 2;
	mergesort(a, l, mid, count);
	mergesort(a, mid, r, count);

	vector<pair<int, int> > tmp;
	int i = l;
	int j = mid;
	while (i < mid && j < r)
	{
		if (a[i] <= a[j])
		{
			tmp.push_back(a[i]);
			i++;
		} 
		else
		{
			tmp.push_back(a[j]);
			count += (mid - i);
			j++;
		}
	}

	while (i < mid)
	{
		tmp.push_back(a[i]);
		i++;
	}
	while (j < r)
	{
		tmp.push_back(a[j]);
		j++;
	}

	for (int k = l; k < r; k++)
		a[k] = tmp[k - l];
}

bool cmp(pair<int, int> a, pair<int, int> b)
{
	if (a.second == b.second)
		return a.first < b.first;
	else 
		return a.second < b.second;
}

int main()
{
	freopen(fin.c_str(), "r", stdin);
	freopen(fout.c_str(), "w", stdout);

	int n;
	cin >> n;

	int red, blue;
	for (int i = 0; i < n; i++)
	{
		cin >> red >> blue;
		a.push_back(make_pair(red, blue));
		b.push_back(make_pair(blue, red));
	}

	sort(a.begin(), a.end(), cmp);
	sort(b.begin(), b.end(), cmp);

	int count_red = 0;
	int count_blue = 0;

	mergesort(a, 0, n, count_red);
	mergesort(b, 0, n, count_blue);

	cout << min(count_red, count_blue);
	return 0;
}