#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cassert>
#include <ctime>
#include <stdarg.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define nextLine() {for(int c = getchar(); c != '\n' && c != EOF; c = getchar());}
#define sqr(a) ((a)*(a))
using namespace std;

typedef long long LL;
typedef long double ldb;
typedef pair<int, int> pii;

string face[6];
vector <char> all;

void Load()
{
	for (int i = 0; i < 6; i++)
	{
		cin >> face[i];
		for (int j = 0; j < 5; j++)
			all.pb(face[i][j]);
		sort(face[i].begin() + 1, face[i].end());
	}
}

enum {
	TOP = 0, LFT, FRN, RGT, BACK, BOT
};

/*
	0 - top
	1 - left
	2 - front
	3 - right
	4 - back
	5 - bottom
*/

int adj[6][4];

inline void precalcAdj()
{
	adj[TOP][0] = LFT; adj[TOP][1] = FRN;
	adj[TOP][2] = RGT; adj[TOP][3] = BACK;

	adj[LFT][0] = TOP; adj[LFT][1] = FRN;
	adj[LFT][2] = BACK; adj[LFT][3] = BOT;

	adj[FRN][0] = TOP; adj[FRN][1] = LFT;
	adj[FRN][2] = RGT; adj[FRN][3] = BOT;

	adj[RGT][0] = TOP; adj[RGT][1] = FRN;
	adj[RGT][2] = BACK; adj[RGT][3] = BOT;

	adj[BACK][0] = TOP; adj[BACK][1] = LFT;
	adj[BACK][2] = RGT; adj[BACK][3] = BOT;

	adj[BOT][0] = LFT; adj[BOT][1] = FRN;
	adj[BOT][2] = RGT; adj[BOT][3] = BACK;
}

set <string> was;
vector <string> good;

string vis = "";

inline void turnUp(const string &s, string &ns)
{
	ns = s;
	ns[BACK] = s[TOP];
	ns[BOT] = s[BACK];
	ns[FRN] = s[BOT];
	ns[TOP] = s[FRN];
}

inline void turnRight(const string &s, string &ns)
{
	ns = s;
	ns[BOT] = s[RGT];
	ns[RGT] = s[TOP];
	ns[TOP] = s[LFT];
	ns[LFT] = s[BOT];
}

void gen(const string &s)
{
	if (was.find(s) != was.end())
		return;
	was.insert(s);
	string ns;	
	turnUp(s, ns);
	gen(ns);
	turnRight(s, ns);
	gen(ns);
}

void rec(int pos)
{
	if (good.size() >= 2)
		return;
	if (pos == 6)
	{
		if (was.find(vis) != was.end())
			return;
		vector <int> cnt1(6, 0);
		vector <int> cnt2(6, 0);	
		for (int i = 0; i < 6; i++)
		{
			string cur = "";
			for (int j = 0; j < 4; j++)
				cur += vis[adj[i][j]];
			sort(cur.begin(), cur.end());
			cur = vis[i] + cur;
			for (int j = 0; j < 6; j++)
				if (face[j] == cur)
				{
					cnt1[i]++;
					cnt2[j]++;
				}
		}
		bool ok = true;
		for (int i = 0; ok && i < 6; i++)
			ok &= cnt1[i] > 0 && cnt2[i] > 0;
		if (ok)
		{
			gen(vis);
			good.pb(vis);
		}	
		return;
	}

	for (int i = 0; i < (int)all.size(); i++)
	{
		vis += all[i];
		rec(pos + 1);
		vis.erase(vis.end() - 1);
	}
}

void Solve()
{	
	sort(all.begin(), all.end());
	all.erase(unique(all.begin(), all.end()), all.end());
	if (all.size() > 6)
	{
		printf("Impossible");
		return;
	}
	was.clear();
	precalcAdj();
	rec(0);
	if (good.empty())
	{
		printf("Impossible");
	} else
	{
		for (int i = 0; i < min(2, (int)good.size()); i++)
			cout << good[i] << "\n";
	}	
}

#define task "cube"
int main()
{
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	Load();
	Solve();
	return 0;
}