#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cassert>
#include <ctime>
#include <stdarg.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define nextLine() {for(int c = getchar(); c != '\n' && c != EOF; c = getchar());}
#define sqr(a) ((a)*(a))
#define has(mask, i) (((mask) >> (i)) & (1))
using namespace std;

typedef long long LL;
typedef long double ldb;
typedef pair<int, int> pii;

const int maxv = 5005;
const int maxe = 100005;

int edges = 0;
int fst[maxv];
int nxt[maxe];
int end[maxe];

inline void addEdge(int u, int v)
{
	nxt[edges] = fst[u];
	end[edges] = v;
	fst[u] = edges++;
}

int n, k, m;
void Load()
{
	memset(fst, -1, sizeof(fst));
	scanf("%d%d%d", &n, &k, &m);
	for (int i = 0; i < m; i++)
	{
		int u, v;
		scanf("%d%d", &u, &v);
		addEdge(u, v);
		addEdge(v, u);
	}
}

bool can[maxv][11];
int col[maxv];

void dfs(int v, int c)
{
	col[v] = c;
	for (int i = fst[v]; i != -1; i = nxt[i])
		can[end[i]][c] = false;
	for (int i = fst[v]; i != -1; i = nxt[i])
	{
		int to = end[i];
		int nc = (c + 1) % n;
		if (col[to] == -1 && can[to][nc])
			dfs(to, nc);
	}
}

void Solve()
{
	memset(can, true, sizeof(can));
	memset(col, -1, sizeof(col));
	for (int i = 1; i <= k; i++)
	{
		col[i] = i - 1;
		for (int j = fst[i]; j != -1; j = nxt[j])
			can[end[j]][i - 1] = false;
	}
	for (int i = 1; i <= k; i++)
		dfs(i, i - 1);
	for (int i = 1; i <= n; i++)
		printf("%d ", col[i] + 1);
}

#define task "galaxy"
int main()
{
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	Load();
	Solve();
	return 0;
}