#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cassert>
#include <ctime>
#include <stdarg.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define nextLine() {for(int c = getchar(); c != '\n' && c != EOF; c = getchar());}
#define sqr(a) ((a)*(a))
#define has(mask, i) (((mask) >> (i)) & (1))
using namespace std;

const int inf = 1000000000;

typedef long long LL;
typedef long double ldb;
typedef pair<int, int> pii;

int n, m;
int p[20][20];
int d[20][20];

void Load()
{
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			d[i][j] = (i == j ? 0 : inf);

	for (int i = 0; i < m; i++)
	{
		int u, v, c;
		scanf("%d%d%d", &u, &v, &c);
		--u, --v;
		d[u][v] = min(d[u][v], c);
		p[u][v] = v;
		d[v][u] = min(d[v][u], c);
		p[v][u] = u;
	}
}

int dp[20][(1 << 18) + 2];
int pr[20][(1 << 18) + 2];

int f(int v, int mask)
{
	if (mask == 0)
		return d[v][0];
	if (dp[v][mask] != -1) return dp[v][mask];
	int res = inf;
	int best = -1;
	for (int i = 0; i < n; i++)
	{
		if (!has(mask, i)) continue;
		int cres = f(i, mask & (~(1 << v))) + d[v][i];
		if (cres < res)
		{
			res = cres;
			best = i;
		}
	}
	pr[v][mask] = best;
	return dp[v][mask] = res;
}

vector <int> way;

void out2(int u, int v)
{
	int k = p[u][v];
	if (u == v)
	{
		way.pb(u);
		return;
	}
	if (k == v || k == u)
	{
		way.pb(u);
		way.pb(v);
		return;
	}
	out2(u, k);
	out2(k, v);
}

void out(int v, int mask)
{
	if (mask == 0)	{
		out2(0, v);
		return;
	}
	int k = pr[v][mask];
	out(k, mask & (~(1 << v)));
	out2(k, v);
}

void Solve()
{
	for (int k = 0; k < n; k++)
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				if (d[i][j] > d[i][k] + d[k][j])
				{
					d[i][j] = d[i][k] + d[k][j];
					p[i][j] = k;
				}
	memset(dp, -1, sizeof(dp));
	//cerr << "before 1st\n";
	for (int i = 0; i < n; i++)
		for (int j = 0; j < (1 << n); j++)
			f(i, j | (1 << i));
	//cerr << "after 1st\n";
	int res = inf;
	int bi, bj;
	int bmask1, bmask2;

	//cerr << "before 2nd\n";
	for (int i = 0; i < n; i++)
	{
		for (int mask1 = 0; mask1 < (1 << n); mask1++)
		{
			int mask2 = ((1 << n) - 1) ^ (mask1 | (1 << i));
			for (int j = 0; j < n; j++)
			{
				int cres = max(f(i, mask1 | (1 << i)), f(j, mask2 | (1 << j)));
				if (cres < res)
				{
					res = cres;
					bi = i;
					bmask1 = mask1 | (1 << i);
					bj = j;
					bmask2 = mask2 | (1 << j);
				}
			}
		}
	}
	//cerr << "after 2nd\n";
	//cerr << res << endl;
	printf("%d\n", res);
	out(bi, bmask1);
	way.erase(unique(way.begin(), way.end()), way.end());
	printf("%d", way.size() - 1);
	for (int i = 0; i < (int)way.size(); i++)
		printf(" %d", way[i] + 1);
	way.resize(0);	
	out(bj, bmask2);
	way.erase(unique(way.begin(), way.end()), way.end());
	printf("\n%d", way.size() - 1);
	for (int i = 0; i < (int)way.size(); i++)
		printf(" %d", way[i] + 1);
	
}

#define task "immediate"
int main()
{
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	Load();
	Solve();
	return 0;
}