#include <set>
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cassert>
#include <cstdlib>

using namespace std;

#define TASKNAME "cube"
#define pb push_back
#define mp make_pair
#define fori(i,b,e) for(int i = (b); i < (e); ++i)
#define sz(a) (int)(a).size()

typedef long long int64;

vector<string> ans;

char s[10];
string desc[6];
int p[6];

const int neig[][4] = {
	{1,2,3,4},
	{0,2,4,5},
	{0,1,3,5},
	{0,2,4,5},
	{0,1,3,5},
	{1,2,3,4}
};

char col[7];
char c1[4], c2[4];
int n = 6;

set<string> res;

int perm[][6] = {
	{0,1,2,3,4,5},
	{2,3,0,1,5,4},
	{1,5,2,0,4,3}
};

bool contains() {
	string p = col;
	char r[7];
	r[6] = 0;
	fori(t,0,3) {
		fori(i,0,n) {
			r[i] = col[perm[t][i]];
		}
		fori(i,0,4) {
			if (res.find(r) != res.end()) {
				return true;
			}
			char temp = r[1];
			fori(j,1,4) {
				r[j] = r[j+1];
			}
			r[4] = temp;
		}
		reverse(r, r+6);
		fori(i,0,4) {
			if (res.find(r) != res.end()) {
				return true;
			}
			char temp = r[1];
			fori(j,1,4) {
				r[j] = r[j+1];
			}
			r[4] = temp;
		}
	}
	return false;
}

int main()
{
	assert(freopen(TASKNAME ".in", "rt", stdin));
	assert(freopen(TASKNAME ".out", "wt", stdout));
	col[n] = 0;
	fori(i,0,n) {
		scanf ("%s", s);
		desc[i] = s;
	}
	fori(i,0,n) {
		p[i] = i;
	}
	do {
		fori(i,0,n) {
			col[i] = desc[p[i]][0];
		}
		bool good = true;
		fori(i,0,n) {
			fori(j,0,4) {
				c1[j] = desc[p[i]][j+1];
				c2[j] = col[neig[i][j]];
			}
			sort(c1, c1+4);
			sort(c2, c2+4);
			fori(j,0,4) {
				good = good && (c2[j] == c1[j]);
			}
			if (!good) break;
		}
		if (good) {
//			assert(false);
			if (!contains()) {
				res.insert(col);
			}
		}
	} while (next_permutation(p, p+n));
	int cnt = 0;
	for (set<string>::iterator it = res.begin(); it != res.end(); ++it) {
		printf ("%s\n", it->c_str());
		cnt++;
		if (cnt == 2) break;
	}
	if (cnt == 0) {
		printf ("Impossible");
	}
	return 0;
}