#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cassert>
#include <cstdlib>
#include <cstring>

using namespace std;

#define TASKNAME "galaxy"
#define pb push_back
#define mp make_pair
#define fori(i,b,e) for(int i = (b); i < (e); ++i)
#define sz(a) (int)(a).size()

typedef long long int64;

const int maxn = 5000;
const int maxk = 10;

vector <int> es[maxn]; 
int color[maxn];
int is[maxn][maxk];

int q[maxn];
int used[maxn];
int hd, tl;

void paint(int v, int c)
{
  color[v] = c;
  used[v] = 1;
  for (int i = 0; i < sz(es[v]); i++)
  {
    if (!used[es[v][i]])
      q[tl++] = es[v][i];
    is[es[v][i]][c] = 1;
  }
}

int p[maxk];
int g[maxn][maxn];


int main()
{
	assert(freopen(TASKNAME ".in", "rt", stdin));
	assert(freopen(TASKNAME ".out", "wt", stdout));
	int n, k, m;
	scanf("%d%d%d", &n, &k, &m);
	for (int i = 0; i < m; i++)
	{
	  int u, v;
	  scanf("%d%d", &u, &v);
	  u--, v--;
	  es[u].pb(v);
	  es[v].pb(u);
	  g[u][v] = g[v][u] = 1;
	}

	memset(color, -1, sizeof(color));

	for (int i = 0; i < k; i++)
	  p[i] = i;

	do
	{
	  int bad = 0;
	  for (int i = 0; i < k; i++)
	    if (!g[p[i]][p[(i + 1) % k]])
	    {
	      bad = 1;
	      break;
	    }
	  if (!bad)
	    break;
	}
	while (next_permutation(p, p + k));
	

	for (int i = 0; i < k; i++)
	  paint(p[i], i);

	while (hd != tl)
	{
	  int i = q[hd++];
	  if (used[i])
	    continue; 
      for (int j = 0; j < k; j++)
   	    if (is[i][j] && !is[i][(j + 1) % k])
   	    {
   	      paint(i, (j + 1) % k);
   	      break;
   	    }
	}

	for (int i = 0; i < n; i++)
	  assert(color[i] != -1);

	for (int i = 0; i < n; i++)
	  printf("%d%c", color[i] + 1, "\n "[i != n - 1]);
	return 0;
}
