#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cassert>
#include <cstdlib>

using namespace std;

#define TASKNAME "immediate"
#define pb push_back
#define mp make_pair
#define fori(i,b,e) for(int i = (b); i < (e); ++i)
#define rep(i, n) fori(i, 0, n)
#define sz(a) (int)(a).size()

typedef long long int64;

const int inf = (1 << 30) - 1;
int c[20][20];
int dp[1 << 18][18];
int prev[20][20];

int main()
{
	assert(freopen(TASKNAME ".in", "rt", stdin));
	assert(freopen(TASKNAME ".out", "wt", stdout));

	int n, m;          
	scanf("%d%d", &n, &m);

	rep(i, n) rep(j, n) c[i][j] = inf;
	rep(i, m)
	{
		int q, w, e;
		scanf("%d%d%d", &q, &w, &e);
        c[q - 1][w - 1] = min(c[q - 1][w - 1], e);
        c[w - 1][q - 1] = min(c[w - 1][q - 1], e);				
	}

	rep(i, n) rep(j, n) prev[i][j] = i;

	rep(k, n) rep(i, n) rep(j, n) 
	{
		if(c[i][j] > c[i][k] + c[k][j])
		{
			c[i][j] = c[i][k] + c[k][j];
			prev[i][j] = prev[k][j];
		}
	}

	rep(mask, (1 << n)) rep(i, n) dp[mask][i] = inf;
    dp[1][0] = 0;

    rep(mask, (1 << n)) rep(i, n) 
    {
    	if((1 << i) & mask == 0) continue;
    	rep(j, n)
    	{
    		if((1 << j) & mask) continue;
    		dp[mask | (1 << j)][j] = min(dp[mask | (1 << j)][j], dp[mask][i] + c[i][j]);
    	}
    }

    int res = inf;

    //rep(i, n) rep(j, n) printf("%d%c", c[i][j], " \n"[j == n - 1]);
    //rep(mask, (1 << n)) rep(i, n) printf("%d%c", dp[mask][i] == inf ? -1 : dp[mask][i], " \n"[i == n - 1]);
    int omask = 0, ii = -1, jj = -1;
    
    rep(mask, (1 << n))
    {
    	rep(i, n) rep(j, n)
    	{
    		if(res > max(dp[mask|1][i], dp[(((1 << n) - 1) ^ mask) | 1][j]))
    		{
    			res = max(dp[mask|1][i], dp[(((1 << n) - 1) ^ mask) | 1][j]);
    			omask = mask;
    			ii = i;
    			jj = j; 
    		}
    	}
    }    
    /*
    rep(mask, (1 << n))
    {
    	int u = inf, t = inf;
    	rep(i, n) u = min(u, dp[mask|1][i]);
    	rep(j, n) t = min(t, dp[(((1 << n) - 1) ^ mask) | 1][j]);
    	printf("%d %d %d %d\n", mask|1, (((1 << n) - 1) ^ mask) | 1, u, t);
    }    
    */

    printf("%d\n", res);
    int mask = omask|1;
    int ans[20], t = 0;
    while(mask != 1)
    {
    	rep(j, n) if(dp[mask][ii] == dp[mask ^ (1 << ii)][j] + c[j][ii])
    	{
    		mask ^= 1 << ii;
    		while(ii != j) ans[t++] = ii, ii = prev[j][ii];
    		break;
    	}
    }
    printf("%d 1 ", t);
    while(t --> 0) printf("%d ", ans[t] + 1);
    printf("\n");
    ii = jj;
    mask = (((1 << n) - 1) ^ omask) | 1;
    t = 0;    
    while(mask != 1)
    {
    	rep(j, n) if(dp[mask][ii] == dp[mask ^ (1 << ii)][j] + c[j][ii])
    	{
    		mask ^= 1 << ii;
    		while(ii != j) ans[t++] = ii, ii = prev[j][ii];
    		break;
    	}
    }
    printf("%d 1 ", t);
    while(t --> 0) printf("%d ", ans[t] + 1);
    
	return 0;
}