import java.util.*;
import java.io.*;

public class C implements Runnable {
	private MyScanner in;
	private PrintWriter out;
	private final String fileName = "cube";

	private char[][] vis;

	private TreeSet<String> all;
	private int[] p1 = new int[] { 0, 4, 1, 2, 3, 5 };
	private int[] p2 = new int[] { 4, 1, 0, 3, 5, 2 };
	private int[] p3 = new int[] { 3, 0, 2, 5, 4, 1 };

	private void gen(String s) {
		all.add(s);
		char[] next = new char[6];
		for (int i = 0; i < 6; ++i) {
			next[i] = s.charAt(p1[i]);
		}
		String st = new String(next);
		if (!all.contains(st)) {
			gen(st);
		}
		for (int i = 0; i < 6; ++i) {
			next[i] = s.charAt(p2[i]);
		}
		st = new String(next);
		if (!all.contains(st)) {
			gen(st);
		}
		for (int i = 0; i < 6; ++i) {
			next[i] = s.charAt(p3[i]);
		}
		st = new String(next);
		if (!all.contains(st)) {
			gen(st);
		}
	}

	private String min(String s) {
		all.clear();
		gen(s);
		return all.first();
	}
	
	private void sort(char[][] s) {
		for (int i = 0; i < 5; ++i) {
			for (int j = i + 1; j < 6; ++j) {
				boolean ch = false;
				for (int k = 0; k < 5; ++k) {
					if (s[i][k] < s[j][k]) {
						break;
					}
					if (s[i][k] > s[j][k]) {
						ch = true;
						break;
					}
				}
				if (ch) {
					for (int k = 0; k < 5; ++k) {
						char c = s[i][k];
						s[i][k] = s[j][k];
						s[j][k] = c;
					}
				}
			}
		}
	}
	
	private void sort(char[] s) {
		for (int j = 0; j < 4; ++j) {
			for (int k = j + 1; k < 5; ++k) {
				if (s[j] > s[k]) {
					char c = s[j];
					s[j] = s[k];
					s[k] = c;
				}
			}
		}
	}

	private void solve() {
		vis = new char[6][5];
		for (int i = 0; i < 6; ++i) {
			vis[i] = in.next().toCharArray();
			sort(vis[i]);
		}
		sort(vis);
		all = new TreeSet<String>();
		char[] perm = new char[6];
		ArrayList<Character> ar = new ArrayList<Character>();
		for (int i = 0; i < 6; ++i) {
			for (int j = 0; j < 5; ++j) {
				boolean found = false;
				for (int k = 0; k < ar.size(); ++k) {
					if (vis[i][j] == ar.get(k)) {
						found = true;
						break;
					}
				}
				if (!found) {
					ar.add(vis[i][j]);
				}
			}
		}
		if (ar.size() > 6) {
			out.println("Impossible");
			return;
		}
		TreeSet<String> ans = new TreeSet<String>();
		for (char c0 : ar) {
			for (char c1 : ar) {
				for (char c2 : ar) {
					for (char c3 : ar) {
						for (char c4 : ar) {
							for (char c5 : ar) {
								perm[0] = c0;
								perm[1] = c1;
								perm[2] = c2;
								perm[3] = c3;
								perm[4] = c4;
								perm[5] = c5;
								char[][] cs = new char[6][5];
								for (int i = 0; i < 6; ++i) {
									int pos = 0;
									for (int j = 0; j < 6; ++j) {
										if (i == j) {
											continue;
										}
										cs[i][pos++] = perm[j];
									}
									sort(cs[i]);
								}
								sort(cs);
								boolean ok = true;
								for (int i = 0; i < 6; ++i) {
									for (int j = 0; j < 5; ++j) {
										if (vis[i][j] != cs[i][j]) {
											ok = false;
											break;
										}
									}
									if (!ok) {
										break;
									}
								}
								if (!ok) {
									continue;
								}
								String cmin = min(new String(perm));
								ans.add(cmin);
							}
						}
					}
				}
			}
		}
		if (ans.size() == 0) {
			out.println("Impossible");
			return;
		}
		String f = ans.first();
		out.println(f);
		ans.remove(f);
		if (!ans.isEmpty()) {
			out.println(ans.first());
		}
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			in = new MyScanner(fileName);
			out = new PrintWriter(new File(fileName + ".out"));
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new C().run();
	}

	static class MyScanner {
		private BufferedReader br;
		private StringTokenizer st;

		public MyScanner(String fn) {
			try {
				br = new BufferedReader(new FileReader(fn + ".in"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		private String nextToken() {
			try {
				while (st == null || !st.hasMoreTokens()) {
					st = new StringTokenizer(br.readLine());
				}
				return st.nextToken();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			return nextToken();
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}
}
