import java.util.*;
import java.io.*;

public class C implements Runnable {
	private MyScanner in;
	private PrintWriter out;
	private final String fileName = "cube";

	private char[][] vis;

	private void solve() {
		vis = new char[6][5];
		int[] num = new int[26];
		for (int i = 0; i < 6; ++i) {
			vis[i] = in.next().toCharArray();
			for (int j = 0; j < 5; ++j) {
				num[vis[i][j] - 'A']++;
			}
		}
		char[] s = new char[6];
		int pos = 0;
		for (int i = 0; i < 26; ++i) {
			if (num[i] % 5 != 0) {
				out.println("Impossible");
				return;
			}
			num[i] /= 5;
			for (int j = 0; j < num[i]; ++j) {
				s[pos++] = (char) ('A' + i);
			}
		}
		for (int i = 0; i < 6; ++i) {
			int dist = 0;
			int[] cur = new int[26];
			for (int j = 0; j < 5; ++j) {
				cur[vis[i][j] - 'A']++;
			}
			for (int j = 0; j < 26; ++j) {
				dist += Math.abs(num[j] - cur[j]);
			}
			if (dist != 1) {
				out.println("Impossible");
				return;
			}
		}
		int diff = 0;
		for (int i = 0; i < 26; ++i) {
			if (num[i] > 0) {
				++diff;
			}
		}
		if (diff <= 2) {
			for (int i = 0; i < 26; ++i) {
				for (int j = 0; j < num[i]; ++j) {
					out.print((char)('A' + i));
				}
			}
			out.println();
			return;
		}
		if (diff == 6) {
			int last = 25;
			while (num[last] == 0) {
				--last;
			}
			num[last]--;
			out.print((char)('A' + last));
			for (int i = 0; i < 26; ++i) {
				for (int j = 0; j < num[i]; ++j) {
					out.print((char)('A' + i));
				}
			}
			out.println();
			int pr = 0;
			for (int i = 0; i < 26; ++i) {
				for (int j = 0; j < num[i]; ++j) {
					out.print((char)('A' + i));
					++pr;
					if (pr == 1) {
						out.print((char)('A' + last));
					}
				}
			}			
			out.println();
			return;
		}
		int two = 0;
		while (num[two] < 2) {
			++two;
		}
		int other = 0;
		while (other == two || num[other] == 0) {
			++other;
		}
		num[two] -= 2;
		num[other]--;
		out.print((char)('A' + two));
		out.print((char)('A' + other));
		for (int i = 0; i < 26; ++i) {
			for (int j = 0; j < num[i]; ++j) {
				out.print((char)('A' + i));
			}
		}
		out.print((char)('A' + two));
		out.println();
		out.print((char)('A' + two));
		out.print((char)('A' + two));
		for (int i = 0; i < 26; ++i) {
			for (int j = 0; j < num[i]; ++j) {
				out.print((char)('A' + i));
			}
		}
		out.print((char)('A' + other));
		out.println();
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			in = new MyScanner(fileName);
			out = new PrintWriter(new File(fileName + ".out"));
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new C().run();
	}

	static class MyScanner {
		private BufferedReader br;
		private StringTokenizer st;

		public MyScanner(String fn) {
			try {
				br = new BufferedReader(new FileReader(fn + ".in"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		private String nextToken() {
			try {
				while (st == null || !st.hasMoreTokens()) {
					st = new StringTokenizer(br.readLine());
				}
				return st.nextToken();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			return nextToken();
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}
}
