import java.util.*;
import java.io.*;

public class D implements Runnable {
	private MyScanner in;
	private PrintWriter out;
	private final String fileName = "dice";

	private void solve() {
		int n = in.nextInt();
		Dice[] d = new Dice[n];
		for (int i = 0; i < n; ++i) {
			d[i] = new Dice(i, in.nextInt());
		}
		Arrays.sort(d);
		int[][] ans = new int[n][];
		int cur = 1;
		double exp = 0.;
		for (int i = 0; i < n; ++i) {
			int cn = d[i].num;
			ans[cn] = new int[d[i].a];
			for (int j = 0; j < d[i].a; ++j) {
				ans[cn][j] = cur++;
			}
			exp += 0.5 * (ans[cn][0] + ans[cn][d[i].a - 1]);
		}
		out.println(exp);
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < ans[i].length; ++j) {
				out.print(ans[i][j] + " ");
			}
			out.println();
		}
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			in = new MyScanner(fileName);
			out = new PrintWriter(new File(fileName + ".out"));
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new D().run();
	}

	static class MyScanner {
		private BufferedReader br;
		private StringTokenizer st;

		public MyScanner(String fn) {
			try {
				br = new BufferedReader(new FileReader(fn + ".in"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		private String nextToken() {
			try {
				while (st == null || !st.hasMoreTokens()) {
					st = new StringTokenizer(br.readLine());
				}
				return st.nextToken();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			return nextToken();
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}
	
	static class Dice implements Comparable<Dice> {
		public int num, a;

		public Dice(int num, int a) {
			this.num = num;
			this.a = a;
		}

		@Override
		public int compareTo(Dice o) {
			return o.a - a;
		}		
	}
}
