import java.util.*;
import java.io.*;

public class H implements Runnable {
	private MyScanner in;
	private PrintWriter out;
	private final String fileName = "high";
	
	private int n;
	private char[][] s;
	
	private final long MUL = 100;
	
	private int ch(char c) {
		if (c >= 'a' && c <= 'z') {
			return c - 'a';
		}
		if (c >= 'A' && c <= 'Z') {
			return 26 + c - 'A';
		}
		return 52 + c - '0';
	}
	
	private long hash(int snum, int mask) {
		long ans = 0;
		for (int i = 0; i < 5; ++i) {
			if ((mask & (1 << i)) != 0) {
				ans = MUL * ans + ch(s[snum][i]);
			}
		}
		return ans;
	}

	private void solve() {
		n = in.nextInt();
		s = new char[n][];
		for (int i = 0; i < n; ++i) {
			s[i] = in.next().toCharArray();
		}
		HashMap<Long, Integer> map = new HashMap<Long, Integer>();
		long[] eq = new long[1 << 5];
		for (int mask = 0; mask < (1 << 5); ++mask) {
			map.clear();
			for (int i = 0; i < n; ++i) {
				long cur = hash(i, mask);
				if (!map.containsKey(cur)) {
					map.put(cur, 1);
				} else {
					map.put(cur, map.get(cur) + 1);
				}				
			}
			for (long l: map.values()) {
				eq[mask] += l * (l - 1) / 2;
			}
		}
		long[] ans = new long[6];
		for (int mask = 0; mask < (1 << 5); ++mask) {
			long cur = 0;
			for (int j = 0; j < (1 << 5); ++j) {
				if ((j & mask) != mask) {
					continue;
				}
				int xor = mask ^ j;
				if (Integer.bitCount(xor) % 2 == 0) {
					cur += eq[j];
				} else {
					cur -= eq[j];
				}
			}
			ans[Integer.bitCount(mask)] += cur;
		}
		for (int i = 0; i < 6; ++i) {
			out.print(ans[5 - i] + " ");
		}
		out.println();
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			in = new MyScanner(fileName);
			out = new PrintWriter(new File(fileName + ".out"));
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new H().run();
	}

	static class MyScanner {
		private BufferedReader br;
		private StringTokenizer st;

		public MyScanner(String fn) {
			try {
				br = new BufferedReader(new FileReader(fn + ".in"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		private String nextToken() {
			try {
				while (st == null || !st.hasMoreTokens()) {
					st = new StringTokenizer(br.readLine());
				}
				return st.nextToken();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			return nextToken();
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}
}
