import java.util.*;
import java.io.*;

public class J implements Runnable {
	private MyScanner in;
	private PrintWriter out;
	private final String fileName = "john";

	public Card[] swap(Card[] c) {
		for (int i = 0; i < c.length; i++) {
			int t = c[i].blue;
			c[i].blue = c[i].red;
			c[i].red = t;
		}
		return c;
	}

	Card[] t;

	public long merge(Card[] c, int l, int r) {
		if (r == l) {
			return 0;
		}
		int mid = (r + l) / 2;
		long ans = merge(c, l, mid) + merge(c, mid + 1, r);
		int left = l;
		int right = mid + 1;
		int last = l;
		while (left <= mid || right <= r) {
			if (left > mid && right <= r) {
				t[last] = c[right];
				last++;
				right++;
				continue;
			}
			if (right > r && left <= mid) {
				// ans += mid - left;
				t[last] = c[left];
				last++;
				left++;
				continue;
			}
			if (c[right].blue >= c[left].blue) {
				t[last] = c[left];
				last++;
				left++;
			} else {
				t[last] = c[right];
				ans += mid - left + 1;
				last++;
				right++;
			}
		}
		c = Arrays.copyOf(t, t.length);
		return ans;
	}

	public long calc(Card[] c) {
		Arrays.sort(c);
		t = new Card[c.length];
		long inv = merge(c, 0, c.length - 1);
		return inv;
	}

	private void solve() {
		int n = in.nextInt();
		Card[] c = new Card[n];
		for (int i = 0; i < n; ++i) {
			int r = in.nextInt();
			int b = in.nextInt();
			c[i] = new Card(r, b);
		}
		long ans = Math.min(calc(c), calc(swap(c)));
		out.println(ans);

	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			in = new MyScanner(fileName);
			out = new PrintWriter(new File(fileName + ".out"));
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new J().run();
	}

	static class MyScanner {
		private BufferedReader br;
		private StringTokenizer st;

		public MyScanner(String fn) {
			try {
				br = new BufferedReader(new FileReader(fn + ".in"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		private String nextToken() {
			try {
				while (st == null || !st.hasMoreTokens()) {
					st = new StringTokenizer(br.readLine());
				}
				return st.nextToken();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			return nextToken();
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	static class Card implements Comparable<Card> {
		public int red, blue;

		public Card(int red, int blue) {
			this.red = red;
			this.blue = blue;
		}

		@Override
		public int compareTo(Card o) {
			if (red == o.red) {
				return blue - o.blue;
			} else
				return red - o.red;

		}

		@Override
		public String toString() {
			return "[" + red + " " + blue + "]";
		}
	}
}
