#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
using namespace std;
#define ll long long



int per[6];

class Cube
{
	public:
	int f, bc, bt, t, l, r;
	Cube(){}
	Cube(int f, int bc, int bt, int t, int l, int r) : f(f), bc(bc), bt(bt), t(t), l(l), r(r){}
	inline void rotateLeft()
	{
		int tt = f;
		f = l;
		l = bc;
		bc = r;
		r = tt;
	}
	inline void rotateUp()
	{
		int tt = f;
		f = bt;
		bt = bc;
		bc = t;
		t = tt;
	}
	inline void rotateWest()
	{
		int tt = t;
		t = r;
		r = bt;
		bt = l;
		l = tt;
	}
	inline string toStr()
	{
		string s;
		s += (char)t;
		s += (char)l;
		s += (char)f;
		s += (char)r;
		s += (char)bc;
		s += (char)bt;
		return s;
	}
	inline string get(int j)
	{
		string s;
		if (j == 0)
		{
			s += (char)f;
			s += (char)t;
			s += (char)r;
			s += (char)l;
			s += (char)bt;
		}
		else if (j == 1)
		{
			s += (char)r;
			s += (char)f;
			s += (char)t;
			s += (char)bc;
			s += (char)bt;
		}
		else if (j == 2)
		{
			s += (char)bc;
			s += (char)l;
			s += (char)r;
			s += (char)bt;
			s += (char)t;
		}
		else if (j == 3)
		{
			s += (char)l;
			s += (char)f;
			s += (char)bc;
			s += (char)bt;
			s += (char)t;
		}
		else if (j == 4)
		{
			s += (char)bt;
			s += (char)l;
			s += (char)r;
			s += (char)bc;
			s += (char)f;
		}
		else if (j == 5)
		{
			s += (char)t;
			s += (char)l;
			s += (char)r;
			s += (char)bc;
			s += (char)f;
		}
		sort(s.begin() + 1, s.end());
		return s;
	}
	inline void unique()
	{
		Cube t1;
		Cube c;
		t1 = *this;
		string s = this -> toStr();
		c = *this;
		for (int i = 0; i < 4; i++)
		{
			for (int j = 0; j < 4; j++)
			{
				if (t1.toStr() < s)
				{
					s = t1.toStr();
					c = t1;
				}
				t1.rotateLeft();
			}
			t1.rotateUp();
		}
		t1.rotateWest();
		for (int j = 0; j < 4; j++)
		{
			if (t1.toStr() < s)
			{
				s = t1.toStr();
				c = t1;
			}
			t1.rotateLeft();
		}
		t1.rotateWest();
		t1.rotateWest();
		for (int j = 0; j < 4; j++)
		{
			if (t1.toStr() < s)
			{
				s = t1.toStr();
				c = t1;
			}
			t1.rotateLeft();
		}
		*this = c;
	}
};


vector <int> colors;
string s[6];
void load()
{
	for (int i = 0; i < 6; i++)
	{
		cin >> s[i];
		for (int j = 0; j < 5; j++)
			colors.push_back(s[i][j]);
		sort(s[i].begin() + 1, s[i].end());
	}
}
int a[6];
string cc[6];
vector <string> all;

inline void check()
{
	Cube c;
	c.f = a[0];
	c.r = a[1];
	c.bc = a[2];
	c.l = a[3];
	c.bt = a[4];
	c.t = a[5];
	c.unique();
	for (int i = 0; i < 6; i++)
	{
		cc[i] = c.get(i);
		per[i] = i;
	}
	int cnt = 0;
	while (true)
	{
		bool ok = true;
		for (int i = 0; ok && i < 6; i++)
			if (s[per[i]] != cc[i])
				ok = false;
		if (ok)
			cnt = 1;
		if (!next_permutation(per, per + 6)) break;
	}
	if (cnt)
		all.push_back(c.toStr());
}

inline void go(int i)
{
	if (i == 6)
	{
		check();
		return;
	}
	for (int j = 0; j < colors.size(); j++)
	{
		a[i] = colors[j];
		go(i + 1);
	}
}

void solve()
{
	
	sort(colors.begin(), colors.end());
	colors.erase(unique(colors.begin(), colors.end()), colors.end());
	if (colors.size() > 6)
	{
		printf("Impossible");
		return;
	}
	go(0);
	sort(all.begin(), all.end());
	all.erase(unique(all.begin(), all.end()), all.end());
	if (all.size() == 0)
	{
		printf("Impossible");
		return;
	}
	for (int i = 0; i < all.size(); i++)
	{
		printf("%s\n", all[i].c_str());
	}
}
#define file "cube"
int main()
{
	freopen(file".in", "rt", stdin);
	freopen(file".out", "wt", stdout);
	load();
	solve();
}                   


