import static java.util.Arrays.sort;

import java.io.*;
import java.util.*;

public class C {

	static int[] p;
	static boolean[] was;
	static Set<Cube> answer;
	static char[] d;
	static char[] tmp;

	static void solve() throws Exception {
		String[] s = new String[6];
		char[] c = new char[6];
		for (int i = 0; i < 6; i++) {
			char[] e = next().toCharArray();
			sort(e, 1, e.length);
			s[i] = new String(e);
			c[i] = s[i].charAt(0);
		}
		sort(c);
		answer = new HashSet<Cube>();
		d = new char[6];
		tmp = new char[5];
		was = new boolean[6];
		p = new int[6];
		go(0, 6, c, s);
		if (answer.isEmpty()) {
			out.println("Impossible");
		} else if (answer.size() == 1) {
			out.println(cubeToString(answer.iterator().next()));
		} else {
			Iterator<Cube> it = answer.iterator();
			out.println(cubeToString(it.next()));
			out.println(cubeToString(it.next()));
		}
	}

	static String cubeToString(Cube e) {
		char[] c = e.s.toCharArray();
		char tmp = c[3];
		c[3] = c[4];
		c[4] = tmp;
		return new String(c);
	}

	static int[] rev(int[] p) {
		int[] ret = new int[p.length];
		for (int i = 0; i < ret.length; i++) {
			ret[p[i]] = i;
		}
		return ret;
	}

	static class Cube {
		String s;

		public Cube(String s) {
			this.s = getUnique(s);
		}

		static Set<String> was;
		static int[][] PERM = { { 0, 2, 4, 1, 3, 5 }, { 2, 1, 5, 0, 4, 3 }, {},
				{} };
		static {
			PERM[2] = rev(PERM[0]);
			PERM[3] = rev(PERM[1]);
		}

		static String getUnique(String s) {
			was = new HashSet<String>();
			return dfs(s);
		}

		static String dfs(String s) {
			was.add(s);
			char[] c = s.toCharArray();
			String ret = s;
			for (int[] p : PERM) {
				char[] d = new char[c.length];
				for (int i = 0; i < p.length; i++) {
					d[i] = c[p[i]];
				}
				String newString = new String(d);
				if (was.contains(newString)) {
					continue;
				}
				String got = dfs(newString);
				if (ret.compareTo(got) > 0) {
					ret = got;
				}
			}
			return ret;
		}

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + ((s == null) ? 0 : s.hashCode());
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Cube other = (Cube) obj;
			if (s == null) {
				if (other.s != null)
					return false;
			} else if (!s.equals(other.s))
				return false;
			return true;
		}

	}

	private static void go(int x, int n, char[] c, String[] s) {
		if (x == n) {
			check(c, s);
			return;
		}
		for (int i = 0; i < n; i++) {
			if (was[i]) {
				continue;
			}
			was[i] = true;
			p[x] = i;
			go(x + 1, n, c, s);
			was[i] = false;
		}
	}

	private static void check(char[] c, String[] s) {
		for (int i = 0; i < 6; i++) {
			d[i] = c[p[i]];
		}
		boolean[] was = new boolean[s.length];
		for (int i = 0; i < 6; i++) {
			tmp[0] = d[i];
			int cur = 1;
			for (int j = 0; j < 6; j++) {
				if (i + j == 5 || i == j) {
					continue;
				}
				tmp[cur++] = d[j];
			}
			sort(tmp, 1, 5);
			String str = new String(tmp);
			boolean found = false;
			for (int j = 0; j < s.length; j++) {
				if (was[j] || !str.equals(s[j])) {
					continue;
				}
				was[j] = true;
				found = true;
				break;
			}
			if (!found) {
				return;
			}
		}
		answer.add(new Cube(new String(d)));
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("cube.in"));
		out = new PrintWriter("cube.out");
		solve();
		out.close();
	}
}
