import static java.util.Arrays.sort;

import java.io.*;
import java.util.StringTokenizer;

public class D {

	static class Dice implements Comparable<Dice> {
		int cnt;
		int num;

		public Dice(int cnt, int num) {
			super();
			this.cnt = cnt;
			this.num = num;
		}

		@Override
		public int compareTo(Dice o) {
			return cnt - o.cnt;
		}

	}

	static void solve() throws Exception {
		int n = nextInt();
		Dice[] d = new Dice[n];
		int cur = 0;
		for (int i = 0; i < n; i++) {
			d[i] = new Dice(nextInt(), i);
			cur += d[i].cnt;
		}
		sort(d);
		int[][] ans = new int[n][];
		double exp = 0;
		for (Dice e : d) {
			int[] z = new int[e.cnt];
			for (int i = 0; i < e.cnt; i++) {
				z[i] = cur--;
				exp += 1. * z[i] / e.cnt;
			}
			ans[e.num] = z;
		}
		out.println(exp);
		for (int[] e : ans) {
			for (int j : e) {
				out.print(j + " ");
			}
			out.println();
		}
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("dice.in"));
		out = new PrintWriter("dice.out");
		solve();
		out.close();
	}
}
