import static java.util.Arrays.fill;

import java.io.*;
import java.util.StringTokenizer;

public class E {
	
	static char ans[][];
	
	static void init(int h, int w) {
		ans = new char[h][w];
		for (char a[]: ans) {
			fill(a, '.');
		}
	}
	
	static void output() {
		out.print(ans.length);
		out.print(' ');
		out.print(ans[0].length);
		for (char a[]: ans) {
			out.println();
			out.print(a);
		}
	}
	
	static char merge(char a, char b) {
		if (a == '.') {
			return b;
		}
		if (b == '.') {
			return a;
		}
		if (a == '/' && b == '\\' || a == '\\' && b == '/') {
			return 'X';
		}
//		throw new AssertionError();
		System.err.println("???");
		return '?';
	}
	
	static void apply(int i, int j, char c) {
		ans[i][j] = merge(ans[i][j], c);
	}
	
	static void apply(int i, int j, char c[][]) {
		for (int ii = 0; ii < c.length; ii++) {
			for (int jj = 0; jj < c[ii].length; jj++) {
				apply(i + ii, j + jj, c[ii][jj]);
			}
		}
	}
	
	static char[][] pattern(String s, int h) {
		int w = s.length() / h;
		char res[][] = new char[h][w];
		for (int i = 0; i < s.length(); i++) {
			res[i / w][i % w] = s.charAt(i);
		}
		return res;
	}
	
	static final char[][] SPLIT6 = pattern("\\/\\/\\/\\/\\/\\../\\......\\.L.7\\.....\\L7..\\..........\\..........\\", 6);
	static final char[][] SPLIT = pattern("../\\..../\\L.....L..X77\\.L7\\L/..\\", 4);
	static final char[][] TURN = pattern("/\\./L.7.L7..", 3);
	static final char[][] TURN2 = pattern("/\\.L.7L7.", 3);
	static final char[][] MERGE = pattern(".X7/..", 2);

	static void solve() throws Exception {
		int n = nextInt();
		int m = nextInt();
		boolean dep[][] = new boolean[n][m];
		for (int i = 0; i < n; i++) {
			String s = next();
			for (int j = 0; j < m; j++) {
				switch (s.charAt(j)) {
				case '1':
					dep[i][j] = true;
					break;
				case '0':
					break;
				default:
					throw new AssertionError();
				}
			}
		}
		int finalWidth = 1000;
		init(6 * n - 6 + 4 * m + 3, finalWidth);
		int curI = 4 * m + 2;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < curI; j++) {
				apply(i + j, j, '\\');
			}
		}
		int curJ = curI + n / 2 * 10 + (n - 1) * 2;
		for (int i = 0; i < n / 2; i++) {
			for (int j = 0; j < i * 10; j++) {
				apply(curI + 2 * i + j, curI + j, '\\');
				apply(curI + 2 * i + j + 1, curI + j, '\\');
			}
			apply(curI + i * 12, curI + i * 10, SPLIT6);
			for (int j = curI + (i + 1) * 10; j < curJ - 4 * i; j++) {
				apply(curI + i * 12, j, j % 2 == 0 ? '\\' : '/');
			}
			for (int j = curI + (i + 1) * 10; j < curJ - 4 * i - 2; j++) {
				apply(curI + i * 12 + 6, j, j % 2 == 0 ? '\\' : '/');
			}
		}
		if (n % 2 != 0) {
			for (int i = curI; i < curJ - 2 * (n - 1); i++) {
				apply(n - 1 + i, i, '\\');
			}
		}
		boolean haveInput[] = new boolean[n];
		fill(haveInput, true);
		for (int numOut = 0; numOut < m; numOut++) {
			boolean firstInput = true;
			for (int numIn = 0; numIn < n; numIn++) {
				int si = curI + 6 * numIn;
				int sj = curJ - 2 * numIn;
				if (!firstInput && !dep[numIn][numOut]) {
					int ci = si;
					int cj = sj;
					ci -= 3;
					cj += 4;
					int dif = ci - (4 * numOut + 3);
					ci -= dif;
					cj += dif;
					ci -= 2;
					++cj;
					for (int i = 0; i < 4; i++) {
						apply(ci, cj + i, i % 2 == 0 ? '\\' : '/');
					}
				}
				boolean willBeUsed = false;
				for (int i = numOut + 1; i < m; i++) {
					if (dep[numIn][i]) {
						willBeUsed = true;
						break;
					}
				}
				if (!willBeUsed) {
					haveInput[numIn] = false;
				}
				if (haveInput[numIn]) {
					for (int i = dep[numIn][numOut] ? 8 : 0; i < 4 + 4 * n; i++) {
						apply(si, sj + i, i % 2 == 0 ? '\\' : '/');
					}
				}
				if (!dep[numIn][numOut]) {
					continue;
				}
				if (willBeUsed) {
					apply(si - 4, sj, SPLIT);
				} else {
					apply(si - 3, sj, TURN);
				}
				si -= 3;
				sj += 4;
				while (si > 4 * numOut + 3) {
					apply(si - 1, sj, '/');
					--si;
					++sj;
				}
				if (firstInput) {
					apply(si - 3, sj, TURN2);
					firstInput = false;
				} else {
					apply(si - 2, sj, MERGE);
				}
				apply(si - 2, sj + 3, '\\');
				apply(si - 2, sj + 4, '/');
			}
			curJ += 4 + 4 * n;
			int si = 4 * numOut;
			int sj = curJ + curI - si - 5;
			if (numOut % 2 == 0) {
				++si;
			} else {
				apply(si - 2, sj, TURN2);
				--si;
				sj += 3;
			}
			while (si > numOut) {
				--si;
				apply(si, sj, '/');
				++sj;
			}
			while (sj < finalWidth) {
				apply(si, sj, sj % 2 == 0 ? '\\' : '/');
				++sj;
			}
		}
		output();
	}
	
	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("electro.in"));
		out = new PrintWriter("electro.out");
		solve();
		out.close();
	}
}
