import static java.util.Arrays.fill;

import java.io.*;
import java.util.*;

public class G {

	static List<Integer>[] edgesCycle;
	static List<Integer>[] edges;

	static void solve() throws Exception {
		int n = nextInt();
		int k = nextInt();
		int m = nextInt();
		edgesCycle = new List[k];
		edges = new List[n];
		for (int i = 0; i < k; i++) {
			edgesCycle[i] = new ArrayList<Integer>();
		}
		for (int i = 0; i < n; i++) {
			edges[i] = new ArrayList<Integer>();
		}
		for (int i = 0; i < m; i++) {
			int from = nextInt() - 1;
			int to = nextInt() - 1;
			if (from < k && to < k) {
				edgesCycle[from].add(to);
				edgesCycle[to].add(from);
			}
			edges[from].add(to);
			edges[to].add(from);
		}
		int[] color = new int[n];
		fill(color, -1);
		{
			color[0] = 0;
			all: for (int i = 0, col = 1; col < k; col++) {
				for (int j : edgesCycle[i]) {
					if (color[j] < 0) {
						color[j] = col;
						i = j;
						continue all;
					}
				}
				throw new AssertionError();
			}
		}
		Queue<Integer> q = new ArrayDeque<Integer>();
		boolean[] was = new boolean[n];
		for (int i = 0; i < k; i++) {
			was[i] = true;
			q.add(i);
		}
		boolean[] hasIt = new boolean[k];
		while (!q.isEmpty()) {
			int v = q.poll();
			for (int i : edges[v]) {
				if (was[i]) {
					continue;
				}
				was[i] = true;
				q.add(i);
			}
			if (v < k) {
				continue;
			}
			fill(hasIt, false);
			for (int i : edges[v]) {
				if (color[i] >= 0) {
					hasIt[color[i]] = true;
				}
			}
			for (int i = 0; i < k; i++) {
				int j = i + 1;
				if (j == k) {
					j = 0;
				}
				if (!hasIt[i] && hasIt[j]) {
					color[v] = i;
				}
			}
			if (color[v] < 0) {
				throw new AssertionError();
			}
		}
		for (int i : color) {
			out.print(1 + i + " ");
		}
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("galaxy.in"));
		out = new PrintWriter("galaxy.out");
		solve();
		out.close();
	}
}
