import java.io.*;
import java.util.*;

public class H {

	static void solve() throws Exception {
		int n = nextInt();
		int[][] a = new int[n][5];
		for (int i = 0; i < n; i++) {
			String s = next();
			for (int j = 0; j < 5; j++) {
				a[i][j] = code(s.charAt(j));
			}
		}
		int[] code = new int[n];
		long[] cnt = new long[32];
		for (int mask = 0; mask < 32; mask++) {
			int[] bits = bitList(mask);
			for (int i = 0; i < n; i++) {
				code[i] = code(a[i], bits);
			}
			int max = 1;
			for (int i = 0; i < bits.length; i++) {
				max *= 62;
			}
			cnt[mask] = getPairs(code, max);
		}

		long[] good = new long[32];
		for (int mask = 0; mask < 32; mask++) {
			for (int submask = 0; submask < 32; submask++) {
				if ((mask & submask) != mask) {
					continue;
				}
				int bitcnt = Integer.bitCount(mask ^ submask);
				if (bitcnt % 2 == 0) {
					good[mask] += cnt[submask];
				} else {
					good[mask] -= cnt[submask];
				}
			}
		}
		// System.err.println(Arrays.toString(good));
		long[] res = new long[6];
		for (int i = 0; i < 32; i++) {
			res[5 - Integer.bitCount(i)] += good[i];
		}
		for (int i = 0; i < 6; i++) {
			out.print(res[i] + " ");
		}
	}

	static long getPairs(int[] code, int max) {
		long res = 0;
		if (max <= MAXCODE) {
			for (int i : code) {
				res += count[i];
				count[i]++;
			}
			for (int i : code) {
				count[i] = 0;
			}
		} else {
			for (int i : code) {
				Integer c = hm.get(i);
				if (c == null) {
					c = 0;
				}
				res += c;
				hm.put(i, c + 1);
			}
			hm.clear();
		}
		return res;
	}

	static final Map<Integer, Integer> hm = new HashMap<Integer, Integer>();
	static final int MAXCODE = 1 << 24;
	static int[] count = new int[MAXCODE];

	static int[] mul = new int[] { 1, 62, 62 * 62, 62 * 62 * 62,
			62 * 62 * 62 * 62 };

	static int code(int[] a, int[] bits) {
		int res = 0;
		int mul = 1;
		for (int i = 0; i < bits.length; i++) {
			res += mul * a[bits[i]];
			mul *= 62;
		}
		return res;
	}

	static int[] bitList(int mask) {
		int[] bit = new int[Integer.bitCount(mask)];
		int cnt = 0;
		for (int i = 0; i < 5; i++) {
			if ((mask & (1 << i)) != 0) {
				bit[cnt++] = i;
			}
		}
		return bit;
	}

	static int code(char c) {
		if (c >= '0' && c <= '9') {
			return c - '0';
		}
		if (c >= 'a' && c <= 'z') {
			return c - 'a' + 10;
		}
		return c - 'A' + 10 + 26;
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("high.in"));
		out = new PrintWriter("high.out");
		solve();
		out.close();
	}
}
