import static java.util.Arrays.fill;

import java.io.*;
import java.util.*;

public class I {

	final static int INF = Integer.MAX_VALUE / 2;

	static void solve() throws Exception {
		int n = nextInt();
		int m = nextInt();
		int[][] g = new int[n][n];
		for (int i = 0; i < m; i++) {
			int x = nextInt() - 1, y = nextInt() - 1;
			int t = nextInt();
			g[x][y] = t;
			g[y][x] = t;
		}
		int[][] dp = new int[1 << n][n];
		int[][] p = new int[1 << n][n];
		for (int[] dd : dp) {
			fill(dd, INF);
		}

		dp[1][0] = 0;

		for (int mask = 1; mask < 1 << n; mask++) {
			relax(dp, p, g, mask);
			for (int man = 0; man < n; man++) {
				if ((mask & (1 << man)) == 0) {
					continue;
				}
				int cost = dp[mask][man];
				if (cost == INF) {
					continue;
				}
				int state = state(mask, man, n);
				for (int add = 0; add < n; add++) {
					if ((mask & (1 << add)) != 0) {
						continue;
					}
					if (g[man][add] == 0) {
						continue;
					}
					int newcost = cost + g[man][add];
					int mask1 = mask | (1 << add);
					if (dp[mask1][add] > newcost) {
						dp[mask1][add] = newcost;
						p[mask1][add] = state;
					}
				}
			}
		}
		int[] min = new int[1 << n];
		int[] whatEat = new int[1 << n];

		for (int mask = 0; mask < 1 << n; mask++) {
			int[] d = dp[mask];
			int best = INF;
			for (int man = 0; man < n; man++) {
				if (d[man] < best) {
					best = d[man];
					whatEat[mask] = state(mask, man, n);
				}
			}
			min[mask] = best;
		}

		int[] minForSubmask = min.clone();
		int[] whatEatForSubmask = whatEat.clone();

		for (int mask = (1 << n) - 1; mask >= 0; --mask) {
			for (int removeBit = 0; removeBit < n; removeBit++) {
				if ((mask & (1 << removeBit)) == 0) {
					continue;
				}
				int mask1 = mask ^ (1 << removeBit);
				if (minForSubmask[mask1] > minForSubmask[mask]) {
					minForSubmask[mask1] = minForSubmask[mask];
					whatEatForSubmask[mask1] = whatEatForSubmask[mask];
				}
			}
		}

		int bestAnswer = INF;
		int whatEatsOne = 0;
		int whatEatsTwo = 0;

		final int ALL = (1 << n) - 1;
		for (int mask = 0; mask < 1 << n; mask++) {
			int curAns = Math.max(min[mask], minForSubmask[ALL ^ mask]);
			if (curAns < bestAnswer) {
				bestAnswer = curAns;
				whatEatsOne = whatEat[mask];
				whatEatsTwo = whatEatForSubmask[ALL ^ mask];
			}
		}

		out.println(bestAnswer);
		List<Integer> mike = getRoute(p, whatEatsOne);
		List<Integer> john = getRoute(p, whatEatsTwo);
		out.print(mike.size() - 1);
		for (int i : mike) {
			out.print(" " + i);
		}
		out.println();
		out.print(john.size() - 1);
		for (int i : john) {
			out.print(" " + i);
		}
		out.println();
	}

	static void relax(int[][] dd, int[][] pp, int[][] graph, int mask) {
		int[] d = dd[mask];
		int[] p = pp[mask];
		int visited = 0;
		int n = d.length;
		while (visited != mask) {
			int best = -1;
			for (int i = 0; i < n; i++) {
				int biti = 1 << i;
				if ((mask & biti) == 0) {
					continue;
				}
				if ((visited & biti) != 0) {
					continue;
				}
				if (best == -1 || d[i] < d[best]) {
					best = i;
				}
			}
			visited |= (1 << best);
			if (d[best] == INF) {
				break;
			}
			int[] g = graph[best];
			for (int i = 0; i < n; i++) {
				if ((mask & (1 << i)) == 0) {
					continue;
				}
				if (g[i] == 0) {
					continue;
				}
				int cost = g[i] + d[best];
				if (d[i] > cost) {
					d[i] = cost;
					p[i] = state(mask, best, n);
				}
			}
		}
	}

	static List<Integer> getRoute(int[][] p, int endState) {
		final int n = p[0].length;
		final int ALL = (1 << n) - 1;
		List<Integer> ans = new ArrayList<Integer>();
		for (int state = endState; state > 0;) {
			int mask = state & ALL;
			int man = state >>> n;
			ans.add(man + 1);
			state = p[mask][man];
		}
		Collections.reverse(ans);
		return ans;
	}

	static int state(int mask, int man, int n) {
		return mask | (man << n);
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("immediate.in"));
		out = new PrintWriter("immediate.out");
		solve();
		out.close();
	}
}
