import static java.util.Arrays.sort;

import java.io.*;
import java.util.StringTokenizer;

public class J {

	static class Card implements Comparable<Card> {
		int a;
		int b;

		public Card(int a, int b) {
			this.a = a;
			this.b = b;
		}

		@Override
		public int compareTo(Card o) {
			if (a != o.a) {
				return a - o.a;
			}
			return b - o.b;
		}

	}

	
	static void solve() throws Exception {
		int n = nextInt();
		Card[] c = new Card[n];
		for (int i = 0; i < n; i++) {
			c[i] = new Card(nextInt(), nextInt());
		}
		sort(c);
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = c[i].b;
		}
		out.println(mergeSort(a, new int[n], 0, n));
	}

	static long mergeSort(int[] a, int[] b, int left, int right) {
		if (left + 1 >= right) {
			return 0;
		}
		int mid = (left + right) >> 1;
		long ret = mergeSort(a, b, left, mid) + mergeSort(a, b, mid, right);
		for (int i = left, j = mid, k = 0; i < mid || j < right; k++) {
			if (j >= right || (i < mid && a[i] <= a[j])) {
				b[k] = a[i++];
			} else {
				ret += mid - i;
				b[k] = a[j++];
			}
		}
		for (int i = 0; i < right - left; i++) {
			a[left + i] = b[i];
		}
		return ret;
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("john.in"));
		out = new PrintWriter("john.out");
		solve();
		out.close();
	}
}
