import static java.lang.Math.abs;
import static java.util.Arrays.fill;

import java.io.*;
import java.util.StringTokenizer;

public class K {

	static void solve() throws Exception {
		n = nextInt();
		Point[] p = new Point[n];
		for (int i = 0; i < n; i++) {
			p[i] = new Point(nextInt(), nextInt());
		}
		long[] whatTriangle = new long[n];
		long[] whatTriangleNext = new long[n];
		long[] bestMin = new long[n];
		long[] bestMinNext = new long[n];
		fill(bestMin, Long.MAX_VALUE);
		long answer = Long.MIN_VALUE;
		long answerCodeLarge = -1;
		long answerCodeSmall = -1;
		for (int length = 2; length < n - 1; length++) {
			for (int left = 0, goodPosition = length; left < n; left++) {
				int right = add(left, length);
				long curArea = area(p[left], p[right], p[goodPosition]);
				long nextArea = area(p[left], p[right], p[add(goodPosition, 1)]);
				while (nextArea > curArea) {
					curArea = nextArea;
					goodPosition = add(goodPosition, 1);
					nextArea = area(p[left], p[right], p[add(goodPosition, 1)]);
				}
				long smallTriangleArea = Long.MAX_VALUE;
				long smallTriangleCode = -1;
				if (bestMin[left] < smallTriangleArea && bestMin[left] > 0) {
					smallTriangleArea = bestMin[left];
					smallTriangleCode = whatTriangle[left];
				}
				if (bestMin[add(left, 1)] < smallTriangleArea
						&& bestMin[add(left, 1)] > 0) {
					smallTriangleArea = bestMin[add(left, 1)];
					smallTriangleCode = whatTriangle[add(left, 1)];
				}
				long small1 = area(p[left], p[right], p[add(left, 1)]);
				if (smallTriangleArea > small1) {
					smallTriangleArea = small1;
					smallTriangleCode = code(left, right, add(left, 1));
				}
				long small2 = area(p[left], p[right], p[add(left, length - 1)]);
				if (smallTriangleArea > small2) {
					smallTriangleArea = small2;
					smallTriangleCode = code(left, right, add(left, length - 1));
				}
				if (smallTriangleArea != 0) {
					if (curArea - smallTriangleArea > answer) {
						answer = curArea - smallTriangleArea;
						answerCodeLarge = code(left, right, goodPosition);
						answerCodeSmall = smallTriangleCode;
					}
				}
				bestMinNext[left] = smallTriangleArea;
				whatTriangleNext[left] = smallTriangleCode;
			}
			{
				long[] t = bestMinNext;
				bestMinNext = bestMin;
				bestMin = t;
			}
			{
				long[] t = whatTriangleNext;
				whatTriangleNext = whatTriangle;
				whatTriangle = t;
			}
		}
		out.println(areaToString(answer));
		out.println(triangleToString(answerCodeLarge));
		out.println(triangleToString(answerCodeSmall));
	}

	static String areaToString(long doubleArea) {
		return doubleArea / 2 + "." + ((doubleArea % 2) * 5);
	}

	static String triangleToString(long triangleCode) {
		int a = (int) (triangleCode >>> 32);
		int b = (int) ((triangleCode >>> 16) & 0xFF);
		int c = (int) (triangleCode & 0xFF);
		return (a + 1) + " " + (b + 1) + " " + (c + 1);
	}

	static int n;

	static long code(int a, int b, int c) {
		return ((long) a << 32) | ((long) b << 16) | c;
	}

	static int add(int a, int add) {
		a += add;
		if (a >= n) {
			a -= n;
		}
		return a;
	}

	static class Point {
		int x, y;

		public Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
	}

	static long area(Point a, Point b, Point c) {
		long x1 = b.x - a.x;
		long y1 = b.y - a.y;
		long x2 = c.x - a.x;
		long y2 = c.y - a.y;
		return abs(x1 * y2 - x2 * y1);
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("kids.in"));
		out = new PrintWriter("kids.out");
		solve();
		out.close();
	}
}
