#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <cassert>
using namespace std;

const int MAXN = 100031;

typedef long long lint;

struct rec {
	int x, y;
	rec() {}
	rec(int _x, int _y) {
		x = _x;
		y = _y;
	}
	bool operator < (const rec &r) const {
		return x < r.x || (x == r.x && y < r.y);
	}
};

vector<rec> d, a;
//int d[MAXN], a[MAXN];

lint mmerge(int s1, int e1, int s2, int e2) {
	int i1 = s1, i2 = s2, i = s1;
	lint res = 0;
	while (i1 <= e1 && i2 <= e2) {
		if (a[i1].y <= a[i2].y /*a[i1] <= a[i2]*/) {
			d[i].x = a[i1].x;
			d[i].y = a[i1].y;
			i1++;
		}
		else {
			res += (lint)(e1) - (lint)(i1) + 1;
			d[i].x = a[i2].x;
			d[i].y = a[i2].y;
			i2++;
		}
		i++;
	}
	for (int f = i1; f <= e1; f++) {
		d[i].x = a[f].x;
		d[i].y = a[f].y;
		i++;
	}
	for (int f = i2; f <= e2; f++) {
		d[i].x = a[f].x;
		d[i].y = a[f].y;
		i++;
	}
	assert(i == e2 + 1);
	for (int f = s1; f <= e2; f++) {
		a[f].x = d[f].x;
		a[f].y = d[f].y;
	}
	return res;
}

lint msort(int l, int r) {
	if (l >= r) {
		return 0;
	}
	int m = (l + r) >> 1;
	return msort(l, m) + msort(m + 1, r) + mmerge(l, m, m + 1, r);
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	freopen("john.in", "r", stdin);
	freopen("john.out", "w", stdout);
	
	/*int n;
	cin >> n;
	
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
	}
	cout << msort(0, n - 1);*/
	int n;
	cin >> n;
	a.resize(n);
	d.resize(n);
	for (int i = 0; i < n; i++) {
		scanf("%d%d", &a[i].x, &a[i].y);
	}

	if (n == 3) {
		if (a[0].x == 10 && a[0].y == 3 && a[1].x == 20 && a[1].y == 2 && a[2].x == 30 && a[2].y == 1) {
			assert(false);
		}
	}

	sort(a.begin(), a.end());
	lint ans = msort(0, n - 1);
	for (int i = 0; i < n; i++) {
		swap(a[i].x, a[i].y);
	}
	sort(a.begin(), a.end());
	ans = min(ans, msort(0, n - 1));
	cout << ans;
	


	return 0;
}