import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {
	private static final String TASKNAME = "black";

	private void solve() throws Exception {
		int m = nextInt();
		int n = nextInt();
		int s = nextInt();
		int k = nextInt();
		
		char[] str = nextToken().toCharArray();
		int[] dp = new int[str.length + 1];
		
		int stars = 0;
		int succ = 0;
		for (int i = str.length - 1; i >= 0; --i) {
			if (str[i] == '*') {
				dp[i] = dp[i + 1] + 1;
				++stars;
			} else {
				dp[i] = 0;
			}
			succ = Math.max(succ, dp[i]);
		}
		
		boolean nonSuc = false;
		for (int i = 0; i < str.length; ++i) {
			if (str[i] == '*') {
				boolean dot = false;
				for (int j = i + 1; j < str.length; ++j) {
					if (str[j] == '.') {
						dot = true;
					}
					if (dot && str[j] == '*') {
						nonSuc = true;
					}
				}
				break;
			}
		}
		
//		System.err.println(stars + " " + succ);
		if ((k == 1 || k == m || s == m || s == 1) && succ == stars && stars == s) {
			println("Unique");
		} else if (stars == 0) {
			if (k - 1 < s && m - k < s) {
				println("Impossible");
			 } else if (k - 1 == s && m - k < s || k - 1 < s && m - k == s) {
				 if (n == s) {
					 println("Unique");
				 } else if (n < s) {
					 println("Impossible");
				 } else {
					 println("Ambiguous");
				 }
			 } else {
				 println("Ambiguous");
			 }
		} else if (stars != s || nonSuc) {
			println("Impossible");
		} else {
			 println("Ambiguous");
		}
	}

	public static void main(String[] args) throws FileNotFoundException {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new B().run();
		System.err.printf("%.3f\n", 1e-3 * (System.currentTimeMillis() - time));
	}

	BufferedReader reader;
	PrintWriter writer;
	StringTokenizer tokenizer;

	String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(reader.readLine());
		}
		return tokenizer.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	void print(Object o) {
		writer.print(o);
	}

	void println(Object o) {
		writer.println(o);
	}

	void printf(String format, Object... o) {
		writer.printf(format, o);
	}

	private void run() {
		try {
			reader = new BufferedReader(new FileReader(TASKNAME + ".in"));
			writer = new PrintWriter(TASKNAME + ".out");

			solve();

			reader.close();
			writer.close();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

}
