import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
	private static final String TASKNAME = "cube";

	ArrayList<String> input = new ArrayList<String>();
	char[] chars = new char[6];
	char[] current = new char[6];

	ArrayList<ArrayList<Integer>> allPerms = new ArrayList<ArrayList<Integer>>();

	ArrayList<Integer> getArray(int[] a) {
		ArrayList<Integer> ans = new ArrayList<Integer>();
		for (int i : a) {
			ans.add(i);
		}
		return ans;
	}

	private void solve() throws Exception {
		getAllperms();
		// System.err.println(allPerms.size());

		HashMap<Character, Integer> map = new HashMap<Character, Integer>();
		for (int i = 0; i < 6; ++i) {
			String s = nextToken();
			char[] a = new char[4];
			for (int j = 1; j < 5; ++j) {
				a[j - 1] = s.charAt(j);
			}
			Arrays.sort(a);
			s = s.charAt(0) + new String(a);
			input.add(s);
			for (char c : s.toCharArray()) {
				Integer value = map.get(c);
				if (value == null) {
					value = 0;
				}
				++value;
				map.put(c, value);
			}
		}
		Collections.sort(input);

		if (map.size() > 6) {
			println("Impossible");
			return;
		}
		int cCount = 0;
		for (char c : map.keySet()) {
			int val = map.get(c);
			if (val % 5 != 0) {
				println("Impossible");
				return;
			}
			for (int i = 0; i < val / 5; ++i) {
				chars[cCount++] = c;
			}
		}

		dfs(0, 0);
		
		if (different.isEmpty()) {
			println("Impossible");
		} else {
			for (int i = 0; i < 2 && i < different.size(); ++i) {
				println(different.get(i));
			}
		}
	}

	private void getAllperms() {
		int[] p = new int[6];
		int[] temp = new int[6];

		for (int i = 0; i < 6; ++i) {
			p[i] = i;
		}

		for (int i = 0; i < 4; ++i) {
			for (int j = 0; j < 4; ++j) {
				for (int k = 0; k < 6; ++k) {
					ArrayList<Integer> list = getArray(p);
					if (!allPerms.contains(list)) {
						allPerms.add(list);
					}
					doPerm(p, temp, permRot);
				}
				doPerm(p, temp, permV);
			}
			doPerm(p, temp, permH);
		}
	}

	private void doPerm(int[] cur, int[] temp, int[] perm) {
		for (int i = 0; i < 6; ++i) {
			temp[i] = cur[perm[i]];
		}
		for (int i = 0; i < 6; ++i) {
			cur[i] = temp[i];
		}
	}

	ArrayList<String> different = new ArrayList<String>();
	HashSet<String> rotations = new HashSet<String>();

	private void dfs(int pos, int mask) {
		if (pos == 6) {
			if (!check()) {
				return;
			}
//			System.err.println("ok");
			String s = new String(current);
			if (rotations.contains(s)) {
				return;
			}
			addRotations();
			different.add(s);
			return;
		}
		for (int i = 0; i < 6; ++i) {
			if ((mask & (1 << i)) == 0) {
				current[pos] = chars[i];
				dfs(pos + 1, mask | (1 << i));
			}
		}
	}

	char[] temp = new char[6];

	private void addRotations() {
		for (ArrayList<Integer> perm : allPerms) {
			for (int i = 0; i < 6; ++i) {
				temp[i] = current[perm.get(i)];
			}
			rotations.add(new String(temp));
		}
	}

	int[] permH = { 0, 4, 1, 2, 3, 5 };
	int[] permV = { 4, 1, 0, 3, 5, 2 };
	int[] permRot = { 2, 0, 1, 5, 3, 4 };
	int[] opposite = { 5, 3, 4, 1, 2, 0 };

	private boolean check() {
		ArrayList<String> array = new ArrayList<String>();
		for (int i = 0; i < 6; ++i) {
			char[] a = new char[4];
			int count = 0;
			for (int j = 0; j < 6; ++j) {
				if (j != i && j != opposite[i]) {
					a[count++] = current[j];
				}
			}
			Arrays.sort(a);
			String s = current[i] + new String(a);
			array.add(s);
		}

		Collections.sort(array);
		for (int i = 0; i < 6; ++i) {
			if (!array.get(i).equals(input.get(i))) {
				return false;
			}
		}
		return true;
	}

	public static void main(String[] args) throws FileNotFoundException {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new Main().run();
		System.err.printf("%.3f\n", 1e-3 * (System.currentTimeMillis() - time));
	}

	BufferedReader reader;
	PrintWriter writer;
	StringTokenizer tokenizer;

	String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(reader.readLine());
		}
		return tokenizer.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	void print(Object o) {
		writer.print(o);
	}

	void println(Object o) {
		writer.println(o);
	}

	void printf(String format, Object... o) {
		writer.printf(format, o);
	}

	private void run() {
		try {
			reader = new BufferedReader(new FileReader(TASKNAME + ".in"));
			writer = new PrintWriter(TASKNAME + ".out");

			solve();

			reader.close();
			writer.close();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

}
