import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
	private static final String TASKNAME = "dice";

	private void solve() throws Exception {
		int n = nextInt();
		final int[] a = new int[n];
		Integer[] inds = new Integer[n];
		int sum = 0;
		
		for (int i = 0; i < n; ++i) {
			a[i] = nextInt();
			sum += a[i];
			inds[i] = i;
		}
		
		int[] l = new int[n];
		int[] r = new int[n];
		
		Arrays.sort(inds, new Comparator<Integer>() {
			@Override
			public int compare(Integer o1, Integer o2) {
				return a[o1] - a[o2];
			}
		});
		
		double avgSum = 0;
		for (int i = 0; i < n; ++i) {
			int ind = inds[i];
			r[ind] = sum;
			l[ind] = sum - a[ind] + 1;
			sum -= a[ind];
			avgSum += (l[ind] + r[ind]) * 0.5;
		}
		printf("%.20f\n", avgSum);
		for (int i = 0; i < n; ++i) {
			for (int j = l[i]; j <= r[i]; ++j) {
				print(j + " ");
			}
			println("");
		}
 	}

	public static void main(String[] args) throws FileNotFoundException {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new Main().run();
		System.err.printf("%.3f\n", 1e-3 * (System.currentTimeMillis() - time));
	}

	BufferedReader reader;
	PrintWriter writer;
	StringTokenizer tokenizer;

	String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(reader.readLine());
		}
		return tokenizer.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	void print(Object o) {
		writer.print(o);
	}

	void println(Object o) {
		writer.println(o);
	}

	void printf(String format, Object... o) {
		writer.printf(format, o);
	}

	private void run() {
		try {
			reader = new BufferedReader(new FileReader(TASKNAME + ".in"));
			writer = new PrintWriter(TASKNAME + ".out");

			solve();

			reader.close();
			writer.close();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

}
