import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
	private static final String TASKNAME = "flat";

	private void solve() throws Exception {
		int n = nextInt();
		int c = nextInt();
		int sum = 0;
		int sumBed = 0;
		int sumBalc = 0;
		
		for (int i = 0; i < n; ++i) {
			int x = nextInt();
			String s = nextToken();
			sum += x;
			if (s.equals("bedroom")) {
				sumBed += x;
			}
			if (s.equals("balcony")) {
				sumBalc += x;
			}
		}
		
		println(sum);
		println(sumBed);
		printf("%.20f\n", 1. * c * (sum - sumBalc * 0.5));
	}

	public static void main(String[] args) throws FileNotFoundException {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new Main().run();
		System.err.printf("%.3f\n", 1e-3 * (System.currentTimeMillis() - time));
	}

	BufferedReader reader;
	PrintWriter writer;
	StringTokenizer tokenizer;

	String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(reader.readLine());
		}
		return tokenizer.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	void print(Object o) {
		writer.print(o);
	}

	void println(Object o) {
		writer.println(o);
	}

	void printf(String format, Object... o) {
		writer.printf(format, o);
	}

	private void run() {
		try {
			reader = new BufferedReader(new FileReader(TASKNAME + ".in"));
			writer = new PrintWriter(TASKNAME + ".out");

			solve();

			reader.close();
			writer.close();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

}
