import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.StringTokenizer;

public class H {
	static BufferedReader in;
	static StringTokenizer st;
	static PrintWriter out;
	static char[][] words;

	static boolean hasMoreTokens() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null)
				return false;
			st = new StringTokenizer(line);
		}
		return true;
	}

	static String nextToken() throws IOException {
		if (!hasMoreTokens()) {
			return null;
		}
		return st.nextToken();
	}

	static String next() throws IOException {
		return nextToken();
	}

	static int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	static final int prime = 1000007;

	static int hash(int w, int ss) {
		int hash = 0;
		for (int i = 0, p = prime; i < 5; i++, p *= prime) {
			if ((ss & (1 << i)) != 0) {
				hash += words[w][i] * p;
			}
		}
		return hash;
	}

	static long[] solve() {
		long[] eq = new long[32];
		long[] sum = new long[6];
		Arrays.fill(sum, 0);
		for (int ss = 0; ss < 32; ss++) {
			HashMap<Integer, Integer> hm = new HashMap<Integer, Integer>();
			long answ = 0;
			for (int i = 0; i < words.length; i++) {
				int cHash = hash(i, ss);
				if (!hm.containsKey(cHash))
					hm.put(cHash, 1);
				else {
					answ += hm.get(cHash);
					hm.put(cHash, hm.get(cHash) + 1);
				}
			}
			eq[ss] = answ;
		}
		for (int ss = 0; ss < 32; ss++) {
			long answ = eq[ss];
			for (int sss = 0; sss < 32; sss++) {
				if (((sss & ss) == ss) && sss != ss) {
					answ -= ((Integer.bitCount(sss) - Integer.bitCount(ss)) % 2 == 0 ? -1
							: 1)
							* eq[sss];
				}
			}
			sum[Integer.bitCount(ss)] += answ;
		}
		return sum;
	}

	public static void main(String[] args) {
		try {
			in = new BufferedReader(new FileReader("high.in"));
			out = new PrintWriter(new File("high.out"));
			long[] sum = new long[6];
			Arrays.fill(sum, 0);
			int n = nextInt();
			words = new char[n][];
			for (int i = 0; i < n; i++) {
				String str = next();
				words[i] = new char[str.length()];
				for (int j = 0; j < str.length(); j++) {
					words[i][j] = str.charAt(j);
				}
			}
			long[] answ = solve();
			for (int i = 0; i <= 5; i++) {
				out.print(answ[5 - i] + " ");
			}
			out.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}
