import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.StringTokenizer;

public class J {
	static BufferedReader in;
	static StringTokenizer st;
	static PrintWriter out;
	static char[][] words;

	static boolean hasMoreTokens() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			if (line == null)
				return false;
			st = new StringTokenizer(line);
		}
		return true;
	}

	static String nextToken() throws IOException {
		if (!hasMoreTokens()) {
			return null;
		}
		return st.nextToken();
	}

	static String next() throws IOException {
		return nextToken();
	}

	static int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	static class Card {
		int r, b;
		Card(int r, int b) {
			this.r = r;
			this.b = b;
		}
	}
	
	static class CmpR implements Comparator<Card> {
		@Override
		public int compare(Card o1, Card o2) {
			return o1.r != o2.r ? o1.r - o2.r : o1.b - o2.b;
		}	
	}
	
	
	static long inverse(Card[] a) {
		if (a.length <= 1) {
			return 0;
		}
		int m = a.length / 2;
		Card[] l = new Card[m];
		Card[] r = new Card[a.length - m];
		for (int i = 0; i < m ;i++) {
			l[i] = a[i];
		}
		for (int i = m; i < a.length; i++) {
			r[i - m] = a[i];
		}
		long inv = inverse(r) + inverse(l);
		int li = 0;
		int ri = 0;
		for (int i = 0; i < a.length; i++) {
			if (li < l.length && (ri >= r.length || r[ri].b >= l[li].b)) {
				a[i] = l[li++];
			} else {
				inv += (l.length - li);
				a[i] = r[ri++];
			}
		}
		return inv;
	}
	
	public static void main(String[] args) {
		try {
			in = new BufferedReader(new FileReader("john.in"));
			out = new PrintWriter(new File("john.out"));
			int n = nextInt();
			Card[] cards = new Card[n];
			for (int i = 0; i < n; i++) {
				int r = nextInt();
				int b = nextInt();
				cards[i] = new Card(r, b);
			}
			Arrays.sort(cards, new CmpR());
			out.println(inverse(cards));
			out.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
}