// Boxes.cc
// ECNA 2012 

#include <iostream>
using namespace std;

#define IFDB if(DEBUG)
#define FOR(i,n) for(int i=0;i<n;i++)

const bool DEBUG=false;
const int MAX=101;

struct BoxWithPos{
  int box, pos;
};

struct Position{
  int w[3],l[3];
};

Position Boxes[MAX];     //holds the dimensions of the boxes
BoxWithPos X[MAX];       //info of boxes in the stack
int n, tallest;

void Swap(int & a, int & b){
  int temp;
  temp=a; a=b; b=temp;
}

bool WillFit(int w1, int l1, int w2, int l2){
//  if(w1<l1) Swap(w1,l1);
//  if(w2<l2) Swap(w2,l2);
  return (w1<=w2 && l1<=l2);
}

bool NotUsed(int k, int j){  //true if box k not in X[0..j-1]
  if(j==0) return true;
  FOR(i,j)
    if(X[i].box == k) return false;       //box k already at pos i
  return true;
}

void PrintBoxes(){
  FOR(i,n) {
    FOR(k,3)
     cout<<Boxes[i].w[k]<<" "<<Boxes[i].l[k]<<" ";
    cout<<endl;
  }
  cout<<"--"<<endl;
}

void PrintStack(int k){  //print boxes on stack
  int thebox, thepos;

  cout<<k<<":  ";
  FOR(i,k){
    thebox = X[i].box; thepos = X[i].pos;
    cout<<thebox<<","<<thepos<<" ("<<Boxes[thebox].w[thepos]<<","<<Boxes[thebox].l[thepos]<<") ";
  }
    thebox = X[k].box; thepos = X[k].pos;
    cout<<thebox<<","<<thepos<<" ("<<Boxes[thebox].w[thepos]<<","<<Boxes[thebox].l[thepos]<<") ";
  cout<<"--"<<endl;
}

void BT(int i){  //find a box to put at X[i], X[1..i-1] already placed
  int LastBox, LastPos;

  LastBox = X[i-1].box;
  LastPos = X[i-1].pos;

  FOR(k,n)     // try each box k at X[i]
    if(NotUsed(k,i)){  //ok to place k on stack @ pos i
      if(i>0){
        FOR(pos,3){      //try all 3 positions of box k
          if(WillFit(Boxes[LastBox].w[LastPos],
                     Boxes[LastBox].l[LastPos],
                     Boxes[k].w[pos],
                     Boxes[k].l[pos]))        //box k will fit on top
          {
            X[i].box=k; X[i].pos=pos;
            if (tallest<i){
               tallest = i;          //new best height
IFDB if (i==n-1) PrintStack(i);
            }
//IFDB PrintStack(i);
            BT(i+1);
          }
        }
      }
      else { //i==0; no need to check if box fits
        FOR(pos,3){
          X[0].box=k; X[0].pos=pos;
          if(tallest<i) tallest=i;
//IFDB PrintStack(i);
          BT(i+1);
        }
      }
    }
}

int main(){
  int a,b,c;
  int caseno=1;

  cin>>n;
  while(n>0){
    FOR(i,n)  {         //get dim of boxes
      cin>>a>>b>>c;
      Boxes[i].w[1]=Boxes[i].w[0]=a;
      Boxes[i].l[0]=Boxes[i].w[2]=b;
      Boxes[i].l[1]=Boxes[i].l[2]=c;
    }
    //now make width < length
    FOR(i,n){
      FOR(j,3){
        if(Boxes[i].w[j]>Boxes[i].l[j])
          Swap(Boxes[i].w[j], Boxes[i].l[j]);
      }
    }
IFDB PrintBoxes();

    tallest = 0;
    BT(0);

    cout<<"Case "<<caseno++<<": "<<tallest+1<<endl;    

    cin>>n;
  }

  return 0;
}

