//ShowMe.cc
//ECNA 2012 - Show Me the Money

#include <iostream>
#include <math.h>
using namespace std;

const bool DEBUG = false;

#define IFDB if (DEBUG)
#define FOR(i,n) for(int i=0; i<n; i++)

int size;
int n;
double rates[50][50]; //rates[i][j] = # i units per j units
string names[50];
int amt;
string den;

void init(){
  size = 0;
  FOR(i,50)
    FOR(j,50)
      rates[i][j] = 0.0;
}

int FindName(string name){
  FOR(i,size)
    if(names[i] == name) return i;
  size++;
  names[size-1] = name;
  return (size-1);
}
void PrintTable(){
  cout<<"rates:"<<endl;
  FOR(i,size){
    FOR(j,size)
      cout<<rates[i][j]<<" ";
    cout<<endl;
  }
  cout<<"--"<<endl;
}

void InsertRates(int i1, int r1, int i2, int r2){
  if (rates[i1][i2]!=0 || rates[i2][i1]!=0) cout<<"already have rate for "<<names[i1]<<" and "<<names[i2]<<endl;
  rates[i1][i2]=r1/(1.0*r2);
  rates[i2][i1]=r2/(1.0*r1);
IFDB cout<<"inserted "<<i1<<" ("<<names[i1]<<"),"<<i2<<" ("<<names[i2]<<")"<<endl;
}

void FillInTable(){
  bool nochange;
  nochange = true;
  while(nochange){
    nochange = true;
    FOR(i,size){
      FOR(j,size)    //scan row i
        if(i!=j && rates[i][j]!=0)
          FOR(k,size) //scan row k for new rates to add
            if(rates[i][k]==0 && rates[j][k]!=0){
              rates[i][k] = rates[i][j]*rates[j][k];
              rates[k][i] = 1.0/rates[i][k];
              nochange = false;
            }
    }
  }
}

int main(){
  string n1, n2, eq;
  int r1, r2;
  int i1, i2;
  int caseno=1;
  double bestratio;
  int  bestnumber, bestdenom, m;

  cin>>n;
  while (n>0){
    init();
    //get rates
    FOR(i,n){
      cin>>r1>>n1>>eq>>r2>>n2;
      i1 = FindName(n1);
      i2 = FindName(n2);
      InsertRates(i1,r1,i2,r2);
    }
//IFDB PrintTable();
    FillInTable();
IFDB PrintTable();

    //get inquiry
    cin>>amt>>den;
    i1 = FindName(den);

    //find best exchange
    bestratio = 1000000.0;
    bestnumber = 0;
    bestdenom = -1;

    //find best j for amt of i1
    FOR(j,size)
      if(j != i1){
        if(rates[i1][j]>0.0){
          m = ceil(amt * rates[j][i1] - 0.0000001);
IFDB cout<<endl<<j<<" "<<rates[i1][j]<<" "<<m<<" "<<m*rates[i1][j]<<endl;
          if (m<=100000){
            if(m*rates[i1][j] < bestratio){
              bestratio = m*rates[i1][j];
              bestnumber = m;
              bestdenom = j;
            }
          }
        }
      }
    
    if (bestratio < 1000000.0){
      cout<<"Case "<<caseno<<": "<<bestnumber<<" "<< names[bestdenom]<<endl;
    }
    else {
      cout<<" error -- no value"<<endl;
    }

    caseno++; 
    cin>>n;
  }
  return 0;
}
